# pymoog

[![DOI](https://zenodo.org/badge/10543633.svg)](https://zenodo.org/badge/latestdoi/10543633) [![Documentation Status](https://readthedocs.org/projects/pymoog/badge/?version=latest)](https://pymoog.readthedocs.io/en/latest/?badge=latest)

`pymoog` is a python3 wrapper for running the LTE spectrum synthesis part of the code [MOOG](https://www.as.utexas.edu/~chris/moog.html) written by Chris Sneden.
It wraps up the (a bit) teidous steps for generating a synthetic spectra into four python commands, while retaining the functions provided by MOOG.
Besides, it also provides some other functions for analysing the MOOG result, mainly contribution function and fitting stellar parameters.

Here you can:
- generate a synthetic spectra
- alter the stellar parameters for the spectra, such as $T_\mathrm{eff}$, metallicity, abundance ratios or resolution.
- determine some stellar parameters, such as microturbulance velocity or abundance ratios.

without considering:
- where to grab stellar atmosphere models and line lists
- how to interpolate the models.

Documentation (including the installation) is available in [here](https://pymoog.readthedocs.io/en/latest/).

## Acknowledgement

This package has made use of the VALD database, operated at Uppsala University, the Institute of Astronomy RAS in Moscow, and the University of Vienna.

# moog_nosm
MOOG without the dependent of SM.

[MOOG](http://www.as.utexas.edu/~chris/moog.html) is a software of generating synthestic spectra and fitting it with observed spectra to get abundances from stellar model and line list. It is written by Chris Sneden.

Original MOOG is related to plotting software [SM](http://www.astro.princeton.edu/~rhl/sm/), which is (maybe) hard to install and call by MOOG. The MOOG in this repository is undependent on SM, so the command MOOG and MOOGSILENT is basically the same.

Beside this some lines are also modified:

- Pi value inside Smooth.f is changed to 3.1415927.
- Some judgement is added to make makefile of MOOGSILENT run normally.
- Input and output format of pixel value of synthetic spectrum inside Binplotprep.f, Smooth.f, Synpop.f, Synspec.f and Vargauss.f is change to f8.4, adding a space between numbers when they are small than 0.
- The output format of Lineinfo.f are modified to output the opacities when `atmosphere` and `lines` are set to 2 and 4.

The modified MOOG of versions NOV2019 and FEB2017 are provided, and their installation methods are identical.

## Install

Here the install method of version NOV2019 are present as example. For the installation of version NOV2019, change `FEB2017` to `NOV2019`.

1. Clone or download the respository.
2. Enter the MOOG folder by `cd PATH_TO_REPO/moog_nosm_NOV2019`.
3. Run the bash file `./install.sh` or `bash ./install.sh` 
4. There will be a prompt asking which kind of machine the installation is on; choose either `Linux` (or simply hit Enter) or `Mac`. I test it in Ubuntu but not for Mac so please be cautious.
5. Then installation should go by itself.
6. If you see some prompt of `make sure that you have entered the proper parameters for MOOG into the FORTRAN source driver routine Moog.f !!!!!!!!!!!!` then you should see a `MOOG` and `MOOGSILENT` file present in the current folder.
7. Done.

## Warnings

Some warnings appear during the make command.
Most of them are no-harm, such as:
- `Warning: Line truncated at (1) [-Wline-truncation]` and
- `Warning: Possible change of value in conversion from REAL(8) to INTEGER(4) at (1) [-Wconversion]`.

They are intended and tried to get rid of some of those.

However there are two may worth a slight change:
- `Warning: ‘ikount’ may be used uninitialized in this function [-Wmaybe-uninitialized]` in `Molquery.f`
- `Warning: Rank mismatch in argument ‘xnew’ at (1) (rank-1 and scalar) [-Wargument-mismatch]` in `OpacHydrogen.f`

I leave them as in the initial code.

      subroutine abunplot
c******************************************************************************
c     This routine produces MONGO plots of line abundances versus
c     excitation potentials and equivalent widths
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Dummy.com'
      real*4 ep(2500),abb(2500),logrw(2500),wavepl(2500)
      equivalence (ep,dummy3(1)),(abb,dummy3(1251)),(logrw,dummy3(2501))
      real*4 style(1),ymed
      character ion*4


c*****dump the data into working arrays
      j = 0
      do l=lim1obs,lim2obs
         if (abundout(l) .ne. 999.99) then
            j = j + 1
            ep(j) = e(l,1)
            abb(j) = abundout(l)
c           logrw(j) = dlog10(wid1comp(l)/wave1(l))
            logrw(j) = dlog10(width(l)/wave1(l))
            wavepl(j) = wave1(l)
         endif
      enddo


c*****find the plot boundaries for the excitation potential plot
      xlo = 20.
      do j=1,kount
         xlo = amin1(xlo,ep(j))
      enddo
      xhi =  0.
      do j=1,kount
         xhi = amax1(xhi,ep(j))
      enddo
      if (xhi-xlo .lt. 5.) then
         xlo = amax1((xlo+xhi)/2.-2.5,-0.2)
         xhi = xlo + 5.0
      else
         xlo = amax1((xlo+xhi)/2.-5.0,-0.2)
         xhi = xlo + 10.
      endif
      ylo = 20.
      do j=1,kount
         ylo = amin1(ylo,abb(j))
      enddo
      yhi = -20.
      do j=1,kount
         yhi = amax1(yhi,abb(j))
      enddo
      if (yhi-ylo .lt. 0.5) then
         ylo = (ylo+yhi)/2. - 0.30
         yhi = ylo + 0.60
      elseif (yhi-ylo .lt. 1.0) then
         ylo = (ylo+yhi)/2. - 0.55
         yhi = ylo + 1.10
      else
         ylo = (ylo+yhi)/2. - 1.10
         yhi = ylo + 2.20
      endif


c*****start the excitation potential plot via plot setup calls
      call sm_defvar ('y_gutter','0.9')
      call sm_window (1,3,1,3,1,3)
      call sm_limits (xlo,xhi,ylo,yhi)
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)


c*****draw and label the box for the excitation potential plot
      call defcolor (1)
      call sm_lweight (4.0)
      call sm_expand (1.2)
      call sm_box (0,0,0,0)
      call sm_lweight (2.0)
      call sm_expand (0.8)
      call sm_box (1,2,4,4)
      array = 'E. P. (eV)'
      call sm_relocate (0.5*(xlo+xhi),ylo-0.20*(yhi-ylo))
      call sm_putlabel (5,array)
      array = 'log eps'
      call sm_relocate (xlo-0.10*(xhi-xlo),0.5*(yhi+ylo))
      call sm_angle (90.)
      call sm_putlabel (5,array)
      call sm_angle (0.)
      

c*****make the excitation potential plot
      call defcolor (2)
      call sm_expand (2.2)
      style(1) = 43.5
      call sm_ptype (style,1) 
      call sm_points (ep,abb,kount)
      call defcolor (4)
      ymed = average
      call sm_lweight (4.0)
      call sm_ltype (2)
      call sm_relocate (xlo,ymed)
      call sm_draw (xhi,ymed)
      if (kount .gt. 2 .and. deltaep .gt. 1.5) then
         call sm_ltype (3)
         call defcolor (3)
         call sm_relocate (xlo,real(xxm1*xlo+xxb1)) 
         call sm_draw (xhi,real(xxm1*xhi+xxb1)) 
      endif
      call sm_ltype (0)
      call sm_lweight (2.0)
      call defcolor (1)
      call sm_relocate (xlo+0.05*(xhi-xlo),ylo+0.15*(yhi-ylo))
      call sm_expand (0.8)
      ich = idint(charge(lim1obs) + 0.1)
      if (ich .eq. 1) then 
         ion = ' I  '
      elseif (ich .eq. 2) then
         ion = ' II '
      elseif (ich .eq. 3) then
         ion = ' III'
      endif
      iatom = idint(atom1(lim1obs))
      write (array,1002) names(iatom),ion
      call sm_relocate ((xhi+xlo)/2.,yhi-0.12*(yhi-ylo))
      call sm_expand (0.8)
      call sm_putlabel (5,array)
   

c*****define the plot limits for the equivalent width plot
      xlo = 5000.
      do j=1,kount
         xlo = amin1(xlo,logrw(j))
      enddo
      xhi =  -5000.
      do j=1,kount
         xhi = amax1(xhi,logrw(j))
      enddo
      xlo = int((xlo-0.01)*2.-1.)/2.
      xhi = int((xhi+0.01)*2.)/2.
      call sm_defvar ('y_gutter','0.9')
      call sm_window (1,3,1,2,1,2)
      call sm_limits (xlo,xhi,ylo,yhi)
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)


c*****draw and label the box for the equivalent width plot
      call defcolor (1)
      call sm_lweight (4.0)
      call sm_expand (1.2)
      call sm_box (0,0,0,0)
      call sm_lweight (2.0)
      call sm_expand (0.8)
      call sm_box (1,2,4,4)
      array = 'log (EW/lambda)'
      call sm_relocate (0.5*(xlo+xhi),ylo-0.20*(yhi-ylo))
      call sm_putlabel (5,array)
      array = 'log eps'
      call sm_relocate (xlo-0.10*(xhi-xlo),0.5*(yhi+ylo))
      call sm_angle (90.)
      call sm_putlabel (5,array)
      call sm_angle (0.)


c*****make the equivalent width plot
      call defcolor (2)
      call sm_expand (2.2)
      style(1) = 43.5
      call sm_ptype (style,1)
      call sm_points (logrw,abb,kount)
      call defcolor (4)
      call sm_lweight (4.0)
      call sm_ltype (2)
      call sm_relocate (xlo,ymed)
      call sm_draw (xhi,ymed)
      if (kount .gt. 2 .and. deltarw .gt. 0.5) then
         call sm_ltype (3)
         call defcolor (3)
         call sm_relocate (xlo,real(xxm2*xlo+xxb2)) 
         call sm_draw (xhi,real(xxm2*xhi+xxb2)) 
      endif
      call sm_ltype (0)
      call sm_lweight (2.0)
      call defcolor (1)
      call sm_expand (0.8)
      call sm_relocate ((xhi+xlo)/2.,yhi-0.12*(yhi-ylo))
      call sm_putlabel (5,moditle(1:56))
      call sm_relocate ((xhi+xlo)/2.,ylo+0.12*(yhi-ylo))
      call sm_putlabel (5,moditle(57:80))


c*****define the plot limits for the wavelength plot
      xlo = 5000000.
      do j=1,kount
         xlo = amin1(xlo,wavepl(j))
      enddo
      xhi = 0.
      do j=1,kount
         xhi = amax1(xhi,wavepl(j))
      enddo
      xlo = int(xlo-50.)
      xhi = int(xhi+50.)
      call sm_defvar ('y_gutter','0.9')
      call sm_window (1,3,1,1,1,1)
      call sm_limits (xlo,xhi,ylo,yhi)
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)


c*****draw and label the box for the wavelength plot
      call defcolor (1)
      call sm_lweight (4.0)
      call sm_expand (1.2)
      call sm_box (0,0,0,0)
      call sm_lweight (2.0)
      call sm_expand (0.8)
      call sm_box (1,2,4,4)
      array = 'lambda (A)'
      call sm_relocate (0.5*(xlo+xhi),ylo-0.20*(yhi-ylo))
      call sm_putlabel (5,array)
      array = 'log eps' 
      call sm_relocate (xlo-0.10*(xhi-xlo),0.5*(yhi+ylo)) 
      call sm_angle (90.) 
      call sm_putlabel (5,array) 
      call sm_angle (0.) 


c*****make the wavelength plot, and exit normally
      call defcolor (2)
      call sm_expand (2.2)
      style(1) = 43.5 
      call sm_ptype (style,1)
      call sm_points (wavepl,abb,kount)
      call defcolor (4)
      call sm_relocate (xlo,ymed)
      call sm_lweight (4.0)
      call sm_ltype (2)
      call sm_draw (xhi,ymed)
      if (kount .gt. 2 .and. deltawv .gt. 500.) then
         call sm_ltype (3)
         call defcolor (3)
         call sm_relocate (xlo,real(xxm3*xlo+xxb3))
         call sm_draw (xhi,real(xxm3*xhi+xxb3))
      endif
      call sm_ltype (0)  
      call sm_lweight (2.0)
      call defcolor (1)
      call sm_relocate ((xhi+xlo)/2.,yhi-0.12*(yhi-ylo))
      call sm_expand (0.8)
      call sm_putlabel (5,linitle)
      return


c*****format statements
1002  format (a2,a4)


      end

      program moog
c******************************************************************************
c     This is the main driver for MOOG.  It reads the parameter
c     file and sends MOOG to various controlling subroutines.
c     This is the normal interactive version of the code; for batch
c     processing without user decisions, run MOOGSILENT instead.
c******************************************************************************

      include 'Atmos.com'
      include 'Pstuff.com'
      character yesno*1


c$$$$$$$$$$$$$$$$$$$$$$$$ USER SETUP AREA $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c*****in compiling MOOG, here the various machine-specific things are 
c     declared.  First, define the directory where MOOG lives, in order to 
c     be able to pull in auxiliary data files; executing 'make' will 
c     generate a reminder of this necessity
      write (moogpath,1001)
      moogpath = 
     .  '/home/mingjie/software/MOOG'


c*****What kind of machine are you using?  Possible ones are:
c     "mac" = Intel-based Apple Mac 
c     "pcl" = a PC or desktop running some standard linux like Redhat
c     "uni" = a machine running Unix, specifically Sun Solaris
      machine = "pcl"


c*****for x11 terminal types, define the parameters of plotting windows;
c     set up an x11 screen geometry and placement that is good for spectrum
c     syntheses (long, but not tall); the user should play with the format
c     statements for particular machines.
      write (smt1,1018)
c     now do the same for line abundance trend plots (short but tall).
      write (smt2,1017)
c$$$$$$$$$$$$$$$$$$$$$$$ END OF USER SETUP $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$


c*****declare this to be the normal interactive version; variable "silent"
c     will be queried on all occasions that might call for user input;
c     DON'T CHANGE THIS VARIABLE; 
c     if silent = 'n', the normal interactive MOOG is run;
c     if silent = 'y', the non-interactive MOOG is run
      silent = 'n'


c*****invoke the overall starting routine
1     control = '       '
      call begin


c*****use one of the standard driver routines ("isotop" is obsolete):
      if     (control .eq. 'synplot') then
         call plotit
      elseif (control .eq. 'synth  ') then
         call synth
      elseif (control .eq. 'cogsyn ') then
         call cogsyn  
      elseif (control .eq. 'blends ') then
         call blends  
      elseif (control .eq. 'abfind ') then
         call abfind
      elseif (control .eq. 'ewfind ') then
         call ewfind
      elseif (control .eq. 'cog    ') then
         call cog
      elseif (control .eq. 'calmod ') then
         call calmod
      elseif (control .eq. 'doflux ') then
         call doflux   
      elseif (control .eq. 'weedout') then
         call weedout  
      elseif (control .eq. 'gridsyn') then
         call gridsyn  
      elseif (control .eq. 'gridplo') then
         call gridplo  
      elseif (control .eq. 'binary ') then
         call binary
      elseif (control .eq. 'abpop  ') then
         call abpop
      elseif (control .eq. 'synpop ') then
         call synpop


c*****or, put in your own drivers in the form below....
      elseif (control .eq. 'mine  ') then
         call  mydriver 


c*****or else you are out of luck!
      else
         array = 'THIS IS NOT ONE OF THE DRIVERS.  TRY AGAIN (y/n)?'
         istat = ivwrite (4,3,array,49)
         istat = ivmove (3,1)
         read (*,*) yesno
         if (yesno .eq. 'y') then
            go to 1
         else
            call finish (0)
         endif
      endif


c*****format statements
1001  format (60(' '))
1002  format ('The "isotop" driver is obsolete; "synth" does ',
     .        'its functions now!')
1003  format (22x,'MOOG IS CONTROLLED BY DRIVER ',a7)
1017  format ('x11 -bg black -title MOOGplot -geom 700x800+650+000')
1018  format ('x11 -bg black -title MOOGplot -geom 1200x350+20+450')


      end


      

      subroutine taukap
c******************************************************************************
c     This routine calculates the line absorption coefficient and the line  
c     opacity at wavelength *wave* for all lines in the spectrum            
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'


c*****compute the total line opacity at each depth                          
      do i=1,ntau     
         kapnu(i) = 0.0
         do j=lim1,lim2
            v = 2.997929d10*dabs(wave-wave1(j))/
     .             (wave1(j)*dopp(j,i))            
            kapnu(i) = kapnu(i) + kapnu0(j,i)*voigt(a(j,i),v)
         enddo                                     

         dummy1(i) = tauref(i)*kapnu(i)/(0.4343*kapref(i))
                                                       
c*****do the same for the strong lines
         if (dostrong .gt. 0) then
            do j=nlines+1,nlines+nstrong
               v = 2.997929d10*dabs(wave-wave1(j))/
     .             (wave1(j)*dopp(j,i)) 
               kapnu(i) = kapnu(i) + kapnu0(j,i)*voigt(a(j,i),v)    
            enddo
         endif

         dummy1(i) = tauref(i)*kapnu(i)/(0.4343*kapref(i))
      enddo      

c*****compute the optical depths                                            
      first = tauref(1)*kapnu(1)/kapref(1)
      dummy1(1) = rinteg(xref,dummy1,taunu,ntau,0.)      
      taunu(1) = first
      do i=2,ntau                                                     
         taunu(i) = taunu(i-1) + taunu(i)                  
      enddo


      return                                              
      end                                                

      real*8 function partnew (atom,k,level)
c******************************************************************************
c     This routine computes partition functions for those species that have
c     been updated from those that are in ATLAS9.  The polynomial 
c     representations are in the form used by Irwin (1981, ApJS, 45, 621):
c            log10(U) = SUM{C_j*log10(T)**(j-1)}    for j = 1-->6
c     where T = temperature and C_j are the six polynomial coefficients.
c     Information on the updated partition functions are given by
c     Lawler & Sneden (2002, in preparation).  This routine will be 
c     increasingly invoked as new new data are added to the *newpartdata*
c     array,  until a full replacement for the older partition functions
c     is implemented.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Quants.com'


      iatom = nint(atom)
      iarray = partflag(iatom,k)

      if (level .gt. 500) then
         temp = dlog(dble(level))
      else
         temp = tlog(level)
      endif

      ulog = 0.
      do j=1,6
         ulog = ulog + newpartdata(iarray,j)*temp**(j-1)
      enddo
      partnew = dexp(ulog)

      return
      end                                  

      subroutine gridsyn
c******************************************************************************
c     This program can synthesize multiple sections of spectra for multiple
c     input model atmospheres
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Linex.com'
      include 'Pstuff.com'


c*****examine the parameter file
1     call params
      linprintopt = linprintalt


c*****open the files for: standard output, raw spectrum depths, smoothed 
c     spectra, and (if desired) IRAF-style smoothed spectra
      nf1out = 20     
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21               
      lscreen = lscreen + 2
      array = 'RAW SYNTHESIS OUTPUT'
      nchars = 20
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)
      if (plotopt .gt. 0) then
         nf3out = 22               
         lscreen = lscreen + 2
         array = 'SMOOTHED SYNTHESES OUTPUT'
         nchars = 25
         call infile ('output ',nf3out,'formatted  ',0,nchars,
     .                f3out,lscreen)
         nf5out = 26
         lscreen = lscreen + 2
         array = 'POSTSCRIPT PLOT OUTPUT'
         nchars = 22
         call infile ('output ',nf5out,'formatted  ',0,nchars,
     .                f5out,lscreen)
      endif
      if (plotopt .gt. 1) then
         nf6out = 27
         lscreen = lscreen + 2
         array = 'SPECTRUM COMPARISON OUTPUT'
         nchars = 27
         call infile ('output ',nf6out,'formatted  ',0,nchars,
     .                f6out,lscreen)
      endif
      if (iraf .ne. 0) then
         nf4out = 23               
         lscreen = lscreen + 2
         array = 'IRAF ("rtext") OUTPUT'
         nchars = 24
         call infile ('output ',nf4out,'formatted  ',0,nchars,
     .                f4out,lscreen)
      endif


c*****open and read the model atmosphere file
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****open the line list file and the strong line list file
      nflines = 31
      lscreen = lscreen + 2
      array = 'THE LINE LIST'
      nchars = 13
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .              flines,lscreen)
      if (dostrong .gt. 0) then
         nfslines = 32
         lscreen = lscreen + 2
         array = 'THE STRONG LINE LIST'
         nchars = 20
         call infile ('input  ',nfslines,'formatted  ',0,nchars,
     .                 fslines,lscreen)
      endif
      

c*****do the syntheses
      if (numpecatom .eq. 0 .or. numatomsyn .eq. 0) then
         isorun = 1
         isynth = 1
         nlines = 0
         mode = 3
         call inlines (1)
         call eqlib
         call nearly (1)
         call synspec
      else
         do n=1,numatomsyn
            isynth = n
            isorun = n
            start = oldstart
            sstop = oldstop
            mode = 3
            call inlines (1)
            molopt = 2
            call eqlib
            call nearly (1)
            call synspec
            linprintopt = 0
         enddo
      endif
         

c*****now plot the spectrum
      if (plotopt.eq.2 .and. specfileopt.gt.0) then
         nfobs = 33               
         lscreen = lscreen + 2
         array = 'THE OBSERVED SPECTRUM'
         nchars = 21
         if (plotopt.eq.1 .or. specfileopt.eq.3) then
            call infile ('input  ',nfobs,'unformatted',2880,nchars,
     .                   fobs,lscreen)
         else
            call infile ('input  ',nfobs,'formatted  ',0,nchars,
     .                   fobs,lscreen)
         endif
      endif
      if (plotopt .ne. 0) then
         ncall = 1
         call pltspec (lscreen,ncall)
      endif


c*****finish
      if (control .ne. 'gridend') then
         call finish (1)
         go to 1
      else
         call finish (0)
      endif
      return

      end 

      subroutine doflux
c******************************************************************************
c     This routine produces flux curves
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'
      include 'Pstuff.com'


c*****examine the parameter file
      call params

c*****open the files for standard output and summary curves-of-growth
      nf1out = 20
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21
      lscreen = 6
      array = 'SUMMARY FLUX OUTPUT'
      nchars = 19
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)
      nf5out = 26
      lscreen = lscreen + 2
      array = 'POSTSCRIPT PLOT OUTPUT'
      nchars = 22
      call infile ('output ',nf5out,'formatted  ',0,nchars,
     .             f5out,lscreen)


c*****open and read the model atmosphere
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****compute the flux curve
      wave = start
1     call opacit (2,wave)
      if (modprintopt .ge. 2) 
     .    write(nf1out,1002) wave,(kaplam(i),i=1,ntau)
      call cdcalc (1)
      first = 0.4343*cd(1)
      flux = rinteg(xref,cd,dummy1,ntau,first)
      if (flux .le. 0.1) flux = 0.
      if (iunits .eq. 1) then
         write (nf1out,1003) 1.d-4*wave,flux
      else
         write (nf1out,1004) wave,flux
      endif
      waveinv = 1.0d4/wave
      if (flux .gt. 0.) then
         fluxlog = dlog10(flux)
      else
         fluxlog = -1.0
      endif
      write (nf2out,1001) wave, flux, waveinv, fluxlog
      wave = wave + step
      if (wave .le. sstop) go to 1
      call pltflux


c****end the computations
      call finish (0)
      return


c*****format statements
1001  format (1p2d12.4,0p2f10.4)
1002  format ('  kaplam from 1 to ntau at wavelength',f11.3/
     1        (6(1pd12.4)))
1003  format ('AT WAVELENGTH/FREQUENCY =',f11.7,
     .        '  CONTINUUM FLUX/INTENSITY =', 1pd12.5)
1004  format ('AT WAVELENGTH/FREQUENCY =',f11.3,
     .        '  CONTINUUM FLUX/INTENSITY =', 1pd12.5)


      end                                                               

      subroutine ewfind
c******************************************************************************
c     This routine predicts equivalent widths for individual atomic lines
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'
      include 'Dummy.com'
      real*8 taunu0(100)
      character*4 ion(3)
      data ion/' I  ', ' II ', ' III'/

c*****read the parameter file
      call params

c*****open the files for standard output and summary curves-of-growth
      nf1out = 20
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21
      lscreen = lscreen + 2
      array = 'SUMMARY PREDICTED EW OUTPUT'
      nchars = 27
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)


c*****open and read the model atmosphere
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****open and read the line list file; get ready for the line calculations
      nflines = 31
      lscreen = lscreen + 2
      array = 'THE LINE LIST'
      nchars = 13
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .              flines,lscreen)
      call inlines (1)
      call eqlib
      call nearly (1)

 
c*****set some parameters and write header stuff to output
      ewsynthopt = +1
      mode = 1
      call linlimit
      lim1obs = lim1line
      lim2obs = lim2line
      istat = ivcleof (4,1)
      write (nf2out,1002) linitle,moditle


c*****run single line computations once to predict the EW for each line
      do lim1=lim1line,lim2line
         array(1:40) = 'wavelength        EP     logGF     ident'
         array(41:60) = '     Abund    EWcalc'
         lscreen = lscreen + 2
c        call prinfo (lscreen)
         write (nf2out,1001)
         ncurve = lim1
         lim2 = lim1
         gf1(ncurve) = gf(lim1)
         call oneline (1)
         widout(lim1) = w(ncurve)
         iatom = atom1(lim1)
         xab = dlog10(xabund(iatom)) + 12.
         ich = idint(charge(lim1) + 0.1)
         if (iatom .lt. 100) then
            write (array,1003) wave1(lim1), e(lim1,1), 
     .                         dlog10(gf(lim1)), names(iatom), 
     .                         ion(ich), xab, 1000.*widout(lim1)
            lscreen = lscreen + 2
c           call prinfo (lscreen)
            write (nf2out,1003) wave1(lim1), e(lim1,1), 
     .                          dlog10(gf(lim1)), names(iatom), 
     .                          ion(ich) ,xab, 1000.*widout(lim1)
         else
            write (array,1004) wave1(lim1), e(lim1,1), 
     .                         dlog10(gf(lim1)), atom1(lim1), 
     .                         xab, 1000.*widout(lim1)
            lscreen = lscreen + 2
c           call prinfo (lscreen)
            write (nf2out,1004) wave1(lim1), e(lim1,1), 
     .                          dlog10(gf(lim1)), atom1(lim1), 
     .                          xab, 1000.*widout(lim1)
         endif


c*****(re)compute the line optical depth at line center and the C_d curve
         do i=1,ntau
            kapnu(i) = kapnu0(lim1,i)
            dummy1(i) = tauref(i)*kapnu(i)/(0.4343*kapref(i))
         enddo
         first = tauref(1)*kapnu(1)/kapref(1)
         dummy2(1) = rinteg(xref,dummy1,taunu0,ntau,0.)
         taunu0(1) = first
         do i=1,ntau
            taunu(i) = taunu0(i)
         enddo
         call cdcalc (2)
         do i=2,ntau
            taunu0(i) = taunu0(i-1) + taunu0(i)
         enddo
         write (nf2out,1010) 
         write (nf2out,1011) (i, rhox(i), xref(i), int(t(i)), 
     .                        pgas(i), rho(i), xdepth(i), taulam(i), 
     .                        taunu0(i), cd(i), i=1,ntau)


c*****compute layer where continuum optical depth > 1
         do i=1,ntau
            if (taulam(i) .ge. 1.) then
               xdepthlam1 = xdepth(i-1) + (1.-taulam(i-1))*
     .                (xdepth(i)-xdepth(i-1))/(taulam(i)-taulam(i-1))
               write (nf2out,1013) int(xdepthlam1), i
               go to 10
            endif
         enddo


c     compute layer where line center optical depth > 1
10          if (taunu0(ntau) .lt. 1.) then
               write (nf2out,1016)
               go to 20
            endif
            do i=1,ntau
            if (taunu0(i) .ge. 1.) then
               xdepthnu01 = xdepth(i-1) + (1.-taunu0(i-1))*
     .                (xdepth(i)-xdepth(i-1))/(taunu0(i)-taunu0(i-1))
               write (nf2out,1014) int(xdepthnu01), i
               go to 20
            endif
         enddo


c     compute layer where line center plus continuum optical depth > 1
20       do i=1,ntau
            if (taunu0(i)+taulam(i) .ge. 1.) then
               tautot1 = taulam(i-1) + taunu0(i-1)
               tautot2 = taulam(i) + taunu0(i)
               xdepthtot1 = xdepth(i-1) + (1.-tautot1)*
     .                (xdepth(i)-xdepth(i-1))/(tautot2-tautot1)
               write (nf2out,1015) int(xdepthtot1), i
               go to 30
            endif
         enddo


*****compute mean line-center formation level (weight: contribution function)
30       do i=1,ntau
            dummy1(i) = xref(i)*dabs(cd(i))
         enddo
         xrefcdinteg = rinteg(xref,dummy1,dummy2,ntau,0.)
         do i=1,ntau
            dummy1(i) = dabs(cd(i))
         enddo
         cdinteg = rinteg(xref,dummy1,dummy2,ntau,0.)
         xrefmean = xrefcdinteg/cdinteg
         do i=1,ntau
            if (xrefmean .le. xref(i)) then
               xdepthxrefmean = xdepth(i-1) + (xrefmean-xref(i-1))* 
     .                (xdepth(i)-xdepth(i-1))/(xref(i)-xref(i-1))
               write (nf2out,1017) int(xdepthxrefmean), i, tauref(i),
     .                             taulam(i)
               go to 40
            endif
         enddo
40       continue
      enddo


c*****end the abundance computations
      call finish (0)
      return


c*****format statements
1001  format (/'wavelength        EP     logGF     ident',
     .        '     Abund    EWcalc')
1002  format (a80)
1003  format (f10.2,f10.2,f10.3,'     ',a2,a3,f10.2,f10.1)
1004  format (f10.2,f10.2,f10.3,a10,f10.2,f10.1)
1010     format ('  i', 2x, 'rhox', 5x, 'xref', 5x, 'T', 5x, 'Pgas', 
     .           6x, 'rho', 8x, 'X', 3x, 'taulam', 3x, 'taunu0',
     .           8x, 'Cd')
1011  format (i3, 1pe9.2, 0pf6.2, i6, 1p5e9.2, e10.2)
1013           format (i7, 'km (layer ~', i3, ') = physical depth',
     .                 ' for tau(cont) ~ 1')
1014           format (i7, 'km (layer ~', i3, ') = physical depth',
     .                 ' for tau(line center) ~ 1')
1015           format (i7, 'km (layer ~', i3, ') = physical depth',
     .                 ' for tau(cont)+tau(line center) ~ 1')
1016           format (7x,'  NOTE: tau(line center) < 1 at deepest',
     .                 ' atmosphere layer')
1017           format (i7, 'km (layer ~', i3, ') = line center ',
     .                 'formation mean depth; C_d weight'/
     .                 25x, 'where tauref, taulam =', 2f8.3)

      end

      subroutine getsyns (lscreen,ncall)
c******************************************************************************
c     This routine commands the syntheses to be done (or resyntheses if 
c     abundances or isotopic ratios are changed)
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Factor.com'
      include 'Dummy.com'


c*****if the syntheses need to be redone: first rewind the output files,
c     then close/reopen line list(s), then rewrite model atmosphere output
      if (choice .eq. 'n') then
         call chabund
         if (choice .eq. 'x') call pltspec (lscreen,ncall)
         rewind nf1out
         rewind nf2out
         if (nflines .ne. 0) then
            close (unit=nflines)
            open (unit=nflines,file=flines,access='sequential',
     .            form='formatted',blank='null',status='old',
     .            iostat=jstat,err=10)
         endif
         if (nfslines .ne. 0) then
            close (unit=nfslines)
            open (unit=nfslines,file=fslines,access='sequential',
     .            form='formatted',blank='null',status='old',
     .            iostat=jstat,err=10)
         endif
         if (plotopt .ne. 0) then
            rewind nf3out
         endif
         write (nf1out,1002) modtype
         if (modprintopt .ge. 1) then
            if (modtype .eq. 'begn      ' .or.
     .          modtype .eq. 'BEGN      ') write (nf1out,1003)
            write (nf1out,1102) moditle
            do i=1,ntau
               dummy1(i) = dlog10(pgas(i))
               dummy2(i) = dlog10(ne(i)*1.38054d-16*t(i))
            enddo
            write (nf1out,1103) wavref,(i,xref(i),tauref(i),t(i),
     .                          dummy1(i), pgas(i),dummy2(i),ne(i),
     .                          vturb(i),i=1,ntau)
            write (nf1out,1104)
            do i=1,95
               dummy1(i) = dlog10(xabund(i)) + 12.0
            enddo
            write (nf1out,1105) (names(i),i,dummy1(i),i=1,95)
            write (nf1out,1106) modprintopt, molopt, linprintopt, 
     .                          fluxintopt
            write (nf1out,1107) (kapref(i),i=1,ntau)
         endif
         linprintopt = linprintalt
         choice = '1' 
      endif


c*****now do the syntheses
      if (numpecatom .eq. 0 .or. numatomsyn .eq. 0) then
         isynth = 1
         isorun = 1
         nlines = 0
         mode = 3
         call inlines (1)
         call eqlib
         call nearly (1)
         call synspec
      else
         do n=1,numatomsyn
            isynth = n
            isorun = n
            start = oldstart
            sstop = oldstop
            mode = 3
            molopt = 2
            call inlines (1)
            call eqlib
            call nearly (1)
            call synspec
            linprintopt = 0
         enddo
      endif
      return
         

c*****a nonsense situation:  the line list read in successfully at the
c*****start, but now there is a problem on re-synthesis
10    write (*,1108)
      stop


c*****format statements
1002  format (13('-'),'MOOG OUTPUT FILE',10('-'),
     .        '(MOOG version from 23/04/07)',13('-')//
     .        'THE MODEL TYPE: ',a10)
1003  format ('   The Rosseland opacities and optical depths have ',
     .        'been read in')
1102  format (/'MODEL ATMOSPHERE HEADER:'/a80/)
1103  format ('INPUT ATMOSPHERE QUANTITIES',10x,
     .        '(reference wavelength =',f10.2,')'/3x,'i',2x,'xref',3x,
     .        'tauref',7x,'T',6x,'logPg',4x,'Pgas',6x,'logPe',
     .        5x,'Ne',9x,'Vturb'/
     .        (i4,0pf6.2,1pd11.4,0pf9.1,f8.3,1pd11.4,0pf8.3,
     .        1pd11.4,d11.2))
1104  format (/'INPUT ABUNDANCES: (log10 number densities, log H=12)'/
     .       '      Default solar abundances: Asplund et al. 2009')
1105  format (5(3x,a2,'(',i2,')=',f5.2))
1106  format (/'OPTIONS: atmosphere = ',i1,5x,'molecules  = ',i1/
     .        '         lines      = ',i1,5x,'flux/int   = ',i1)
1107  format (/'KAPREF ARRAY:'/(6(1pd12.4)))
1108  format ('something odd: linelist was OK initially, now cannot ',
     .        'be read; I QUIT!')


      end 

      subroutine linlimit 
c******************************************************************************
c     This routine marks the range of lines to be considered in a 
c     particular line calculations, depending on the type of calculation
c     (e.g. synthetic spectrum, single line curve-of-growth, etc.)
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Linex.com'
      include 'Pstuff.com'


      lineflag = 0
c*****for single-line computations, the line rage is the whole line set;
c     this will be called from "ewfind"
      if     (mode .eq. 1) then
         lim1line = 1
         lim2line = nlines
          return


c*****for deriving abundances from single of lines of one species, delimit
c     the lines of that species as the range; called from "abfind"
      elseif (mode .eq. 2) then
         if (lim2line .eq. nlines) then
            if (nlines .eq. 1) then
               lim1line = 1
               lim2line = 1
               mode = -1
            else
               lim1line = -1
            endif
            return
         endif
         if (lim1line .eq. 0) then
            lim1line = 1 
         else
            lim1line = lim2line + 1
         endif
         if (lim1line .eq. nlines) then
            lim2line = lim1line
            return
         else
            oldatom = atom1(lim1line)
            do j=lim1line+1,nlines
               if (atom1(j) .ne. oldatom) then
                  lim2line = j - 1
                  return
               endif
            enddo
         endif
         lim2line = nlines
         return


c*****for spectrum synthesis, find the range of lines to include at each
c     wavelength step; called from "synspec"; if requested synthesis
c     begins more than 10A blueward or goes on more than 105A redward of the
c     linelist limits, the synthesis aborts with a message;
      elseif (mode .eq. 3) then
         wavelo = wave - delta
         wavehi = wave + delta
c        requested synthesis too far from linelist limits
         if     (wavehi .lt. wave1(1)-10.0) then
            write (*,1004)
            stop
         elseif (wavelo .gt. wave1(nlines)+10.0 .and.
     .           nlines+nstrong .lt. 2500) then
            write (*,1005)
            stop
         endif
c        blank synthesis at start or end of requested wavelength range
         if     (wavehi .lt. wave1(1)) then
            lim1line = 1
            lim2line = 1
            lineflag = -1
            return
         elseif (wavelo .gt. wave1(nlines)) then
            lim1line = nlines
            lim2line = nlines
            lineflag = -1
            return
         endif
c        requested synthesis region is at least partially within the line list
c        first set the lower synthesis limit; at the beginning of a synthesis
c        of with a new chunk of lines, lim1line = 0
         if (lim1line.eq.0 .or. wavelo .lt. wave1(1)) lim1line = 1
         do j=lim1line,nlines
            if (wavelo .lt. wave1(j)) then
               lim1line = j
               exit
            endif
         enddo
c        now set the upper synthesis limit
         do j=lim1line,nlines
            if (wavehi .lt. wave1(j)) then
               lim2line = j - 1
               if (lim1line.eq.lim2line .and.
     .             wavelo.gt. wave1(lim1line)) then
                  lineflag = -1
               endif
               return
            endif
         enddo   
c        here the end of the line list has been reached; decide whether
c        to read in more lines
         if (nlines+nstrong .eq. 2500) then
            lim2line = -1
         else
            lim2line = nlines
         endif
         return


c*****for blended line force fits to the EWs, the range is a set of
c     lines in a particular blend
      elseif (mode .eq. 4) then
         if (lim1line .eq. 0) lim1line = 1
         if (group(lim1line) .ne. 0.) then
            write (array,1001)
            call prinfo (10)
            write (array,1002)
            call prinfo (11)
            stop
         endif
         if (lim1line .eq. nlines) then
            lim2line = lim1line
         else
            do j=lim1line+1,nlines
               if (group(j) .ne. 1) then
                  lim2line = j - 1
                  return
               endif
            enddo
            lim2line = nlines
         endif
         return
      else
         write (array,1003) mode
         call prinfo (10)
         stop
      endif


c*****format statements
1001  format ('TROUBLE! THE FIRST LINE IN THE GROUP')
1002  format ('DOES NOT DEFINE A NEW GROUP OF LINES!  I QUIT!')
1003  format ('mode = ', i3, ' BUT IT MUST BE 1-4 ONLY; I QUIT!')
1004  format ('synthesis begins more than 10A blueward of the',
     .        ' linelist start; I QUIT!')
1005  format ('synthesis ends more than 10A redward of the',
     .        ' linelist end; I QUIT!')


      end

      subroutine correl
c******************************************************************************
c     This routine cross-correlates arrays x and y using any part of the
c     arrays, as long as there are enough data points in each array. 
c     The result is printed out in terms of the shift in the abscissa
c     of the y array needed to align it with the x array.
c******************************************************************************

      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      include 'Plotval.com'
      real*4 xgood(100000), ygood(100000), zgood(100000)
      real*8 spx(1000), spy(1000)
      real*4 q
      real*8 xinterp(21), yinterp(21)


      wavemin = amax1(xsyn(1),xobs(1))
      wavemax = amin1(xsyn(kount),xobs(lount))
      wavecenter = (wavemax + wavemin)/2.


c*****find the array subscripts for the minimum and maximum 
c     wavelengths in the synthetic spectrum.  
      do i=1,kount
         if (xsyn(i) .ge. wavemin) then
            ilosyn = i
            go to 5
         endif
      enddo
5     do i=ilosyn,kount
         if (xsyn(i) .gt. wavemax) then
            ihisyn = i - 1
            go to 10
         endif
      enddo
      ihisyn = kount


c*****dump the synthetic spectrum wavelengths and fluxes into working arrays
10    itotsyn = ihisyn - ilosyn + 1
      do i=1, itotsyn
         xgood(i) = xsyn(ilosyn-1+i)
         ygood(i) = chunk(ilosyn-1+i,1)
      enddo


c*****find the array subscript for the minimum wavelength in the 
c     observed spectrum 
      do j=1,lount
         if (xobs(j) .ge. xgood(1)) then
            jloobs = j
            go to 15
         endif
      enddo


c*****using a 3-point Lagrangian, make an interpolated observed
c     spectrum that matches the wavelength step size of the
c     synthetic spectrum
15    j = jloobs
      do i=1,itotsyn
         if (xgood(i) .gt. (xobs(j+1)+xobs(j))/2.) j = j + 1
         q = xgood(i)
         zgood(i) = yobs(j-1)*(q-xobs(j))*(q-xobs(j+1))/
     .                  ((xobs(j-1)-xobs(j))*(xobs(j-1)-xobs(j+1))) +
     .              yobs(j)*(q-xobs(j-1))*(q-xobs(j+1))/
     .                  ((xobs(j)-xobs(j-1))*(xobs(j)-xobs(j+1))) +
     .              yobs(j+1)*(q-xobs(j-1))*(q-xobs(j))/
     .                  ((xobs(j+1)-xobs(j-1))*(xobs(j+1)-xobs(j)))
      enddo


c*****next, EITHER do a single cross-correlation 
         call crosscorr (ishift,spy(1),ygood,zgood,itotsyn)

c*****next, do the cross-correlation:
      imax = 2*maxshift + 1
      do i=1,imax
         ishift = i - 1 - maxshift
         spx(i) = dble(ishift)
         call crosscorr (ishift,spy(i),ygood,zgood,itotsyn)
      enddo

c*****interpolate to find the maximum of the correlation function
      corrmax = spy(1)
      mc = 1
      do i=2,imax
         if (spy(i) .gt. corrmax) then
            corrmax = spy(i)
            mc = i
         endif
      enddo
      if (mc.eq.1 .or. mc.eq.imax) then
         deltawave = 0.
         return
      endif
      xinterp(1) = spx(mc-1)
      yinterp(1) = spy(mc-1)
      do j=2,21
         q = spx(mc-1) + (j-1)/10.
         xinterp(j) = q
         yinterp(j) = spy(mc-1)*(q-spx(mc))*(q-spx(mc+1))/
     .                  ((spx(mc-1)-spx(mc))*(spx(mc-1)-spx(mc+1))) +
     .                spy(mc)*(q-spx(mc-1))*(q-spx(mc+1))/
     .                  ((spx(mc)-spx(mc-1))*(spx(mc)-spx(mc+1))) +
     .                spy(mc+1)*(q-spx(mc-1))*(q-spx(mc))/
     .                  ((spx(mc+1)-spx(mc-1))*(spx(mc+1)-spx(mc)))
      enddo
      jmax = 1
      corrmax = yinterp(1)
      do j=2,21
         if (yinterp(j) .gt. corrmax) then
            jmax = j
            corrmax = yinterp(j)
            shiftmax = xinterp(j)
         endif
      enddo


c*****translate this into a correction to the input velocity shift
      deltawave = -step*shiftmax
      deltavel = -3.0d5*step*shiftmax/wavecenter
      veladd = veladd + deltavel


      return
      end






      

      subroutine abfind
c******************************************************************************
c     This routine derives abundances for individual atomic lines       
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'

  
c*****read the parameter file
      call params


c*****open the files for standard output and summary abundances
      nf1out = 20
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21
      lscreen = lscreen + 2
      array = 'SUMMARY ABUNDANCE OUTPUT'
      nchars = 24
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)
      nf5out = 26
      lscreen = lscreen + 2
      array = 'POSTSCRIPT PLOT OUTPUT'
      nchars = 22
      call infile ('output ',nf5out,'formatted  ',0,nchars,
     .             f5out,lscreen)


c*****open and read the model atmosphere
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
102   nfmodel = 30
      lscreen = lscreen + 2
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****open and read the line list file; get ready for the line calculations
      array = 'THE LINE LIST'
      nchars = 13
      nflines = 31
      lscreen = lscreen + 2
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .              flines,lscreen)


c*****get ready for the line calculations: generate a curve-of-growth lookup
c     table, read the linelist, etc.
100   call fakeline
      call inlines (1)
      call eqlib
      call nearly (1)

 
c*****set some parameters
      ewsynthopt = -1
      mode = 2
      cogatom = 0.
      lim1line = 0


c*****find the range of lines of a species
5     call linlimit
      if (lim1line .lt. 0) then
         call finish (0)
         return
      endif
      lim1obs = lim1line
      lim2obs = lim2line


c*****find out whether molecular equilibrium is involved in the species
      call molquery


c*****force each abundance of a species member to predict the 
c     line equivalent width; here is the code for ordinary species
      if (molflag .eq. 0) then
         abundin =  dlog10(xabund(iabatom)) + 12.0
         do lim1=lim1line,lim2line
            call lineabund (abundin)
         enddo
         call stats
         call lineinfo (3)
      else


c*****and here is the code for species involved in molecular equilibrium;
c     this procedure is iterated until input and output abundances are in 
c     agreement
         iternumber = 1
10       abundin =  dlog10(xabund(iabatom)) + 12.0
         do lim1=lim1line,lim2line
            call lineabund (abundin)
         enddo
         call stats
         call lineinfo (3)
         if (t(jtau5).lt.3800                 .or. 
     .       atom1(lim1line).gt.100.0         .or.
     .       int(atom1(lim1line)+0.0001).eq.6 .or.
     .       int(atom1(lim1line)+0.0001).eq.8) then
            if (iternumber .lt. 6) then
               if (dabs(average-abundin) .gt. 0.02) then
                  xabund(iabatom) = 10.**(average-12.)
                  iternumber = iternumber + 1
                  call eqlib
                  call nearly (2)
                  go to 10
               else
                  write (array,1001) iternumber
                  ikount=kount+14
                  nchars = 53
                  call putasci (nchars,ikount)
               endif
            else
               write (array,1003) molecule, dlog10(abundin),
     .                            dlog10(average)
               lscreen = lscreen + 2
               call prinfo (lscreen)
               stop
            endif
         endif
      endif


c*****here a plot may be made on the terminal (and paper) if there 
c     are enough lines; then the user will be prompted on some
c     options concerning what is seen on the plot
      if (plotopt .ne. 0) then
         call pltabun
         if     (choice.eq.'v') then
            rewind nf1out
            rewind nf2out
            write (nf2out,1002) linitle,moditle
            choice = ' '
            go to 100
         elseif (choice .eq. 'm') then
            close (unit=nfmodel)
            close (unit=nflines)
            rewind nf1out
            rewind nf2out
            rewind nf5out
            array = 'THE NEW MODEL ATMOSPHERE'
            nchars = 24
            fmodel =  'no_filename_given'
            lim1line = 0
            lim2line = 0
            lim1obs = 0
            lim2obs = 0
            go to 102
         endif
      endif


 
             
c*****quit, or go on to another species?
      if (silent .eq. 'y') then
         choice = 'y'
         nchars = 0
      else
         array = 'DO ANOTHER SPECIES ([y]/n)? '
         nchars = 28
         call getasci (nchars,maxline)
         choice = chinfo(1:1)
      endif
      if (choice.eq.'y' .or. nchars.le.0) then
         if (mode .eq. 2) then
            go to 5
         else
            call finish (0)
            return
         endif
      else
         call finish (0)
         return
      endif


c*****format statements
1001  format ('THIS REQUIRED', i2,' ITERATIONS WITH MOLECULAR ',
     .        'EQUILIBRIUM')
1002  format (a80)
1003  format ('FOR SPECIES ', f10.1,' NO CONVERGENCE: '/
     .        'LAST ITERATIONS YIELD', 2f10.3, '  I QUIT!')


      end

      subroutine binplotprep
c******************************************************************************
c     This routine concatenates two syntheses in order to make a smoothed
c     binary synthetic spectrum
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Factor.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      include 'Multistar.com'
      real*8 normalization
      integer pshift


c*****open the files 
      nf7out = 21
      lscreen = 4
      array = 'RAW SYNTHESIS INPUT FOR PRIMARY'
      nchars = 31
      call infile ('input  ',nf7out,'formatted  ',0,nchars,
     .             f7out,lscreen)
      nf8out = 22
      lscreen = lscreen + 2
      array = 'RAW SYNTHESIS INPUT FOR SECONDARY'
      nchars = 33
      call infile ('input  ',nf8out,'formatted  ',0,nchars,
     .             f8out,lscreen)
      nf9out = 23
      lscreen = lscreen + 2
      array = 'RAW SYNTHESIS OUTPUT FOR COMBINED BINARY'
      nchars = 40
      call infile ('output ',nf9out,'formatted  ',0,nchars,
     .             f9out,lscreen)
      if (plotopt .ne. 0) then
         nf10out = 24
         lscreen = lscreen + 2
         array = 'SMOOTHED SYNTHESIS OUTPUT FOR COMBINED BINARY'
         nchars = 45
         call infile ('output ',nf10out,'formatted  ',0,nchars,
     .                f10out,lscreen)
         nf5out = 26
         lscreen = lscreen + 2
         array = 'POSTSCRIPT PLOT OUTPUT FOR COMBINED BINARY'
         nchars = 22
         call infile ('output ',nf5out,'formatted  ',0,nchars,
     .                f5out,lscreen)
      endif
      if (plotopt .gt. 1) then
         nf6out = 27
         lscreen = lscreen + 2
         array = 'SPECTRUM COMPARISON OUTPUT'
         nchars = 27
         call infile ('output ',nf6out,'formatted  ',0,nchars,
     .                f6out,lscreen)
      endif


c*****compute and output the parameters related to the spectrum combination:
c     the declared velocity difference, the luminosity ratio, and
c     for information, the computed fluxes of the two stars; get the user's
c     agreement
      deltawave = deltaradvel/2.9979d+5*(start+sstop)/2.
      pshift = nint(deltawave/step)
      write (array,1002) fluxprimary, fluxsecondary
      lscreen = lscreen + 2
      nchars = 55
      call putasci (nchars,lscreen)
      write (array,1003) lumratio
      lscreen = lscreen + 1
      nchars = 49
      call putasci (nchars,lscreen)
      write (array,1001) deltaradvel, deltawave, pshift
      lscreen = lscreen + 1
      nchars = 71
      call putasci (nchars,lscreen)
      write (array,*) 'ARE THESE VALUES OK (y/n)? '
      lscreen = lscreen + 2
      nchars = 27


c*****read back the header information from the individual star raw 
c     synthetic spectra
99    read (nf7out,1004,end=100) array
      read (nf8out,1004) chinfo
      if     (array(1:7).eq.'Isotopi') then
         write (nf9out,1004) array
         go to 99
      elseif (array(1:7).eq.'ALL abu') then
         write (nf9out,1010) array(1:59), chinfo(54:59)
         go to 99
      elseif (array(1:7).eq.'Changin') then
         write (nf9out,1011) array(1:37), chinfo(31:37)
         go to 99
      elseif (array(1:7).eq.'element') then
         write (nf9out,1012) array(1:30), chinfo(25:30)
         go to 99
      elseif (array(1:7).eq.'MODEL: ') then 
         write (nf9out,1013) array(8:43), chinfo(8:43)
         modbin(1) = array(1:80)
         modbin(2) = chinfo(1:80)
      endif
      read (nf7out,1004) array
      read (nf8out,1004) chinfo
      read (array,*) start, sstop, step
      kount = nint((sstop - start + (step/4.0) )/step) + 1
      write (nf9out,1004) array


c*****read back the raw synthetic spectra from the individual stars;
c     shift by the appropriate point number, add the spectra (normalized),
c     and dump to combined raw synthetic spectrum file
      read (nf7out,1006) (y(i),i=1,kount)
      read (nf8out,1006) (z(i),i=1,kount)
      do i=1,kount
         y(i) = 1.0 - y(i)
         z(i) = (1.0 - z(i))/lumratio
      enddo
      normalization = 1.0 + 1.0/lumratio
      if (pshift .gt. 0) then
         do i=1,pshift
            dev(i) = 1.0
         enddo
         do i=pshift+1,kount
            dev(i) = (y(i)+z(i-pshift))/normalization
         enddo
      elseif (pshift .eq. 0) then
         do i=1,kount
            dev(i) = (y(i)+z(i))/normalization
         enddo
      else
         do i=1, kount-pshift
            dev(i) = (y(i)+z(i-pshift))/normalization
         enddo
         do i=kount-pshift+1,kount
            dev(i) = 1.0
         enddo
      endif
      do i=1,kount
         y(i) = 1.0 - dev(i)
      enddo
      write (nf9out,1006) (y(i),i=1,kount)
      go to 99
100   return


c*****format statements
1001  format ('INPUT DELTA VELOCITY = ', f8.3,
     .        ';  DELTA WAVELENGTH = ', f8.3,
     .        ';  POINT SHIFT = ', i4)
1002  format ('PRIMARY FLUX = ', 1pe10.3, 
     .        ';  SECONDARY FLUX = ', 1pe10.3)
1003  format ('INPUT LUMINOSITY RATIO = ', 0pf8.3)
1004  format (a80)
1006  format (10f8.4)
1010  format (a59, ',', a6, ' dex')
1011  format (a37, ',', a6, ' dex')
1012  format (a30, ',', a6)
1013  format ('MODEL: ', 2a36)


      end                                                            

      subroutine vargauss (line)
c******************************************************************************
c     This subroutine prepares synthesis data for plotting by smoothing
c     the data with a Gaussian whose FWHM has been specified by the user
c     at various wavelengths along the spectrum
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      real*8 wavefwhm(100),fwhm(100)
      character*80 fsmooth
      data istart /0/


c*****initialize parameters
      write (abitle,1001) 
      nsyn = 1
      sigma = 0.   
      jrotdel = 0
      fsmooth = 'no_filename_given'


c*****on entering, rewind the unsmoothed and smoothed spectrum output 
c     files, and get the synthesis range parameters from the 'dump' file
      rewind nf2out
      rewind nf3out
55    read (nf2out,1002) moditle
      if (moditle(1:15).eq.'        element' .or.  
     .    moditle(1:15).eq.' ALL abundances' .or.
     .    moditle(1:15).eq.'Isotope Ratio: ') go to 55
      read (nf2out,*) start, sstop, step
      kount = nint((sstop - start + (step/4.0) )/step) + 1
      rewind nf2out


c*****the first time through, read in the Gaussian FWHM array
      if (istart .eq. 0) then
         istart = 1
         nfsmooth = 35
         array = 'SMOOTHING FWHM DATA'
         nchars = 19
         call infile ('input  ',nfsmooth,'formatted  ',0,nchars,
     .                fsmooth,line)
         j = 1
39       read (nfsmooth,*,end=40) wavefwhm(j), fwhm(j)
         j = j + 1
         if (j .le. 100) then
            go to 39
         else
            istat = ivcleof (line,1)
            istat = ivmove (line-1,1)
            write (*,*) 'ERROR: TOO MANY POINTS IN THE FWHM FILE!'
            smtype = 'e'
            return
         endif
40       jtotfwhm = j - 1
      endif


c*****now read in the raw spectrum and flip to a depth scale
45    noff = 80*(nsyn-1)
      abitle(noff+1:noff+12) = '[M/H] 0.00  '
      nabunds = 0
41    read (nf2out,1002,end=2000) array
      if     (array(1:15).eq.' ALL abundances') then
         abitle(noff+6:noff+10) = array(56:60)
         go to 41
      elseif (array(1:15).eq.'        element') then
         nabunds = nabunds + 1
         if (nabunds .le. 7) then
            ioff = noff + 12 + 9*(nabunds-1)
            abitle(ioff+1:ioff+2) = array(17:18)
            abitle(ioff+3:ioff+7) = array(34:38)
            abitle(ioff+8:ioff+9) = '  '
         endif
         go to 41
      elseif (array(1:15).eq.'Isotope Ratio: ') then
         nabunds = nabunds + 1
         if (nabunds .le. 7) then
            ioff = noff + 12 + 9*(nabunds-1)
            abitle(ioff+1:ioff+4) = array(27:30)
            abitle(ioff+5:ioff+5) = ' '
            do k=33,44
               if (array(k:k) .ne. ' ') then
                  abitle(ioff+6:ioff+8) = array(k:k+2)
                  go to 60
               endif
            enddo
60          abitle(ioff+9:ioff+9) = ' '
         endif
         go to 41
      endif
      read (nf2out,1002,end=2000)
      read (nf2out,1003,end=2000) (y(i),i=1,kount)
      do i=1,kount
         y(i) = 1.0 - y(i)
      enddo


c*****go through the spectrum wavelengths step by step; the 
c     Gaussian smoothing will need to be different at each step
      i = 0
      oldhalf = 0.
25    i = i + 1
      if (i .gt. kount) go to 90
      synstep = start + (i-1)*step


c*****interpolate linearly in the FWHM array to get the appropriate value 
c     for the current wavelength step
      if     (synstep .le. wavefwhm(1)) then
         half = fwhm(1)
      elseif (synstep .ge. wavefwhm(jtotfwhm)) then
         half = fwhm(jtotfwhm)
      else
         do j=2,jtotfwhm
            if (synstep .le. wavefwhm(j)) then
               half = fwhm(j-1) + (synstep-wavefwhm(j-1))*
     .                (fwhm(j)-fwhm(j-1))/(wavefwhm(j)-wavefwhm(j-1))
               if (half .gt. 0.) then
                  go to 10
               else
                  go to 15
               endif
            endif
         enddo
      endif


c*****compute the Gaussian smoothing function, if needed
10    if (dabs(half-oldhalf)/half .lt. 0.03) go to 50
      oldhalf = half
      sigma = half/2
      aa = 0.6932/sigma**2
      power = 1.0
      do k=1,1000
         p(k) = dexp(-aa*(step*k)**2 )
         power = power + 2*p(k)
         if (p(k) .lt. 0.05) then
            jdel = k
            min = jdel + 1
            max = kount - jdel
            p0 = 1.
            go to 50 
         endif
      enddo
      istat = ivcleof (line,1)
      istat = ivmove (line-1,1)
      write (*,1023) sigma, (p(i),i=1,1000)
      smtype = 'e'
      return


c*****if no smoothing, just equate the smoothed to the unsmoothed point
15    z(i) = y(i)
      go to 25

  
c*****otherwise smooth the spectrum
50    if (i.lt.min .or. i.gt.max) then
         z(i) = y(i)
      else
         z(i) = p0*y(i)
         do k=1,jdel
            z(i) = z(i) + p(k)*(y(i-k) + y(i+k))
         enddo
         z(i) = z(i)/power
      endif
      go to 25
 

c*****copy the smoothed spectrum to the appropriate array
90    do i=1,kount
         chunk(i,nsyn) = z(i)
      enddo


c*****compute the wavelength array; must be done for each synthetic
c     spectrum because of the way the equivalences were set up
      do i=1,kount
         xsyn(i) = start + (i-1)*step
      end do
 

c*****dump the smoothed spectrum in a MONGO-style set of 
c     (wavelength,flux) point pairs
      write (nf3out,1005) kount, start, sstop, step
      if (xsyn(1) .le. 100.0) then
         write (nf3out,1009) (xsyn(i),z(i),i=1,kount)
      else 
         write (nf3out,1008) (xsyn(i),z(i),i=1,kount)
      endif
      nsyn = nsyn + 1
      go to 45


c*****exit the routine normally
2000  nsyn = nsyn - 1
      return


c*****format statements
1001  format (400(' '))
1002  format (a80)
1003  format (10f8.4)
1005  format ('the number of points per synthesis = ',i5/
     .       'start = ',f10.3,5x,'stop = ',f10.3,5x,'step = ',f10.3)
1008  format (f10.3,'  ',f10.5)
1009  format (f10.6,'  ',f10.5)
1023  format ('ERROR: GAUSSIAN PROFILE TOO BIG! (HALF WIDTH=',
     .       f6.2,')      THE PROFILE:'/(15f5.2))

      end

      subroutine binary
c******************************************************************************
c     This program synthesizes a section of a spectroscopic binary star
c     spectrum, using one model atmosphere for the primary and one model
c     for the secondary, and then compares it to an observed spectrum.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      include 'Multistar.com'
      integer ncall


c*****examine the parameter file
      begin = 0
      ncall = 1
1     call params
      linprintopt = linprintalt
      if (begin .eq. 0) then
         if (numpecatom .gt. 0) then
            do i=3,95
               binpec(syncount,i) = pec(i)
               do j=1,numatomsyn
                  binpecabund(syncount,i,j) = pecabund(i,j)
               enddo
            enddo
         endif
      else
         if (numpecatom .gt. 0) then
            do i=3,95
               pec(i) = binpec(syncount,i)
               do j=1,numatomsyn
                  pecabund(i,j) = binpecabund(syncount,i,j)
               enddo
            enddo
         endif
      endif


c*****open the files for: standard output, raw spectrum depths, smoothed 
c     spectra, and (if desired) IRAF-style smoothed spectra
      istat = ivcleof(5,1)
      nf1out = 20     
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21               
      lscreen = lscreen + 2
      array = 'RAW SYNTHESIS OUTPUT'
      nchars = 20
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)
      if (syncount .eq. 1) then
         f7out = f2out
      else
         f8out = f2out
      endif
      if (iraf .ne. 0) then
         nf4out = 23               
         lscreen = lscreen + 2
         array = 'IRAF ("rtext") OUTPUT'
         nchars = 24
         call infile ('output ',nf4out,'formatted  ',0,nchars,
     .                f4out,lscreen)
      endif


c*****open and read the model atmosphere file
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****open the line list file and the strong line list file
      nflines = 31
      lscreen = lscreen + 2
      array = 'THE LINE LIST'
      nchars = 13
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .              flines,lscreen)
      if (dostrong .gt. 0) then
         nfslines = 32
         lscreen = lscreen + 2
         array = 'THE STRONG LINE LIST'
         nchars = 20
         call infile ('input  ',nfslines,'formatted  ',0,nchars,
     .                 fslines,lscreen)
      endif
      

c*****do the syntheses
      if (numpecatom .eq. 0 .or. numatomsyn .eq. 0) then
         isorun = 1
         nlines = 0
         mode = 3
         call inlines (1)
         call eqlib
         call nearly (1)
         call synspec
      else
         do n=1,numatomsyn
            isynth = n
            isorun = 1
            start = oldstart
            sstop = oldstop
            mode = 3
            call inlines (1)
            call eqlib
            call nearly (1)
            call synspec
            linprintopt = 0
         enddo
      endif
      if (syncount .eq. 1) then
         fluxprimary = flux
      else
         fluxsecondary = flux
      endif
         

c*****finish the syntheses
      call finish (1)
      istat = ivcleof(4,1)
      if (control .ne. 'gridend') go to 1


c*****combine the synthetic spectra for plotting
      call binplotprep


c*****now plot the spectrum, maybe iterating abundances, and end the program
      if (plotopt.eq.2 .and. specfileopt.gt.0) then
         nfobs = 33               
         lscreen = lscreen + 2
         array = 'THE OBSERVED SPECTRUM'
         nchars = 21
         if (specfileopt.eq.1 .or. specfileopt.eq.3) then
            call infile ('input  ',nfobs,'unformatted',2880,nchars,
     .                   fobs,lscreen)
         else
            call infile ('input  ',nfobs,'formatted  ',0,nchars,
     .                   fobs,lscreen)
         endif
      endif
      if (plotopt .ne. 0) then
         control = 'binary '
         nf2out = nf9out
         nf3out = nf10out
         call pltspec (lscreen,ncall)
         if (choice .eq. 'n') then
            do syncount=1,2
               if (numpecatom .gt. 0) then
                  do i=3,95
                     pec(i) = binpec(syncount,i)
                     do j=1,numatomsyn
                        pecabund(i,j) = binpecabund(syncount,i,j)
                     enddo
                  enddo
               endif
               call chabund
               do i=3,95
                  binpec(syncount,i) = pec(i)
                  do j=1,numatomsyn
                     binpecabund(syncount,i,j) = pecabund(i,j)
                  enddo
               enddo
            enddo
            call finish (1)
            linecount = 0
            oldcount = 0
            begin = begin + 1
            choice = '1'
            ncall = 2
            go to 1
         endif
      endif

      call finish (0)

      end

      subroutine oneline (imode)                                    
c******************************************************************************
c     This routine computes a single line profile                       
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'
      real*8 dinteg(200)
      data waveold /0.0/                                   


c*****set an arbitrary maximum # of wavelength points to compute 
c     the line profile
      maxsteps = 100


c*****get started; calculate an initial step size; wavestep only is 
c*****used in synpop
      if (imode .eq. 0) gf1(ncurve) = gf(lim1)                          
      dellam(1) = 0.                                                    
      if (wavestep .eq. 0.) then
         st1 = wave1(lim1)*dopp(lim1,jtau5)/2.997929e10/5.
         st1 = dfloat(ifix(10000.*sngl(st1)))/10000.
      else
         st1 = wavestep
      endif
      storig = st1


c*****calculate continuous opacity and intensity/flux at line wavelength 
      wave = wave1(lim1)                                                
      if (abs(wave-waveold) .gt. 30.) then
         waveold = wave
         call opacit(2,wave)     
         if (imode.ne.2 .and. modprintopt.ge.2) 
     .      write(nf1out,1002) wave,(kaplam(i),i=1,ntau)
         call cdcalc(1)
         first = 0.4343*cd(1)
         flux = rinteg(xref,cd,dummy1,ntau,first)
         if (imode .ne. 2) then
            if (iunits .eq. 1) then
               write (nf1out,1003) 1.d-4*wave,flux
            else
               write (nf1out,1004) wave,flux
            endif
         endif
      endif


c*****check the wavelength step size; expand/contract as necessary
      if (wavestep .eq. 0.) then
         wave = wave1(lim1)
         call taukap
         call cdcalc(2)
         first = 0.4343*cd(1)
         d(1) = rinteg(xref,cd,dummy1,ntau,first)
         do k=1,30
            if (k .eq. 30) then
               write (*,1010) wave
               stop
            endif
            wave = wave1(lim1) + 5.*st1
            call taukap
            call cdcalc(2)
            first = 0.4343*cd(1)
            d(2) = rinteg(xref,cd,dummy1,ntau,first)       
            d2d1 = d(2)/d(1)
            if     (d2d1 .le. 0.2) then
               st1 = st1/1.5
            elseif (d2d1 .le. 0.6) then
               st1 = st1/1.2
            elseif (d2d1.gt.0.60 .and. d2d1.lt.0.80) then
               if (imode .ne. 2) write (nf1out,1001) lim1,
     .                           1000.*width(lim1), storig, st1, k
               exit
            elseif (d2d1 .ge. 0.80) then
               st1 = st1*1.6
            elseif (d2d1 .ge. 0.90) then
               st1 = st1*2.1
            endif
               st1 = dble(idnint(10000.*st1))/10000.
         enddo
      endif


c*****calculate wavelength dependent line quantities, and the line depth
c     until the depth is very small in the line wing
      wave = wave1(lim1)                                                
      do n=1,maxsteps
         dellam(n) =  (n-1)*st1
         wave = wave1(lim1) + dellam(n)
         call taukap
         call cdcalc(2)
         first = 0.4343*cd(1)
         d(n) = rinteg(xref,cd,dummy1,ntau,first)       
         if (linprintopt.ge.3 .and. n.eq.1 .and. imode.eq.2) then
            do i=1,ntau
               dummy1(i) = xref(i)*cd(i)
            enddo
            first = 0.
            cdmean = rinteg(xref,dummy1,dummy2,ntau,first)/
     .               rinteg(xref,cd,dummy2,ntau,first)
            do i=1,ntau
               if (cdmean .lt. cd(i)) exit
            enddo
            write (nf1out,1005) lim1, cdmean, i, xref(i)
            do i=1,ntau
               if (taunu(i)+taulam(i) .ge. 1.) exit
            enddo
            write (nf1out,1006) lim1, i, dlog10(tauref(i)),
     .                          dlog10(taulam(i)), dlog10(taunu(i))
         endif
         if (d(n)/d(1) .lt. 0.0050) then
            ndepths = n
            exit
         endif
         if (n .eq. maxsteps) then 
            if (d(n).gt.0.001 .and. imode.ne.2) then
               write (nf1out,1007)
               ndepths = maxsteps 
            endif
         endif
      enddo                                                             


c*****finish the calculation                                            
      if (imode .ne. 2) write (nf1out,1008) (d(j),j=1,ndepths)
      do n=2,ndepths
         d(ndepths+n-1) = d(n)
      enddo
      d(ndepths) = d(1)
      do n=2,ndepths
         d(n-1) = d(2*ndepths+1-n)
      enddo
      dellam(1) = -st1*(ndepths-1)
      ndep = 2*ndepths - 1
      do n=2,ndep
         dellam(n) = dellam(n-1) + st1
      enddo
      first = 2*dellam(ndep)*d(ndep)
      w(ncurve) = rinteg(dellam,d,dinteg,ndep,first) 
      if (imode .ne. 2) then
         ew = 1000.0*w(ncurve)
         gflog = dlog10(gf1(ncurve))
         rwlog = dlog10(w(ncurve)/wave1(lim1))
         write (nf1out,1009) wave1(lim1), ew, rwlog, gf1(ncurve), gflog
      endif
      return                                                            


c*****format statements
1001  format (/'LINE ', i5, ':', 5x, 'observed EW to match: ', f7.2/
     .        16x, 'lambda step initial, final: ', 2f7.4/ 
     .        16x, 'trials needed to decide this: ', i2)
1002  format ('  kaplam from 1 to ntau at wavelength',f10.2/
     1        (6(1pd12.4)))
1003  format ('AT WAVELENGTH/FREQUENCY =',f11.7,
     .        '  CONTINUUM FLUX/INTENSITY =',1p,d12.5)
1004  format ('AT WAVELENGTH/FREQUENCY =',f11.3,
     .        '  CONTINUUM FLUX/INTENSITY =',1p,d12.5)
1005  format (/'LINE ', i5, ':',
     .        ' weighted mean line contribution function C_d =',
     .        f6.2/ '  which occurs near level ', i3,
     .        ' with log tauref = ', f6.2)
1006  format (/'LINE ', i5, ':',
     .        '  tau(total) is greater than 1 at level',i3/
     .        '  logs of tauref, taulam, taunu =', 3f6.2)
1007  format ('WARNING:  not enough points to specify the line?')
1008  format (10f7.3)
1009  format ('lambda =',f12.3,5x,'E.W. =',f8.2,' mA.',5x,
     .       'log(R.W.) =',f6.2/'gf =',1pd10.3,5x,'log(gf) =',
     .       0pf7.2)
1010  format ('CANNOT DECIDE ON LINE WAVELENGTH ',
     .        'STEP SIZE FOR', f10.2, '   I QUIT!')
1011  format ('original and final wavelength step size: ', 2f8.4)

      end                                                               

      subroutine findtic (end1,end2,bigtic,smltic)
c******************************************************************************
c     this routine makes tic marks at nice round intervals.
c******************************************************************************

      implicit real*8(a-h,o-z)
      real*4 end1, end2, bigtic, smltic, span, spanlog


      span = end2 - end1
      if (span .lt. 0.) span = - span
      spanlog = alog10(span)
      size = ifix(spanlog)
      if (spanlog .lt. 0.) size = size - 1
      chop = spanlog - size
      if (chop .lt. 0.31) then
         bigtic = 10.**(size)/2
         smltic = bigtic/5
      elseif (chop .lt. 0.71) then
         bigtic = 10.**(size)
         smltic = bigtic/5
      else
         bigtic = 10.**(size)*2
         smltic = bigtic/4
      endif
      return


      end

      subroutine curve
c******************************************************************************
c     This routine produces a curve-of-growth for a single line          
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'


c*****set up the parameters 
      ewsynthopt = -1
      ncurve = 1
      dec = 10.**(rwstep)
      wstart = 10.**(rwlow)*wave1(lim1)
      wstop = 10.**(rwhigh)*wave1(lim1)
      gf1(ncurve) = gf(lim1)

 
c*****increment the log(gf) value backward by rwstep and redo the calculations 
c     until the end (rwlow) is reached
31    call oneline (2)
      if (w(ncurve) .gt. wstart) then
         gf1(ncurve) = gf1(ncurve)/dec
         do i=1,ntau
            kapnu0(lim1,i) = kapnu0(lim1,i)/dec
         enddo
         go to 31
      endif
      go to 61
 

c*****increment the log(gf) value forward by rwstep and redo the calculations 
c     until the end (rwhigh) is reached
60    gf1(ncurve) = gf1(ncurve-1)*dec
      do i=1,ntau                                                     
         kapnu0(lim1,i) = kapnu0(lim1,i)*dec
      enddo
61    call oneline (2)
      if (w(ncurve) .lt. wstop) then
         ncurve = ncurve + 1
         go to 60
      endif
 

c*****end the computations with a summary print
      if (nf2out .ne. 0 .and. lim1 .eq. 1)
     .   write (nf2out,1001) moditle
      do i=1,ncurve
         w(i) = dlog10(w(i)/wave1(lim1))
         gf1(i) = dlog10(gf1(i))
      enddo
      iatom = atom1(lim1)
      if(iatom .ge. 100) iatom = 1
      abund = dlog10(xabund(iatom)) + 12.
      write (nf1out,1002) wave1(lim1),atom1(lim1),e(lim1,1),
     .                    abund,ncurve
      write (nf1out,1003) (gf1(i),w(i),i=1,ncurve)
      if (nf2out .eq. 0) return
      write (nf2out,1002) wave1(lim1),atom1(lim1),e(lim1,1),
     .       abund,ncurve
      write (nf2out,1003) (gf1(i),w(i),i=1,ncurve)
      return


c*****format statements
1001  format (a80)
1002  format(/'wavelength =', f9.3,5x, 'species =', f6.1,5x, 'ep =',
     .       f7.3, 'abundance =', f10.3, 5x, 'n =',i2)
1003  format('  curve of growth in (loggf,logrw) pairs'/
     .       (1(f7.3,',',f7.3)))
1004  format (10f7.3)


      end

      subroutine inlines (num)
c******************************************************************************
c     This subroutine reads in the line data
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Dummy.com'
      include 'Pstuff.com'
      include 'Quants.com'
      include 'Factor.com'
      real*8 swave1(40), satom1(40), se(40),sgf(40),
     .       sdampnum(40),sd0(40),swidth(40), scharge(40)
      integer n2


      if (num .eq. 2) go to 4
      if (num .eq. 6) go to 340
      n1marker = 1
      n2 = 0


c*****decide if certain element abundances need to be modified.
      if (numpecatom .gt. 0) then
         do iatom=3,95
            xabund(iatom) = 10.**pecabund(iatom,isynth)*
     .                      10.**abfactor(isynth)*xabu(iatom)
         enddo
      endif
      if (num .ne. 5) then
         write (nf1out,1004)
         xmetals = abscale + abfactor(isynth)
         if (ninetynineflag .eq. 1) then
            write (nf1out,1005) xmetals
            if (nf2out .gt. 0) write (nf2out,1005) xmetals
         else
            if (nf2out .gt. 0) write (nf2out,1006) abscale
         endif
         do j=1,93
            if (pec(j) .gt. 0 ) then
               dummy1(j) = dlog10(xabund(j)) + 12.0
               if (dummy1(j) .le. -10.) then 
                  write (nf1out,1008) names(j),dummy1(j)
                  if (nf2out .gt. 0) 
     .                write (nf2out,1008) names(j),dummy1(j)
               else
                  write (nf1out,1007) names(j),dummy1(j)
                  if (nf2out .gt. 0) 
     .                write (nf2out,1007) names(j),dummy1(j)
               endif
            endif
         enddo
      endif


c*****output information about the isotopic ratios
      if (numiso .gt. 0) then
         write (nf1out,1014)
         do i=1,numiso
            iiso = isotope(i)
            write (nf1out,1015) iiso, isotope(i), isoabund(i,isorun)
            if (nf2out .gt. 0) write (nf2out,1015) 
     .                         iiso, isotope(i), isoabund(i,isorun)
         enddo
      endif



c*****Inititalize strong line printing
c     if 'printstrong' gt 0 then the strong lines have 
c     been printed
      printstrong = -1

      if (num .ne. 4) then  
         rewind nflines
         wave = start
         read (nflines,1001) linitle
      endif


c*****read in the strong lines if needed
302   nstrong = 0
      if (dostrong .gt. 0 ) then
         rewind nfslines
         do j=1,41
            if (linfileopt .eq. 0) then
               read (nfslines,1002,end=340) swave1(j),satom1(j),se(j),
     .                             sgf(j),sdampnum(j),sd0(j),swidth(j)
            else
               read (nfslines,*,end=340) swave1(j),satom1(j),se(j),
     .                             sgf(j),sdampnum(j),sd0(j),swidth(j)
            endif
            nstrong = nstrong + 1
            iatom = satom1(j)
            scharge(j) = 1.0 + dble(int(10.0*(satom1(j) - iatom)
     .          +0.0001))
            if (scharge(j) .gt. 3.) then
               write (*,1003) swave1(i), satom1(i)
               stop
            endif
         enddo
         if (nstrong .gt. 40) then
            write(*,*) 'STRONG LINE LIST HAS MORE THAN 40 LINES. THIS'
            write(*,*) 'IS NOT ALLOWED. I QUIT!'
            stop
         endif
      endif

340   nlines = 2500 - nstrong
      j = 1
333   if (linfileopt .eq. 0) then
         read (nflines,1002,end=311) wave1(j),atom1(j),e(j,1),gf(j),
     .                             dampnum(j),d0(j),width(j)
      else
         read (nflines,*,end=311) wave1(j),atom1(j),e(j,1),gf(j),
     .                             dampnum(j),d0(j),width(j)
      endif
      iatom = atom1(j)
      charge(j) = 1.0 + dble(int(10.0*(atom1(j) - iatom)+0.0001))
      if (charge(j) .gt. 3.) then
         write (*,1003) wave1(j), atom1(j)
         stop
      endif 
      if (width(j) .lt. 0.) then
         if (control .eq. 'blends ') then
            write (*,*) 'BLENDS cannot have negative EWs!  I QUIT!'
            stop
         else
            go to 333
         endif
      endif
      if (iunits .eq. 1) wave1(j) = 1.d+4*wave1(j)
      j = j + 1
      if (j .le. nlines) go to 333
311   nlines = j - 1 


c*****append the strong lines here if necessary
      if (dostrong .gt. 0) then
         do k=1,nstrong
            wave1(nlines+k) = swave1(k)
            atom1(nlines+k) = satom1(k)
            e(nlines+k,1) = se(k)
            gf(nlines+k) = sgf(k)
            dampnum(nlines+k) = sdampnum(k)
            d0(nlines+k) = sd0(k)
            width(nlines+k) = swidth(k)
            charge(nlines+k) = scharge(k)
         enddo
      endif


c*****here groups of lines for blended features are defined
      do j=1,nlines+nstrong
         if (wave1(j) .lt. 0.) then
            group(j) = 1
            wave1(j) = dabs(wave1(j))
            width(j) = width(j-1)
         else
            group(j) = 0
         endif
      enddo     


c*****here excitation potentials are changed from cm^-1 to eV, if needed
      do j=1,nlines+nstrong
         if (e(j,1) .gt. 50.) then
            do jj=1,nlines+nstrong
               e(jj,1) = 1.2389e-4*e(jj,1)
            enddo
            exit
         endif
      enddo
 

c*****here log(gf) values are turned into gf values, if needed
      do j=1,nlines+nstrong
         if (gfstyle.eq.0 .or. gf(j) .lt. 0) then
            do jj=1,nlines+nstrong
               gf(jj) = 10.**gf(jj)
            enddo
            exit
         endif
      enddo         


c*****turn log(RW) values and EW values in mA into EW values in A.  Stuff
c     duplicate EW values of the first line of a blend into all blend members.
      do j=1,nlines+nstrong
         if (width(j) .lt. 0.) then
            width(j) = 10.**width(j)*wave1(j)
         else
            width(j) = width(j)/1000.
         endif
       enddo


c*****here some parameters for the lines are assigned or calculated; 
c     there is a block of statements for moleculer lines, 
c     and a different one for atomic lines
      do j=1,nlines+nstrong
         iatom = atom1(j)
         atom10 = 10.*atom1(j)
         e(j,2) =  e(j,1) + 1.239d+4/wave1(j)


c*****here are the calculations specific to molecular lines
         if (iatom .ge. 100) then
            call sunder (atom1(j),ia,ib)
            if (ia .gt. ib) then
               write (*,1010) ia,ib
               stop
            endif
            if (atom10-int(atom10) .le. 0.0) then
               amass(j) = xam(ia) + xam(ib)    
               mas1 = xam(ia) + 0.0000001
               mas2 = xam(ib) + 0.0000001
            else 
               jat100 = int(100.*(atom10+0.00001))
               mas1 = jat100 - 100*int(atom10)
               jat10000 = int(10000.*(atom10+0.00001))
               mas2 = jat10000 - 100*jat100
               if (mas1.gt.mas2 .or. mas1.le.0.0 .or. 
     .             mas2.le.0.0) then
                  write (*,1011) mas1, mas2
                  stop
               endif
               amass(j) = mas1 + mas2
            endif
c*****use an internal dissociation energy for molecules if the user
c     does not read one in
            if (d0(j) .eq. 0.) then
               do k=1,110
                  if (int(datmol(1,k)+0.01) .eq.
     .                int(atom1(j)+0.01)) then
                     d0(j) = datmol(2,k)
                     go to 390
                  endif
                enddo
                write (*,1013) atom1(j)
                stop
            endif
390         rdmass(j) = mas1*mas2/amass(j)
            chi(j,1) = 0.
            chi(j,2) = 0.
            chi(j,3) = 0.


c*****here are the calculations specific to atomic lines
         else
            if (atom10-int(atom10) .le. 0.0) then
               amass(j) = xam(iatom)
            else 
               atom10 = atom10 + 0.00001
               amass(j) = int(1000*(atom10-int(atom10)))
            endif
            rdmass(j) = 0.
            chi(j,1) = xchi1(iatom)
            chi(j,2) = xchi2(iatom)
            chi(j,3) = xchi3(iatom)
         endif
      enddo


c*****quit the routine normally
      if (nlines+nstrong .lt. 2500) then
         if (sstop .gt. wave1(nlines)+10.) sstop = wave1(nlines)+10.
      endif
      lim1line = 1
      return  


c****prepare to get another chunk of line data 
4     n2 = n1marker + lim1line - 1
      n1marker = n2
      rewind nflines
      do j=1,n2
         read (nflines,1001)
      enddo
      start = wave
      go to 302


c*****format statements
1001  format (a80)
1002  format (7e10.3)
1003  format ('INPUT STRONG LINE: LAMBDA = ', f10.3, ' AND ID = ',
     .        f6.1, ' CANNOT BE DONE!'/
     .        'NO TRIPLE OR GREATER IONS; I QUIT!')
1004  format (/'For these computations, some abundances have ',
     .       ' been altered:')
1005  format ('Changing overall metallicity: ', f6.2, ' dex')
1006  format ('ALL abundances NOT listed below differ ',
     .        'from solar by ', f6.2, ' dex')
1007  format ('element ', a2, ':  abundance = ', f5.2)
1008  format ('element ', a2, ':  abundance = ', f5.1)
1010  format ('ATOMIC NUMBERS IN MOLECULAR NAME (',
     .        2i2, ') ARE IN WRONG ORDER'/'I QUIT!!!')
1011  format ('ISOTOPIC MASS NUMBERS IN MOLECULAR NAME (',
     .        2i3, ') ARE IN WRONG ORDER OR ARE WEIRD;'/'I QUIT!!!')
1013  format (f6.1, ' IS AN UNKOWN MOLECULE; I QUIT!')
1014  format ('Isotopic Ratios given for this synthesis')
1015  format ('Isotopic Ratio: [', i4, '/', f10.5, '] = ', f10.3)
      

      end

      subroutine synpop
c******************************************************************************
c     Synthetic spectrum routine for stellar populations; usually meant for
c     integrated light spectra.  
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Quants.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Pstuff.com'
      include 'Multimod.com'
      real*8 tempspec(5,10000), rspec(10000)
      character*80 holdline(5,30)
      character*80 line

  
c*****read the parameter file 
      call params


c*****open the model table input file and the summary table output file;
c     read the information from the table input file
      call tablepop (2)


c*****open the standard output file
60    nf1out = 20
      lscreen = 8
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)


c*****FIRST PASS:  For each model, compute a raw synthetic spectrum;
c*****the starting do/if loops are for isotopic things only
      xhyd = 10.0**xsolar(1)
      do mmod=1,modtot
         if (numiso .gt. 0) then
            if (nisos .gt. 0) then
               do k=1,numiso
                  do l=1,nisos
                     if (isotope(k) .eq. isospecial(l)) then
                        do m=1,numisosyn
                           isoabund(k,m) = fracspecial(mmod,l)
                        enddo
                     endif
                  enddo
               enddo
            endif
         endif


c*****read in the model atmospheres and their summary output files
         line = synpre
         num = 80
         call getcount (num,line)
         if (mmod .lt. 10) then
            write (line(num+1:num+1),1013) mmod
         else
            write (line(num+1:num+2),1014) mmod
         endif
         nf2out = 21
         fmodoutput(mmod) = line
         f2out = fmodoutput(mmod)
         lscreen = 12
         array = 'INDIVIDUAL MODEL RAW SYNTHESIS OUTPUT'
         nchars = 37
         call infile ('output ',nf2out,'formatted  ',0,nchars,
     .                f2out,lscreen)
         line = modpre
         num = 80
         call getcount (num,line)
         if (mmod .lt. 10) then
            write (line(num+1:num+1),1013) mmod
         else
            write (line(num+1:num+2),1014) mmod
         endif
         nfmodel = 30
         fmodinput(mmod) = line
         fmodel = fmodinput(mmod)
         lscreen = 14
         array = 'INDIVIDUAL MODEL ATMOSPHERE'
         nchars = 27
         call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .                fmodel,lscreen)
         call inmodel
         write (nf2out,1001) moditle


c*****change the "default" abundances to be the ones read from the table file
         do i=1,nabs
            iabund = nint(elspecial(i))
            xabu(iabund) = 10.**abspecial(mmod,i)/xhyd
         enddo


c*****open the line list file and the strong line list file
         nflines = 31
         lscreen = 16
         array = 'THE LINE LIST'
         nchars = 13
         call infile ('input  ',nflines,'formatted  ',0,nchars,
     .                flines,lscreen)
         if (dostrong .gt. 0) then
            nfslines = 32
            lscreen = 18
            array = 'THE STRONG LINE LIST'
            nchars = 20
            call infile ('input  ',nfslines,'formatted  ',0,nchars,
     .                   fslines,lscreen)
         endif


c*****do the syntheses
         ncall = 1
         if (numpecatom .eq. 0 .or. numatomsyn .eq. 0) then
            isorun = 1
            nlines = 0
            mode = 3
            call inlines (1)
            call eqlib
            call nearly (1)
            call synspec
         else
            do n=1,numatomsyn
               isynth = n
               isorun = n
               start = oldstart
               sstop = oldstop
               mode = 3
               call inlines (1)
               call eqlib
               call nearly (1)
               call synspec
               linprintopt = 0
            enddo
         endif
         fluxmod(mmod,1) = flux
         call finish (0)
      enddo


c*****clear the mean spectrum array and the information array
      do i=1,5
         do j=1,10000
            tempspec(i,j) = 0.
         enddo
      enddo
      do i=1,5
         do j=1,30
            write (holdline(i,j),1008)
         enddo
      enddo


c*****open the file where the mean raw spectrum will be written
      nf9out = 23
      lscreen = 10
      array = 'MEAN RAW SYNTHESIS OUTPUT'
      nchars = 25
      call infile ('output ',nf9out,'formatted  ',0,nchars,
     .             f9out,lscreen)


c*****compute normalized weights
      weighttot = 0.
      do mmod=1,modtot
         weightmod(mmod,1) = fluxmod(mmod,1)*radius(mmod)**2*      
     .                             relcount(mmod)
         weighttot = weighttot + weightmod(mmod,1)
      enddo
      do mmod=1,modtot
         weightmod(mmod,1) = weightmod(mmod,1)/weighttot
      enddo
      

c*****read back the syntheses, compute the weighted average 
      do mmod=1,modtot
         newunit = 26
         open (newunit,file=fmodoutput(mmod))
         read (newunit,1001) line
         do j=1,numatomsyn
            lincount = 0
50          read (newunit,1001) line
            lincount = lincount + 1
            if (mmod .eq. 1) write (holdline(j,lincount),1001) line
            if (line(1:5) .eq. 'MODEL') then
               read (newunit,1001) line
               lincount = lincount + 1
               if (mmod .eq. 1) write (holdline(j,lincount),1001) line
               read (line,*) wavemod1, wavemod2, wavestep
               nw1 = nint(1000.*wavemod1)
               nw2 = nint(1000.*wavemod2)
               nws = nint(1000.*wavestep)
               nnn = (nw2-nw1)/nws + 1
               read (newunit,*) (rspec(n),n=1,nnn)
               do n=1,nnn
                  tempspec(j,n) = tempspec(j,n) + weightmod(mmod,1)*
     .                            rspec(n)
               enddo
            else
               go to 50
            endif
         enddo
         close (unit=newunit)
      enddo


c     write the average spectrum back to disk.
      line(1:7) = 'MODEL: '
      line(8:80) = popitle(1:73) 
      do j=1,numatomsyn
         holdline(j,lincount-1) = line
         write (nf9out,1001) (holdline(j,l),l=1,lincount)
         write (nf9out,1003) (tempspec(j,n),n=1,nnn)
      enddo
      close (unit=nf9out)


c*****now plot the spectrum
      if (plotopt.eq.2 .and. specfileopt.gt.0) then
         nfobs = 33
         lscreen = 12
         array = 'THE OBSERVED SPECTRUM'
         nchars = 21
         if (specfileopt.eq.1 .or. specfileopt.eq.3) then
            call infile ('input  ',nfobs,'unformatted',2880,nchars,
     .                   fobs,lscreen)
         else
            call infile ('input  ',nfobs,'formatted  ',0,nchars,
     .                   fobs,lscreen)
         endif
      endif
      if (plotopt .ne. 0) then
         nf2out = nf9out
         f2out = f9out
         nf2out = 21
         lscreen = lscreen + 2
         array = 'RAW SYNTHESIS OUTPUT'
         nchars = 20
         call infile ('output ',nf2out,'formatted  ',0,nchars,
     .                f2out,lscreen)
         nf3out = 22
         lscreen = lscreen + 2
         array = 'SMOOTHED SYNTHESES OUTPUT'
         nchars = 25
         call infile ('output ',nf3out,'formatted  ',0,nchars,
     .                f3out,lscreen)
         if (f5out .ne. 'optional_output_file') then
            nf5out = 26
            lscreen = lscreen + 2
            array = 'POSTSCRIPT PLOT OUTPUT'
            nchars = 22
            call infile ('output ',nf5out,'formatted  ',0,nchars,
     .                   f5out,lscreen)
         endif
         if (plotopt .eq. 3) then
            call smooth (-1,ncall)
            choice = 'q'
         else
            call pltspec (lscreen,ncall)
         endif


c*****if needed, loop back with abundance changes
         if (choice .eq. 'n') then
            call chabund
            if (choice .eq. 'q') go to 60
         endif
      endif


c*****format statements
1001  format (a80)
1002  format ('POPULATION SYNTHESIS FOR INTEGRATED-LIGHT SPECTRA'/a80)
1003  format (10f8.4)
1004  format (a30, 2x, a10, 3f8.0)
1005  format ('#models =', i3, 5x, 'total weight =', f7.2//
     .        ('model#', i5, 5x, 'relative weight', f8.2))
1006  format (i3, 1x, f8.0, 2f8.2, 10f6.2)
1008  format (80(' '))
1009  format ('SPECIAL ELEMENTS OR NAMES OF ISOTOPES'/(10i8))
1010  format ('NO DECLARED SPECIAL ELEMENTS')
1011  format ('SPECIAL ISOTOPE NAMES'/((5f10.5)))
1012  format ('NO DECLARED SPECIAL ISOTOPES')
1013  format (i1)
1014  format (i2)
1015  format (6f13.5)


      end

      subroutine trudamp (linnum)
c*************************************************************************
c     This routine calculates damping parameters for lines that have
c     accurately known laboratory damping parameters
c     THE USER IS WARNED THAT THESE FORMULAE ARE OLD AND NOT EASILY 
c     DEFENDED; THE BARKLEM NUMBERS ARE TO BE PREFERRED.
c*************************************************************************
      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'


c*****begin with some calculations leading to a c6 value ("unsold")
      j = linnum
      iwave = int(wave1(j))
      iatom10 = nint(10.*atom1(j))
      ich = nint(charge(j))
      unsold = dabs(1.61d-33*(13.5*charge(j)/(chi(j,ich) -
     .         e(j,1)))**2 - 1.61d-33*(13.5*charge(j)/
     .         (chi(j,ich)-e(j,2)))**2)


c*****Ca II "IR triplet" lines at the Ca II K line at 3934 A
      if (iatom.eq.201 .and. iwave.eq.3933) then
         do i=1,ntau
            gammaa = 1.45d+8 
            gnature = gammaa + 0.5*1.5d-9*t(i)**(1/3)*numdens(1,1,i)
            gvander = 1.6d-8 * (t(i)/5000.)**0.3 * numdens(1,1,i)
            gstark = 3.0d-6 * ne(i)
            gammadamp = anature + gvander + gstark
            a(j,i) = gammadamp*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            write (nf1out,1001) gnature, gstark, gvander,
     .                          gammadamp, a(j,i)             
         enddo                                                
         return


c*****Ca II "IR triplet" lines at 8498, 8542, and 8662 A
      elseif (iatom10.eq.201 .and.
     .        (iwave.eq.8498.or.
     .         iwave.eq.8542.or.
     .         iwave.eq.8662)) then
         write (nf1out,1000)
         do i=1,ntau
            nhe = xabund(2)*nhtot(i)
            gnature = 1.5e+08
            gstark  = 1.5e-06*ne(i)*(t(i)/5000.)**0.1666
            ghelium = 3.0e-09*nhe*(t(i)/5000.)**0.4 
            ghydro  = 1.0e-08*nhtot(i)*(t(i)/5000.)**0.4 
            gammadamp = gnature/2. + gstark + ghelium + ghydro 
            a(j,i) = gammadamp*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))  
            gvander = 17.0*unsold**0.4*v1**0.6*nhtot(i)       
            avander = gvander*wave1(j)*1.0d-8/(12.56636*dopp(j,i))  
            write (nf1out,1001) gnature, gstark, ghelium, ghydro,
     .                          gammadamp, a(j,i), avander
         enddo
         return


c*****Ca I 6717 A
      elseif (iatom10.eq.200 .and. iwave.eq.6717) then
         write (nf1out,1002) iwave
         do i=1,ntau
            nhe = xabund(2)*nhtot(i)
            gnature = 0.4e-08
            ghelium = 1.0e-09*nhe*(t(i)/5000.)**0.4 
            ghydro  = 2.0e-08*nhtot(i)*(t(i)/5000.)**0.4 
            gammadamp = gnature/2. + ghelium + ghydro 
            gammadamp = gammadamp*2.
            a(j,i) = gammadamp*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008)) 
            gvander = 17.0*unsold**0.4*v1**0.6*nhtot(i)       
            avander = gvander*wave1(j)*1.0d-8/(12.56636*dopp(j,i))  
            write (nf1out,1001) gnature, ghelium, ghydro,
     .                          gammadamp, a(j,i), avander
         enddo
         return


c*****Ca I 6318, 6343, 6361 A autoionization lines
      elseif (iatom10.eq.200 .and. 
     .        (iwave.eq.6318 .or.
     .         iwave.eq.6343 .or.
     .         iwave.eq.6361)) then
         write (nf1out,1005) iwave
         do i=1,ntau
            if (dampnum(j) .eq. 0) then
               gnature = 1.5d12
            else
               gnature = dampnum(j)*1.5d12
            endif
            gammadamp = gnature
            a(j,i) = gammadamp*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            write (nf1out,1001) gnature, gammadamp, a(j,i)
         enddo
         return


c*****Na I lines
      elseif (iatom .eq. 110) then
         write (nf1out,1003) iwave
         do i=1,ntau
            gnature = 2.21e+15/wave1(j)**2
            v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))
            gvander = 17.0*unsold**0.4*v1**0.6*nhtot(i)       
            gcoll   = gvander*2.1
            gammadamp = gnature/2. + gcoll
            a(j,i) = gammadamp*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            avander = gvander*wave1(j)*1.0d-8/(12.56636*dopp(j,i))  
            write (nf1out,1001) gnature, gcoll, gammadamp, 
     .                          a(j,i), avander
         enddo
         return


c*****CH autoionization line at 3693 A
      elseif (iatom10.eq.1060 .and.
     .        iwave.eq.3693) then
         write (nf1out,1006) iwave
         do i=1,ntau
            if (dampnum(j) .eq. 0) then
               gnature = 4.0d11
            else
               gnature = dampnum(j)*4.0d11
            endif
            gammadamp = gnature
            a(j,i) = gammadamp*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            write (nf1out,1001) gnature, gammadamp, a(j,i)
         enddo
         return
      endif


c*****format statements
1000  format(//' LINE BROADENING PARAMETERS FOR ',
     .       'CaII INFRARED TRIPLET'/
     .       4x,'natural',6x,'stark',5x,'helium',3x,'hydrogen',
     .       6x,'gammadamp',5x,'a(j,i)',5x,'a(VdW)')
1001  format (1p7e11.3)
1002  format(//' LINE BROADENING PARAMETERS FOR ',
     .       'CaI LINE AT',i6/
     .       4x,'natural',5x,'helium',3x,'hydrogen',
     .       6x,'gammadamp',5x,'a(j,i)',5x,'a(VdW)')
1003  format(//' LINE BROADENING PARAMETERS FOR ',
     .       'NaI LINE AT',i6/
     .       4x,'natural',4x,'VdW*1.2',6x,'gammadamp',
     .       5x,'a(j,i)',5x,'a(VdW)')
1004  format(//' LINE BROADENING PARAMETERS FOR ',
     .       'CaI LINE AT 6318A'/
     .       4x,'natural',6x,'Stark',4x,'vdwaals',
     .       6x,'gammadamp',5x,'a(j,i)')
1005  format(//' LINE BROADENING PARAMETERS FOR ',
     .       'THE CaI AUTOIONIZATION LINE AT',i6/
     .       4x,'natural', 2x,'gammadamp',5x,'a(j,i)')
1006  format(//' LINE BROADENING PARAMETERS FOR ',
     .       'THE CH AUTOIONIZATION LINE AT',i6/
     .       4x,'natural', 2x,'gammadamp',5x,'a(j,i)')


      end

      subroutine setmols
c******************************************************************************
c     This subroutine is invoked at the end of each call to *eqlib*:
c     it transfers some of the output number densities to arrays needed
c     for opacities, etc.
c****************************************************************************** 

      implicit real*8 (a-h,o-z) 
      include 'Atmos.com'
      include 'Mol.com'
      include 'Dummy.com'
      integer nel(7)
      integer append
      data (nel(i),i=1,7)/  1,  2,  6, 12, 13, 14, 26/


c     In the number density array "numdens", the elements denoted by
c     the first subscripts are named in at the ends of the assignment
c     lines; at present these are the only ones needed for continuous 
c     opacities
c     the desired elements are H, He, C, Mg, Al, Si, Fe, along
c     with the H_2 molecule
c     first do the neutrals
      do j=1,7
         do k=1,neq
            if (nel(j) .eq. iorder(k)) then
               do i=1,ntau
                  numdens(j,1,i) = xamol(k,i)
               enddo
               exit
            endif
         enddo
      enddo


c*****then do the ions
      do j=1,7
         ispec10 = nint(dble(10*nel(j)+1))
         do k=1,nmol
            kmol10 = nint(10.*amol(k))
            if (ispec10 .eq. kmol10) then
               do i=1,ntau
                  numdens(j,2,i) = xmol(k,i)
               enddo
               exit
            endif
         enddo
      enddo


c*****finally add in H_2
      do k=1,nmol
         ispec = 101
         if (ispec .eq. nint(amol(k))) then
            do i=1,ntau
               numdens(8,1,i) = xmol(k,i)
            enddo
            exit
         endif
      enddo


c*****compute partitiion functions for H_2O and CO_2; 
      do i=1,ntau
         h2olog = 0.
         co2log = 0.
         if (t(i) .gt. 5000.) then
            uh2o(i) = 1.d8
            uco2(i) = 1.d8
         else
            do j=1,5
               h2olog = h2olog + h2ocoeff(j)*t(i)**(j-1)
               co2log = co2log + co2coeff(j)*t(i)**(j-1)
            enddo
            uh2o(i) = 10**h2olog
            uco2(i) = 10**co2log
         endif
      enddo


c*****transfer H_2O and CO_2 number densities from the molecular 
c     equilibrium output
c     note:  HITRAN partition functions are given only for T < 5000K
      do j=1,nmol
         if (nint(amol(j)) .eq. 10108) ih2o = j
         if (nint(amol(j)) .eq. 60808) ico2 = j
      enddo
      do i=1,ntau
         xnh2o(i) = xmol(ih2o,i)
         xnco2(i) = xmol(ico2,i)
      enddo
         
      
c*****yes, perhaps not the most efficient coding, but it works - I hope
      return

      end

 
      subroutine fluxplot
c******************************************************************************
c     This subroutine creates plots of flux curves
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Dummy.com'
      include 'Pstuff.com'
      real*8 wavep(2000), fluxp(2000)
      real*4 waveplot(2000), flxplt(2000)
      real*4 style(1)


c*****dump the data into working arrays
      rewind nf2out
      i = 1
1     read (nf2out,*,end=10) wavep(i), fluxp(i), waveplot(i), flxplt(i)
      i = i + 1
      go to 1


c*****define the plot boundaries
10    ntot = i - 1
      xlo = int(waveplot(1))
      xhi = int(waveplot(ntot))
      ylo =  1.e+30
      yhi = -1.e+30
      do i=1,ntot
         ylo = amin1(ylo,flxplt(i))
         yhi = amax1(yhi,flxplt(i))
      enddo
      ylo = real(int(ylo+0.5001)) - 0.5
      yhi = real(int(yhi+0.5001)) + 0.5


c*****start the plot via some setup calls
      call sm_location (3500,31000,5000,31000)
      call sm_limits (xlo,xhi,ylo,yhi)
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)
 
 
c*****draw and label the box for the curve-of-growth
      call sm_expand (0.6)
      call sm_lweight (1.4)
      call defcolor (1)
      call sm_box (0,0,0,0)
      call sm_expand (1.0)
      call sm_box (1,2,4,4)
      array = '1/lambda'
      call sm_relocate (0.5*(xlo+xhi),ylo-0.20*(yhi-ylo))
      call sm_putlabel (5,array)
      array = 'log (flux)'
      call sm_relocate (xlo-0.10*(xhi-xlo),0.5*(yhi+ylo))
      call sm_angle (90.)
      call sm_putlabel (5,array)
      call sm_angle (0.)
      call sm_ltype (1)
      call sm_lweight (0.8)
      call sm_grid (0,0)
      call sm_ltype (0)


c*****plot the computed flux curve points
      call sm_expand (1.0)
      call defcolor (2)
      style(1) = 240.7
      call sm_ptype (style,1)
      call sm_points (waveplot,flxplt,ntot)
      call defcolor (1)
      call sm_relocate ((xhi+xlo)/2.0,ylo+0.07*(yhi-ylo))
      call sm_putlabel (5,moditle)


c*****compute total flux and effective temperature; exit normally
      do i=1,ntot
         wavep(i) = 1.0d-8*wavep(i)
      enddo
      first =  fluxp(1)
      fluxtot = rinteg(wavep,fluxp,dummy3,ntot,first)
      teff = (3.14159*fluxtot/5.67d-5)**0.25
      write (smitle,1001) fluxtot, teff
      call defcolor (5)
      call sm_relocate ((xhi+xlo)/2.0,ylo+0.14*(yhi-ylo))
      call sm_putlabel (5,smitle)
      return


c*****format statements
1001  format ('total flux = ' ,1pd12.4, 5x, 'Teff = ', 0pf6.0)
      end

      subroutine cdcalc (number)                                        
c******************************************************************************
c     this routine calculates continuum and line+continuum                  
c     contribution functions
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'

c*****continuum "contribution curve" calculation                           
      if (number .eq. 1) then
         do i=1,ntau                                                    
            scont(i) = ((1.19089d+25/wave**2)*1.0d+10)/(wave**3*
     .                 (dexp(1.43879d+08/(wave*t(i)))-1.0d+00))
            if (fluxintopt .eq. 1) then
               cd(i) = kaplam(i)*tauref(i)*scont(i)*
     .                 dexp(-taulam(i))/(0.4343*kapref(i))
            else
               cd(i) = 2.0*kaplam(i)*tauref(i)*scont(i)*
     .                 expint(taulam(i),2)/(0.4343*kapref(i))
            endif
         enddo
                       
c*****line plus continuum "contribution curve" calculation    
      else
         do i=1,ntau                                                    
            sline(i) = scont(i)   
            if (fluxintopt .eq. 1) then
               if (taulam(i)+taunu(i) .le. 50.) then
                  exptau = dexp(-taulam(i)-taunu(i))                
               else
                  exptau = 0.                        
               endif
               cd(i) = tauref(i)*kaplam(i)/(0.4343*flux*
     .                 kapref(i))*(scont(i)*dexp(-taulam(i)) - 
     .                 (1.0+kapnu(i)/kaplam(i))*sline(i)*exptau)    
            else
               cd(i) = 2.0*tauref(i)*kaplam(i)/(0.4343*flux*
     .                 kapref(i))*(scont(i)*expint(taulam(i),2) - 
     .                 (1.0+kapnu(i)/kaplam(i))*sline(i)*
     .                 expint(taulam(i)+taunu(i),2)) 
            endif
         enddo
      endif

c*****normal exit
      return


      end                                                               

      subroutine stats
c******************************************************************************
c     This routine does abundance statistics for a single species
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'

c*****compute the average and standard deviation
      average = 0.
      kount = 0
      do l=lim1obs,lim2obs
         if (abundout(l) .ne. 999.99) then
            average = average + abundout(l)
            kount = kount + 1
         endif
      enddo
      if (kount .gt. 0) then
         average = average/kount
      endif
      deviate = 0.
      if (kount .gt. 1) then
         do l=lim1obs,lim2obs
            if (abundout(l) .ne. 999.99) then
               deviate = deviate + (abundout(l)-average)**2
            endif
         enddo
         deviate = dsqrt(deviate/(kount-1))
      endif

         
c*****correlate the abundances with excitation potential, equivalent width,
c     and wavelength
      if (kount .gt. 2) then
         epmin = 999.
         epmax = -999.
         rwmin = 999.
         rwmax = -999.
         wvmin = 999999.
         wvmax = -999999.
         x1 = 0.
         x2 = 0.
         x3 = 0.
         x4 = 0.
         x5 = 0.
         x6 = 0.
         y1 = 0.
         y2 = 0.
         xy = 0.
         yz = 0.
         za = 0.

         do l=lim1obs,lim2obs
            if (abundout(l) .ne. 999.99) then
c              rw = dlog10(wid1comp(l)/wave1(l))
               rw = dlog10(width(l)/wave1(l))
               x1 = x1 + e(l,1)
               x2 = x2 + e(l,1)**2
               x3 = x3 + rw
               x4 = x4 + rw**2
               x5 = x5 + wave1(l)
               x6 = x6 + wave1(l)**2
               y1 = y1 + abundout(l)
               y2 = y2 + abundout(l)**2
               xy = xy + e(l,1)*abundout(l)
               yz = yz + rw*abundout(l)
               za = za + wave1(l)*abundout(l)
               if (e(l,1) .lt. epmin) epmin = e(l,1)
               if (e(l,1) .gt. epmax) epmax = e(l,1)
               if (rw .lt. rwmin) rwmin = rw
               if (rw .gt. rwmax) rwmax = rw
               if (wave1(l) .lt. wvmin) wvmin = wave1(l)
               if (wave1(l) .gt. wvmax) wvmax = wave1(l)
            endif
         enddo

         xxm1 =    (kount*xy - x1*y1)/(kount*x2 - x1**2)
         xxb1 =    (y1*x2 - xy*x1)/(kount*x2 - x1**2)
         xxr1 =    (kount*xy - x1*y1)/dsqrt((kount*x2 - x1**2)*
     .             (kount*y2 - y1**2))
         deltaep = epmax - epmin

         xxm2 =    (kount*yz - x3*y1)/(kount*x4 - x3**2)
         xxb2 =    (y1*x4 - yz*x3)/(kount*x4 - x3**2)
         xxr2 =    (kount*yz - x3*y1)/dsqrt((kount*x4 - x3**2)*
     .             (kount*y2 - y1**2))
         deltarw = rwmax - rwmin

         xxm3 =    (kount*za - x5*y1)/(kount*x6 - x5**2)
         xxb3 =    (y1*x6 - za*x5)/(kount*x6 - x5**2)
         xxr3 =    (kount*za - x5*y1)/dsqrt((kount*x6 - x5**2)*
     .             (kount*y2 - y1**2))
         deltawv = wvmax - wvmin

      endif

      return
      end
  

      subroutine pointcurs
c******************************************************************************
c     This subroutine returns the cursor position upon a click
c******************************************************************************

      include 'Pstuff.com'
      integer ichr


      call sm_graphics
      if     (whichwin .eq. '1of1') then
         call sm_window (1,1,1,1,1,1)
      elseif (whichwin .eq. '2of2') then
         call sm_defvar ('y_gutter','0.0')
         call sm_window (1,2,1,1,1,1)
      endif
      call sm_curs (xplotpos,yplotpos,ichr)
      call sm_gflush
      call sm_alpha

      
      return
      end

      subroutine finish (number)
c******************************************************************************
c     This routine simply wraps up MOOG
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Pstuff.com'


c  close the files
      if (nfmodel .ne. 0)      close (unit=nfmodel)
      if (nflines .ne. 0)      close (unit=nflines)
      if (nfslines .ne. 0)     close (unit=nfslines)
      if (nftable .ne. 0)      close (unit=nftable)
      if (nfobs .ne. 0)        close (unit=nfobs)
      if (nf1out .ne. 0)       close (unit=nf1out)
      if (nf2out .ne. 0)       close (unit=nf2out)
      if (nf3out .ne. 0)       close (unit=nf3out)
      if (nf4out .ne. 0)       close (unit=nf4out)
      if (nf5out .ne. 0)       close (unit=nf5out)
      if (control .ne. 'gridsyn' .and. control .ne. 'gridplo') then
         if (nf6out .ne. 0)    close (unit=nf6out)
         if (nf7out .ne. 0)    close (unit=nf7out)
         if (nf8out .ne. 0)    close (unit=nf8out)
         if (nf9out .ne. 0)    close (unit=nf9out)
         if (nf10out .ne. 0)   close (unit=nf10out)
      endif

c  write the closing message
      if (number .eq. 0) then
         istat = ivcleof (4,1)
         write (array,1001) 
         istat = ivwrite (5,1,array,79)
      endif
      return


c*****format statements
1001  format (22('<'),10x,'MOOG HAS ENDED!',10x,22('>'))


      end
      

      subroutine opacit (modeop,waveop)
c******************************************************************************
c     This routine calculates the continuous opacity *kaplam* or            
c     *kapref* and optical depth *taulam* as needed. the formulas are       
c     ones lifted from the write-up of program *atlas*                      
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Kappa.com'
      include 'Dummy.com'
      real*8 taucheck(100), tauinteg(100)


c*****initialization                                                        
      freq = 2.997925d18/waveop 
      freqlg = dlog(freq)
      do i = 1,ntau
         hkt = 6.6256d-27/(1.38054d-16*t(i))
         evhkt(i) = dexp(-freq*hkt)
      enddo
      do i=1,ntau
         aH1(i) =      1.d-99
         aHminus(i) =  1.d-99
         aHeminus(i) = 1.d-99
         aC1(i) =      1.d-99
         aMg1(i) =     1.d-99
         aMg2(i) =     1.d-99
         aAl1(i) =     1.d-99
         aSi1(i) =     1.d-99
         aSi2(i) =     1.d-99
         aFe1(i) =     1.d-99
      enddo


c*****compute the opacities
       call opacH1
       call opacHminus
       call opacHscat
       call opacH2scat
       call opacHeminus
       call opacHescat
       call opacescat
       call opacC1
       call opacMg1
       call opacMg2
       call opacAl1
       call opacSi1
       call opacSi2
       call opacFe1


c*****sum up all the opacities
      do i=1,ntau
         kaplamabs(i) = aH1(i) + aHminus(i) + aHeminus(i) + aC1(i) + 
     .                  aMg1(i) + aMg2(i) + aAl1(i) + aSi1(i) +
     .                  aSi2(i) + aFe1(i)
         kaplamsca(i) = sigH(i) + sigH2(i) + sigHe(i) + sigel(i)
         kaplam(i)    = kaplamabs(i) + kaplamsca(i)
      enddo


c*****write out the opacities
      if (modprintopt .gt. 1) then
         write (nf1out,1001) waveop
         do i=1,ntau
            write (nf1out,1002) i, nint(t(i)), dlog10(kaplam(i)),
     .      dlog10(aH1(i)), dlog10(aHminus(i)), dlog10(sigH(i)), 
     .      dlog10(aHeminus(i)), dlog10(sigHe(i)), dlog10(sigel(i)),
     .      dlog10(sigH2(i))
         enddo
         write (nf1out,1003) waveop
         do i=1,ntau
            write (nf1out,1002) i, nint(t(i)), dlog10(kaplam(i)),
     .      dlog10(aC1(i)),  dlog10(aMg1(i)), dlog10(aMg2(i)), 
     .      dlog10(aAl1(i)), dlog10(aSi1(i)), dlog10(aSi2(i)), 
     .      dlog10(aFe1(i))
         enddo
      endif


c*****add in an arbitrary amount of "extra" continuous opacity;
c     this is a pure fudge factor, so experiment with care
      if (fudge .gt. 0.0) then
         do i=1,ntau
            kaplam(i) = kaplam(i)*((fudge*10000)/t(i))
            if (i .eq. 1) then
               write(nf1out,1005)
               write(nf1out,1006) fudge
            endif
         enddo
      endif


c*****compute an optical depth array at this wavelength, and exit
      if (modeop .ne. 1) then
         do  i=1,ntau
            dummy1(i) = tauref(i)*kaplam(i)/(0.4343*kapref(i))
         enddo
         first = tauref(1)*kaplam(1)/kapref(1)
         dummy1(1) = rinteg(xref,dummy1,taulam,ntau,first)
         taulam(1) = first
         do i=2,ntau
            taulam(i) = taulam(i-1) + taulam(i)
         enddo
         if (modprintopt .gt. 1) write(nf1out,1004) (taulam(i),i=1,ntau)
         return
      endif


c*****here is the assignment of opacities kaplam to kapref; exit normally
      do i=1,ntau
         kapref(i) = kaplam(i)
      enddo
      if(modprintopt .lt. 2) return


c*****here is an internal tauref check on the externally read in tau scale;
c     then exit normally
      do i=1,ntau
         dummy1(i) = dlog10(tauref(i))
         tauinteg(i) = tauref(i)*kaplam(i)/(0.4343*kapref(i))
      enddo
      first = tauref(1)
      tauinteg(1) = rinteg(dummy1,tauinteg,taucheck,ntau,first)
      taucheck(1) = first
      do i=2,ntau
         taucheck(i) = taucheck(i-1) + taucheck(i)
      enddo
      write (nf1out,1004) (taucheck(i),i=1,ntau)
      return


c*****format statements
1001  format (/'log opacities due to H, He, e- at a wavelength of ',
     .       f10.2,' A'/' i  T(i)  kaplam     aH1     aH-    sigH',
     .       '    aHe-   sigHe   sigel   sigH2')
1002  format (i2,i6,10f8.2)
1003  format (/'log opacities due to "metal" edges at a wavelength',
     .       ' of ',f10.2,' A'/' i  T(i)  kaplam     aC1    aMg1', 
     .       '    aMg2    aAl1    aSi1    aSi2    aFe1')
1004  format(/'COMPUTED TAULAM ARRAY'/(1p7e11.3))
1005  format ('Opacities artificially are now ',
     .        'altered by scaling law of: ')
1006  format ('      kaplam(i) = kaplam(i) * ',
     .        '((', f6.2, ' * 10000)/t(i))')


      end

      subroutine pltabun
c******************************************************************************
c     This subroutine controls the decisions that are made around the
c     plotting of individual line abundances
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'
      real*8 xnum
      real*4 shortnum


      if (kount .ge. plotopt) then
         if (plotopt .eq. 0) return
10       choice = 'y'
         plotroutine = 'term_port_abun'
         lscreen = maxline -2
c         call makeplot (lscreen)
         array = 'WHAT TO DO NEXT ([n]/h/f/r/m/v)? '
         lscreen = lscreen + 2
         nchars = 35
         call getasci (nchars,maxline)
         choice = chinfo(1:1)
         if (choice.eq.'n' .or. nchars.le.0) then
            return
         elseif (choice .eq. 'm') then
            return   
         elseif (choice .eq. 'v') then
            write (array,*) 'What is the new microturbulence (km/s)? '
            nchars = 41
            call getnum (nchars,lscreen,xnum,shortnum)
            do i=1,ntau
               vturb(i) = xnum*1.0e5
            enddo
            write (moditle(57:64),1010) xnum
            lim1line = 0
            lim2line = 0
            lim1obs = 0
            lim2obs = 0
            return   
         elseif (choice .eq. 'h') then
            plotroutine = 'hard_port_abun'
c            call makeplot (lscreen)
         elseif (choice .eq. 'r') then
            go to 10
         elseif (choice .eq. 'f') then
            plotroutine = 'file_port_abun'
c            call makeplot (lscreen)
         endif
      endif


      return


c*****format statements
1010  format ('vt=',f5.2)
      end

      subroutine readobs (line)
c******************************************************************************
c     this routine reads in observed spectra.  the format is indicated by
c     the value of "specfileopt"
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      include 'Obspars.com'
      byte      int1(2880), onebyte
      integer*2 int2(1440)
      integer*4 int4(720)
      real*4 real4(720)
      real*4 xtemp, ytemp
      equivalence (int1,int2,int4,real4)
      character head*2880


c*****first set some initial parameters
      write (obsitle,1021)
      iend = 0
      naxis = 1
      naxis1 = 0
      bscale = 0.
      bzero = 0.
      do j=1,9
         disp(j) = 0.
      enddo


c*****branch to the appropriate data file type
      go to (100,200,300,400,500), specfileopt


c*****here is a pure FITS file type. Reading is done with ordinary
c     FORTRAN read statements
c     first get the header records and search for key parameters
100   irec = 1
101   read (unit=nfobs,rec=irec,err=1002,iostat=ierr) head
      call obshead (head,iend,line)
      if (lount .eq. -1) return
      if (iend .eq. 0) then
         irec = irec + 1
         go to 101
      endif


c     next read the flux array from the file
      nrec = lount/nblock
      ipt = 0
      if (mod(lount,nblock) .ne. 0) nrec = nrec + 1
      do j=1,nrec
         irec = irec + 1
         jpt = min0(nblock,lount-ipt)
         if (ibits .eq. 16) then
            read (unit=nfobs,rec=irec,err=1006,iostat=ierr) int1
            if (byteswap .eq. 1) then
               do k=2,2880,2
                  onebyte = int1(k)
                  int1(k) = int1(k-1)
                  int1(k-1) = onebyte
               enddo
            endif
            do k=1,jpt
               yobs(ipt+k) = bzero + bscale*real(int2(k))
            enddo
         elseif (ibits .eq. 32) then
            read (unit=nfobs,rec=irec,err=1006,iostat=ierr) int1
            if (byteswap .eq. 1) then
               do k=4,2880,4
                  onebyte = int1(k)
                  int1(k) = int1(k-3)
                  int1(k-3) = onebyte
                  onebyte = int1(k-1)
                  int1(k-1) = int1(k-2)
                  int1(k-2) = onebyte
               enddo
            endif
            do k=1,jpt
               yobs(ipt+k) = bzero + bscale*real(int4(k))
            enddo
         elseif(ibits .eq. -32) then
            read (unit=nfobs,rec=irec,err=1006,iostat=ierr) int1
            if (byteswap .eq. 1) then
               do k=4,2880,4
                  onebyte = int1(k)
                  int1(k) = int1(k-3)
                  int1(k-3) = onebyte
                  onebyte = int1(k-1)
                  int1(k-1) = int1(k-2)
                  int1(k-2) = onebyte
               enddo
            endif
            do k=1,jpt
               yobs(ipt+k) = real4(k)
            enddo
         endif
         ipt = ipt + jpt
      enddo     


c     now adjust the continuum, if desired
      do j=1,lount
         yobs(j) = yobs(j)*contnorm
      enddo


c     now fill in the wavelength array
      do j=1,lount
         xobs(j) = sngl(wavecalc(sngl(dfloat(j)),lount,disp))
      enddo
      lim1obs = 1
      lim2obs = lount
      if(xobs(2) .lt. xobs(1)) then
         do j=1,lount/2
            xtemp = xobs(j)
            ytemp = yobs(j)
            xobs(j) = xobs(lount+1-j)
            yobs(j) = yobs(lount+1-j)
            xobs(lount+1-j) = xtemp
            yobs(lount+1-j) = ytemp
         enddo
      endif
      return
         

c     or if trouble, give error messages, and abort
1002  write(array,1003) ierr
      istat = ivwrite(line+2,3,array,39)
      go to 1007
1006  write(array,1004) ierr
      istat = ivwrite(line+2,3,array,39)
1007  lount = -1
      return


c*****this is a dummy for future file use
200   return


c*****this is a dummy for future file use
300   return


c*****this is a dummy for future file use
400   return


c*****here is a MONGO-style input array
500   rewind nfobs
      read (nfobs,5001) obsitle
      i = 1
501   read (nfobs,*,end=525) xobs(i),yobs(i)
      i = i + 1
      go to 501
525   lount = i - 1
      lim1obs = 1
      lim2obs = lount
      if(xobs(2) .lt. xobs(1)) then
         do j=1,lount/2
            xtemp = xobs(j)
            ytemp = yobs(j)
            xobs(j) = xobs(lount+1-j)
            yobs(j) = yobs(lount+1-j)
            xobs(lount+1-j) = xtemp
            yobs(lount+1-j) = ytemp
         enddo
      endif


c     now adjust the continuum, if desired
      do j=1,lount
         yobs(j) = yobs(j)*contnorm
      enddo
      return


c*****format statements
1003  format('ERROR IN FITS HEADER READ:   ERROR=',i4)
1004  format('ERROR IN DATA READ:  ERROR=',i4,'/')
1021  format (80(' '))
5001  format (a80)


      end

      real*8 function ucalc (atom,level)                             
c******************************************************************************
c     This routine decodes the partition function data. the source       
c     is the atlas program of kurucz                                     
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Quants.com'
      dimension scale(4) 
      data scale/0.001,0.01,0.1,1.0/ 

      if (level .gt. 500) then
         temp = level               
      else
         temp = t(level)           
      endif

      iatom = nint(atom)
      ion = nint(10.*(atom - float(iatom)))
      j = 4*(iatom-1) + ion + 1
    
      if (ion .eq. 0) then
         chix = xchi1(iatom)      
      elseif (ion .eq. 1) then
         chix = xchi2(iatom)     
      else
         chix = xchi3(iatom)
      endif

      t2000 = chix*2000./11.    
      it = max0(1,min0(9,idint(temp/t2000-0.5))) 
      dt = temp/t2000 - float(it) - 0.5         
      pmin = 1.                                
      i = (it+1)/2                            
      k1 = nudata(i,j)/100000                
      k2 = nudata(i,j) - k1*100000          
      k3 = k2/10                           
      kscale = k2 - k3*10                 
      if (mod(it,2) .eq. 0) then
         p1 = float(k3)*scale(kscale)    
         k1 = nudata(i+1,j)/100000      
         kscale = mod(nudata(i+1,j),10)
         p2 = float(k1)*scale(kscale) 
      else
         p1 = float(k1)*scale(kscale)
         p2 = float(k3)*scale(kscale)            
         if (dt .ge. 0.) go to 13                
         if (kscale .gt. 1.) go to 13           
         kp1 = p1                              
         if (kp1 .ne. idint(p2+0.5)) go to 13 
         pmin = kp1                          
      endif
13    ucalc = dmax1(pmin,p1+(p2-p1)*dt)

      return                                
      end 

      subroutine tablepop (option)
c******************************************************************************
c     this routine opens the table file containing information for a stellar
c     population, and reads the data in that file; the information is a
c     bit different for "abpop" and "synpop"
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Multimod.com'
      include 'Pstuff.com'
      integer option
      character*80 line

  
c*****open the model table input file and the summary table output file
      nftable = 18
      lscreen = 4
      array = 'MODEL TABLE INPUT FILE'
      nchars = 22
      call infile ('input ',nftable,'formatted  ',0,nchars,
     .             ftable,lscreen)      
      nf7out = 24
      lscreen = 6
      array = 'MODEL TABLE OUTPUT FILE'
      nchars = 18
      call infile ('output ',nf7out,'formatted  ',0,nchars,
     .             f7out,lscreen)


c*****read the table input for integrated light EW matching
      if (option .eq. 1) then
         read (nftable,1001) line
         if (line(1:5) .ne. 'abpop' ) then
            write(*,*) 'OOPS!  WRONG TABLE FOR ABPOP; I QUIT!'
            stop
         endif
         do i=1,1000
            read (nftable,1001) line
            if     (line(1:5) .eq. 'modpr') then
c			   if (silent .eq. 'n') then
	               call blankstring (modpre)
c			   endif
               modpre(1:70) = line(11:80)
            elseif (line(1:5) .eq. 'synpr') then
c			   if (silent .eq. 'n') then
	               call blankstring (synpre)
c			   endif
               synpre(1:70) = line(11:80)
            elseif (line(1:5) .eq. 'title') then
c			   if (silent .eq. 'n') then
	               call blankstring (abitle)
c			   endif
               popitle(1:74) = line(7:80)
               write (nf7out,1002) popitle(1:73)
            elseif (line(1:5) .eq. 'model') then
               do mmod=1,100
                  if (mmod .eq. 100) then
                     write(*,*) 'MORE THAN 99 MODELS; I QUIT!'
                     stop
                  endif
                  read (nftable,*,end=10) j, radius(mmod), 
     .                                    relcount(mmod)
               enddo
            endif
         enddo


c*****read the table input for integrated light spectrum syntheses
      else
         nabs = 0
         nisos = 0
         read (nftable,1001) line(1:80)
         if (line(1:6) .ne. 'synpop') then
            write (*,*) 'OOPS!  WRONG TABLE FOR SYNPOP; I QUIT!'
            stop
         endif
         do k=1,1000
            call blankstring (line)
            read (nftable,1001) line(1:80)
            if     (line(1:5) .eq. 'modpr') then
c			   if (silent .eq. 'n') then
	               call blankstring (modpre)
c			   endif
               modpre(1:70) = line(11:80)
            elseif (line(1:5) .eq. 'synpr') then
c			   if (silent .eq. 'n') then
	               call blankstring (synpre)
c			   endif
               synpre(1:70) = line(11:80)
            elseif (line(1:5) .eq. 'title') then
c			   if (silent .eq. 'n') then
	               call blankstring (popitle)
c			   endif
               popitle(1:74) = line(7:80)
               write (nf7out,1003) popitle(1:74)
            elseif (line(1:5) .eq. 'abund') then
               read (line(12:80),*) nabs
               if (nabs .gt. 0) then
                  read (nftable,1001) line(1:80)
                  read (line(1:80),*) (elspecial(i),i=1,nabs)
                  write (nf7out,1009) (nint(elspecial(i)),i=1,nabs)
               else
                  write (nf7out,1010)
               endif
            elseif (line(1:5) .eq. 'isoto') then
               read (line(10:80),*) nisos
               if (nisos .gt. 0) then
                  read (nftable,1001) line(1:80)
                  read (line(1:80),*) (isospecial(i),i=1,nisos)
                  write (nf7out,1011) (isospecial(i),i=1,nisos)
               else
                  write (nf7out,1012)
               endif
            elseif (line(1:5) .eq. 'model') then
               do mmod=1,100
                  if (mmod .eq. 100) then
                     write (*,*) 'MORE THAN 99 MODELS; I QUIT!'
                     stop
                  endif
                  if     (nabs.le.0 .and. nisos.le.0) then
                     read (nftable,*,end=10) j, radius(mmod),
     .                                       relcount(mmod)
                     write (nf7out,1006) j, radius(mmod), 
     .                                   relcount(mmod)     
                  elseif (nabs.gt.0 .and. nisos.le.0) then       
                     read (nftable,*,end=10) j, radius(mmod),    
     .                                       relcount(mmod),     
     .                                      (abspecial(mmod,i),i=1,nabs)
                     write (nf7out,1006) j, radius(mmod), 
     .                                   relcount(mmod),       
     .                                   (abspecial(mmod,i),i=1,nabs)  
                  elseif (nabs.le.0 .and. nisos.gt.0) then       
                     read (nftable,*,end=10) j, radius(mmod),    
     .                                       relcount(mmod),     
     .                                   (fracspecial(mmod,i),i=1,nisos)
                     write (nf7out,1006) j, radius(mmod), relcount(mmod)
                     write (nf7out,1015) (fracspecial(mmod,i),i=1,nisos)
                  else                                           
                     read (nftable,*,end=10) j, radius(mmod),    
     .                                       relcount(mmod),     
     .                                   (abspecial(mmod,i),i=1,nabs),
     .                                   (fracspecial(mmod,i),i=1,nisos)
                     write (nf7out,1006) j, radius(mmod), 
     .                                   relcount(mmod),       
     .                                   (abspecial(mmod,i),i=1,nabs)
                     write (nf7out,1015) (fracspecial(mmod,i),i=1,nisos)
                  endif                                          
               enddo                                             
            endif                                                
         enddo                                                   
      endif


c*****close the model input file, exit normally
 10   close (unit=nftable)
      modtot = mmod-1
      return


c*****format statements
1001  format (a80)
1002  format ('EQUIVALENT WIDTH ANALYSIS FOR INTEGRATED-LIGHT SPECTRA'//
     .        a80)
1003  format ('POPULATION SYNTHESIS FOR INTEGRATED-LIGHT SPECTRA'/a80)
1006  format (i3, 1x, f8.0, 2f8.2, 10f6.2)
1009  format ('SPECIAL ELEMENTS OR NAMES OF ISOTOPES'/(10i8))
1010  format ('NO DECLARED SPECIAL ELEMENTS')
1011  format ('SPECIAL ISOTOPE NAMES'/((5f10.5)))
1012  format ('NO DECLARED SPECIAL ISOTOPES')
1015  format (6f13.5)


      end

      subroutine damping (linnumber)
c******************************************************************************
c     This subroutine computes damping 'gamma' factors 
c     and then Voigt parameters 'a'
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'


      j = linnumber
      iwave = int(wave1(j))
      iatom10 = nint(10.*atom1(j))
      if (dampnum(j) .lt. 0.) dampnum(j) = 10.**dampnum(j)


c*****for a few lines, explicit detailed broadening terms have 
c     appeared in the literature, and so do these lines with a 
c     sepaarate subroutine
      if (itru .eq. 0) then
c     Ca II
         if (iatom10 .eq. 201) then
            if (iwave .eq. 8498 .or.
     .          iwave .eq. 8542 .or.
     .          iwave .eq. 8662 .or.
     .          iwave .eq. 3933) then
               call trudamp (j)
               damptype(j) = 'TRUEgam'
               return
            endif
c     CH
         elseif(iatom10 .eq. 1060) then
            if (iwave .eq. 3693) then
               call trudamp (j)
               damptype(j) = 'TRUEgam'
               return
            endif
c     Ca I
         elseif (iatom10 .eq. 200) then
            if (iwave.eq.6717 .or. iwave.eq.6318
     .          .or. iwave.eq.6343 .or. iwave.eq.6361) then
               call trudamp (j)
               damptype(j) = 'TRUEgam'
               return
            endif
c     Ca I autoionization
         elseif (iatom10 .eq. 200) then
            if (iwave.eq.6318 .or. 
     .          iwave.eq.6343 .or.
     .          iwave.eq.6361) then
               call trudamp (j)
               damptype(j) = 'TRUEgam'
               return
            endif
         endif
      endif
  

c*****here are the calculations to set up the damping; for atomic lines 
c     there are several options:
c        dampingopt = 0 and dampnum = 0 ---> 
c                             c6 = Unsold formula
c        dampingopt = 0 and dampnum < 10^(-15) ---> 
c                             c6 = dampnum
c        dampingopt = 0 and 10^(-15) < dampnum < 10^(-5) ---> 
c                             gamma = dampnum
c        dampingopt = 0 and dampnum(i) > 10^(-5) ---> 
c                             c6 =  (Unsold formula)*dampnum
c        dampingopt = 1 --->    
c                             gammav = gamma_Barklem if possible, 
c                                      otherwise use dampingopt=0 options
c        dampingopt = 2 ---> 
c                             c6 = c6_Blackwell-group
c        dampingopt = 3 and dampnum <= 10^(-10) --->             
c                             c6 = c6_NEXTGEN for H I, He I, H2
c        dampingopt = 3 and dampnum > 10^(-10) --->             
c                             c6 = (c6_NEXTGEN for H I, He I, H2)*dampnum
c     for molecular lines (lacking a better idea) --->
c                                        c6 done as in dampingopt = 0


c*****these damping calculations are done at each atmosphere level
      if (linprintopt .gt. 2) write (nf1out,1001) j, wave1(j)
      do i=1,ntau
         ich = nint(charge(j))
         v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))


c*****first calculate an Unsold approximation to gamma_VanderWaals
         if (atom1(j) .gt. 100.) then
            ebreakup = 7.0
         else 
            ebreakup = chi(j,ich)
         endif
         if (e(j,1).ge.ebreakup .or. e(j,2).ge.ebreakup) then
            unsold = 1.0e-33
         else
            unsold = dabs(1.61d-33*(13.598*charge(j)/(ebreakup -
     .               e(j,1)))**2 - 1.61d-33*(13.598*charge(j)/
     .               (ebreakup-e(j,2)))**2)
         endif


c*****dampingopt = 0 or 
c*****dampingopt = 1 and no Barklem data
         if     (dampingopt .eq. 0 .or.
     .          (dampingopt.eq.1 .and. gambark(j).lt.0)) then
            if     (dampnum(j) .eq. 0.0) then
               damptype(j) = 'UNSLDc6'
               gammav = 17.0*unsold**0.4*v1**0.6*numdens(1,1,i)
            elseif (dampnum(j) .lt. 1.0d-15) then
               damptype(j) = '   MYc6'
               gammav = 17.0*dampnum(j)**0.4*v1**0.6*numdens(1,1,i)
            elseif (dampnum(j) .lt. 1.0d-04) then
               damptype(j) = 'MYgamma'
               gammav = dampnum(j)*(t(i)/10000.)**0.3*numdens(1,1,i)
            else
               damptype(j) = 'MODUNc6'
               gammav = 
     .            17.0*(unsold*dampnum(j))**0.4*v1**0.6*numdens(1,1,i)
            endif


c*****dampingopt = 1 with extant Barklem data
         elseif (dampingopt.eq.1 .and. gambark(j).gt.0.) then
               damptype(j) = 'BKgamma'
               gammav =
     .            gambark(j)*(t(i)/10000.)**alpbark(j)*numdens(1,1,i)


c*****dampingopt = 2
         elseif (dampingopt .eq. 2) then
            damptype(j) = 'BLKWLc6'
            gammav = 17.0*((1.0 + 0.67*e(j,1))*unsold)**0.4*
     .               v1**0.6*numdens(1,1,i)


c*****dampingopt = 3
         elseif (dampingopt .eq. 3) then
            damptype(j) = 'NXTGNc6'
            if (dampnum(j) .le. 1.0d-10) dampnum(j) = 1.0
                 c6h = dabs(1.01d-32*(charge(j)**2)*
     .              (13.598/(ebreakup - e(j,1)))**2 - 1.61d-33*
     .              (13.598/(ebreakup-e(j,2)))**2)
                 c6he = dabs((0.204956/0.666793)*1.01d-32*
     .                  (charge(j)**2)*(13.598/(ebreakup - 
     .                  e(j,1)))**2 - 1.61d-33*(13.598/(ebreakup-
     .                  e(j,2)))**2)
                 c6ht = dabs((0.806/0.666793)*1.01d-32*
     .                  (charge(j)**2)*(13.598/(ebreakup - 
     .                  e(j,1)))**2 - 1.61d-33*(13.598/(ebreakup-
     .                  e(j,2)))**2)
               gammav = 17.0*v1**0.6*(c6h**0.4*numdens(1,1,i) +
     .                  c6he**0.4*numdens(2,1,i) +
     .                  c6ht**0.4*numdens(8,1,i))*dampnum(j)**0.4
         endif


c*****compute radiative broadening either by an approximate formula or 
c*****the value in Barklem.dat) 
         if (gamrad(j).ne.0.0 .and. dampingopt .eq. 1) then
            gammar = gamrad(j)
         else
            gammar = 2.223d15/wave1(j)**2
         endif
        

c*****now Stark broadening (approximate formulae)
         excdiff = chi(j,nint(charge(j))) - e(j,2)
         if (excdiff .gt. 0.0 .and. atom1(j).lt.100.) then
            effn2 = 13.6*charge(j)**2/excdiff
         else
            effn2 = 25.
         endif
         gammas = 1.0e-8*ne(i)*effn2**2.5


c*****now finish by summing the gammas and computing the Voigt *a* values
         gammatot = gammar + gammas + gammav
         a(j,i) = gammatot*wave1(j)*1.0d-8/(12.56636*dopp(j,i))
         if (linprintopt .gt. 2) write (nf1out,1002) i, gammar, 
     .      gammas, gammav, gammatot, a(j,i)
      enddo
      return


c*****format statements
1001  format(//' LINE BROADENING PARAMETERS FOR LINE', i4,
     .       ' AT WAVELENGTH ',f8.2/
     .       '  i',4x,'natural',6x,'Stark',4x,'VdWaals',
     .       6x,'total',5x,'a(j,i)')
1002  format (i3,1p5e11.3)


      end

 
      subroutine pltcog
c******************************************************************************
c     This subroutine controls the decisions that are made around the
c     plots of curves-of-growth
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Pstuff.com'
      real*8 xnum
      real*4 shortnum


c  call up the curve-of-growth plot
      if (plotopt .eq. 0) return
10    choice = 'y'
      plotroutine = 'term_land_cog '
      lscreen = 12
      whichwin = '1of1'
      call makeplot (lscreen)


c  make a hardcopy, write to a postscript file, point at a place on the
c  screen, try a new model atmosphere, or replot?
1     array = 'WHAT TO DO NEXT ([n]/h/f/p/v/m/r)? '
      lscreen = 12
      nchars = 37
      call getasci (nchars,lscreen)
      choice = chinfo(1:1)
      if (choice.eq.'n' .or. nchars.le.0) then
         return
      elseif (choice .eq. 'h') then
         plotroutine = 'hard_land_cog '
         call makeplot (lscreen)
         go to 10
      elseif (choice .eq. 'v') then
         write (array,*) 'What is the new microturbulence (km/s)? '
         nchars = 41
         lscreen = lscreen + 2
         call getnum (nchars,lscreen,xnum,shortnum)
         do i=1,ntau
            vturb(i) = xnum*1.0e5
         enddo
         write (moditle(57:64),1010) xnum
         rewind nf1out
         rewind nf2out
         rewind nfmodel
         rewind nflines
         return
      elseif (choice .eq. 'm') then
         return
      elseif (choice .eq. 'r') then
         go to 10
      elseif (choice .eq. 'p') then
         array = 'MARK THE POSITION WITH THE CURSOR'
         istat=ivcleof(21,1)
         istat=ivwrite(13,3,array,34)
         call drawcurs
         go to 1
      elseif (choice .eq. 'f') then
         plotroutine = 'file_land_cog '
         call makeplot (lscreen)
         go to 10
      endif
      return


c*****format statements
1010  format ('vt=',f5.2)


      end

 
      subroutine boxit
c******************************************************************************
c     This subroutine figures out the point numbers of the wavelength 
c     boundaries for synthetic spectrum plots
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Pstuff.com'
      include 'Linex.com'
      include 'Equivs.com'


c*****if only a synthetic spectrum is being plotted, use beginning and
c     end points of the synthetic spectrum instead of those of the observed
c     spectrum
      if (plotopt .lt. 2) then
         do i=1,kount
            if (xlo .le. xsyn(i)) then
               lim1obs = i
               go to 10
            endif
         enddo
         lim1obs = kount
10       do i=lim1obs,kount
            if (xhi .lt. xsyn(i)) then
               lim2obs = i -1
               return
            endif
         enddo
         lim2obs = kount
         return


c*****and here is the same logic when an observed spectrum exists
      else
         do i=1,lount
            if (xlo .le. xobs(i)) then
               lim1obs = i
               go to 20
            endif
         enddo
         lim1obs = lount
20       do i=lim1obs,lount
            if (xhi .lt. xobs(i)) then
               lim2obs = i -1
               return
            endif
         enddo
         lim2obs = lount
         return
      endif

      end

      subroutine minimax(x,xmin,xmax,numpts)
c*****this routine simply finds the minimum and maximum values of array x

      real*8 x(*)
 
      xmax=x(1)
      xmin=xmax
      do 10 i=1,numpts
         if (x(i).lt.xmin) xmin=x(i)
         if (x(i).gt.xmax) xmax=x(i)
   10 continue

      return
      end

      subroutine partfn (atom,jmark)                                  
c******************************************************************************
c     This routine computes arrays or single partition functions;
c     It uses the data and formulation of Kurucz's ATLAS9 program.
c     However, the partition functions have been updated for several species,
c     and those are calculated in subroutine *newpart*.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Quants.com'


      iat = 10*nint(atom) - 1
      at = dfloat(iat)/10.
      iatom = nint(atom)


c*****compute partition functions for 4 ionization states of an element.
      do k=1,4
         iat = iat + 1
         at = dfloat(iat)/10.
         if (partflag(iatom,k) .gt. 0) then
            do i=1,ntau   
               u(jmark,k,i) = partnew(at,k,i)
            enddo
         else
            do i=1,ntau   
               u(jmark,k,i) = ucalc(at,i)   
            enddo
         endif
      enddo


      return
      end 

      subroutine abpop
c******************************************************************************
c     Equivalent width matching routine for stellar populations; usually 
c     meant for integrated light spectra.  
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'
      include 'Multimod.com'
      character*80 line

  
c*****read the parameter file 
      call params


c*****open the model table input file and the summary table output file;
c     read the information from the table input file
      call tablepop (1)


c*****open the standard output file
      nf1out = 20
      lscreen = 8
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)

c*****FIRST PASS:  For each model, for each line, create a curve-of-growth
c     finely divided in steps of 0.01 in "Ngf"
      do mmod=1,modtot


c*****read in the model atmospheres and their summary output files
         line = synpre
         num = 80
         call getcount (num,line)
         if (mmod .lt. 10) then
            write(line(num+1:num+1),1013) mmod
         else
            write(line(num+1:num+2),1014) mmod
         endif
         nf2out = 21
         fmodoutput(mmod) = line
         f2out = fmodoutput(mmod)
         lscreen = 10
         array = 'SUMMARY C-O-G OUTPUT'
         nchars = 20
         call infile ('output ',nf2out,'formatted  ',0,nchars,
     .                f2out,lscreen)

         line = modpre
         num = 80
         call getcount (num,line)
         if (mmod .lt. 10) then
            write(line(num+1:num+1),1013) mmod
         else
            write(line(num+1:num+2),1014) mmod
         endif
         nfmodel = 30
         fmodinput(mmod) = line
         fmodel = fmodinput(mmod)
         array = 'THE MODEL ATMOSPHERE'
         nchars = 20
         lscreen = 12
         call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .                fmodel,lscreen)
         call inmodel
         write (nf2out,1001) moditle


c*****open and read the line list; this will internally be broken down
c     into 1-line lists for computational efficiency
         array = 'THE LINE LIST'
         nchars = 13
         nflines = 31
         lscreen = 14
         call infile ('input  ',nflines,'formatted  ',0,nchars,
     .                flines,lscreen)
         call inlines (1)
         if (nlines .gt. 1000) then
            write (*,1005)
            stop
         endif
         call eqlib
         call nearly (1)


c*****do the curves of growth; store the results
         rwlow = -6.5
         rwhigh = -3.5
         rwstep = 0.15
         do lim1=1,nlines
            lim2 = lim1
            waveold = 0.
            call curve
            if (ncurve .gt. 50) then
               nmodcurve(mmod,lim1) = 50
            else
               nmodcurve(mmod,lim1) = ncurve
            endif
            fluxmod(mmod,lim1) = flux
            lastcurve = nmodcurve(mmod,lim1)
            iatom = nint(atom1(lim1))
            xxab = dlog10(xabund(iatom))
            weightmod(mmod,lim1) = fluxmod(mmod,lim1)*radius(mmod)**2*
     .                             relcount(mmod)
            do icurve=1,lastcurve
               gfmodtab(mmod,lim1,icurve) = gf1(icurve) + xxab
               rwmodtab(mmod,lim1,icurve) = w(icurve)
            enddo
         enddo
      enddo


c*****set some parameters
         ewsynthopt = -1
         mode = 2
         cogatom = 0.
         lim1line = 0


c*****now, inside the 
c*****define the range of lines for a species
 5       call linlimit
         if (lim1line .lt. 0) then
            call finish (0)
            return
         endif
         lim1obs = lim1line
         lim2obs = lim2line


c*****find out whether molecular equilibrium is involved in the species
         call molquery


c*****for just the first model atmosphere, interpolate in the curve-of-growth
c     at very small log(Ngf) steps for just the first line in the list,
c     in order to make a lookup table for later abundance iterations
      ncurve = nmodcurve(1,1)
      do i=2,ncurve-2
         k = 30*(i-2)
         l = -1
         do m=k+1,k+30
           l = l + 1
           pp       = 0.005/0.15*(l-1)
           gftab(m) = gfmodtab(1,1,2) + 0.005*(m-1)
           rwtab(m) = rwmodtab(1,1,i-1)*(-pp)*(pp-1.)*(pp-2.)/6. +
     .                rwmodtab(1,1,i)*(pp*pp-1.)*(pp-2.)/2. +
     .                rwmodtab(1,1,i+1)*(-pp)*(pp+1.)*(pp-2.)/2. +
     .                rwmodtab(1,1,i+2)*pp*(pp*pp-1.)/6.
         enddo
      enddo
      ntabtot = m - 1


c*****now consider each line at a time; use these curve-of-growth to 
c     compute a weighted <EW_calc> 
      do lim1=lim1line,lim2line
         write (nf7out,1003) atom1(lim1), wave1(lim1), e(lim1,1),
     .                       dlog10(gf(lim1))
         rwlgerror = 50.
         deltangf = 0.
         do k=1,30
            call ewweighted
            rwlgcal = dlog10(ewmod(lim1)/wave1(lim1))
            do i=2,ntabtot
               if (rwtab(i) .gt. rwlgcal) then
                  gflgcal = gftab(i-1) + (gftab(i)-gftab(i-1))*
     .                      (rwlgcal-rwtab(i-1))/(rwtab(i)-rwtab(i-1))
                  exit
               endif
            enddo
            rwlgobs = dlog10(width(lim1)/wave1(lim1))
            do i=2,ntabtot
               if (rwtab(i) .gt. rwlgobs) then
                  gflgobs = gftab(i-1) + (gftab(i)-gftab(i-1))*
     .                      (rwlgobs-rwtab(i-1))/(rwtab(i)-rwtab(i-1))
                  exit
               endif
            enddo
            rwlgerror = rwlgobs - rwlgcal
            diffngf = gflgobs - gflgcal
            deltangf = deltangf + diffngf
            if (dabs(rwlgerror) .lt. 0.01) exit
            if (k .eq. 30) then
               write (*,1004)
               stop
            endif
         enddo


c*****here we go for a final iteration on a line, or finish
         call ewweighted
      enddo

      
c*****do the species statistics and output the results
      call stats
      call lineinfo (3)


c*****here a plot may be made on the terminal (and paper) if there 
c     are enough lines; then the user will be prompted on some
c     options concerning what is seen on the plot

      if (plotopt .ne. 0) then
c		 if (silent .eq. 'n') then
      	 	call blankstring (moditle)
c		 endif
         moditle(1:70) = popitle(1:70)
         moditle(57:80) = 'EW-POPULATION '
         call pltabun
      endif


c*****quit, or go on to another species?
      array = 'DO ANOTHER SPECIES ([y]/n)? '
      if (silent .eq. 'n') then 
         nchars = 28
         call getasci (nchars,maxline)
         choice = chinfo(1:1)
      else
         choice = 'y'
      endif
      if (choice.eq.'y' .or. nchars.le.0) then
         if (mode .eq. 2) then
            go to 5
         else
            call finish (0)
            return
         endif
      else
         call finish (0)
         return
      endif


c*****format statements
1001  format (a80)
1003  format (/'species=',f5.1, 3x, 'lambda=', f8.3, 3x, 'EP=', f6.3,
     .        3x, 'log(gf)=', f7.3)
1004  format ('NO ABUNDANCE CONVERGENCE IN 30 TRIES; I QUIT!')
1005  format ('MORE THAN 1000 LINES FED TO ABPOP; I QUIT')
1013  format (i1)
1014  format (i2)
      end

      subroutine lineinfo (number)
c******************************************************************************
c     This routine is an output subroutine for things having to do with
c     lines.  
c            number = 1 gives input line data information
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Dummy.com'
      include 'Factor.com'
      include 'Pstuff.com'
      include 'Quants.com'
      real*8 loggf, logstrength
      integer ifresh
      character*8 molname
      character*4 ion(3)
      character*1 name*1
      data ifresh /0/
      data ion/' I  ', ' II ', ' III'/


      go to (1,2,3), number


c*****here the line data are output to "standard_out"; all relevant 
c     drivers use this
c     if you don't want any line output, linprintopt=0 will exit the routine
1     if (linprintopt .lt. 1) return
c     if you want standard output, linprintopt=1 is chosen
c     linprintopt>=2 outputs ionization potentials, charges, masses,
c                            reduced masses for molecules, 
c     linprintopt>=3 outputs partition functions
c     lineprintop =4 outputs line-center opacities
      write (nf1out,1001) nlines
      if (linprintopt .ge. 2) write (nf1out,1002)
      do j=1,nlines
         ich = idint(charge(j) + 0.1)
         iatom = idint(atom1(j))
         loggf = dlog10(gf(j))
         logstrength = dlog10(strength(j))
         if (iatom .lt. 100) then
            if (iunits .eq. 1) then
               write (nf1out,1003) j, 1.d-4*wave1(j), names(iatom),
     .           ion(ich), atom1(j), e(j,1), loggf, damptype(j), 
     .           logstrength, 1000.*width(j)
            else
               write (nf1out,1004) j, wave1(j), names(iatom),
     .           ion(ich), atom1(j), e(j,1), loggf, damptype(j),
     .           logstrength, 1000.*width(j)
            endif
            if (linprintopt .ge. 2) write (nf1out,1005) 
     .                 (chi(j,k),k=1,3), charge(j), amass(j), rdmass(j)
         else
            call sunder (atom1(j),ia,ib)
            if (ia .eq. 1) then
               l = ia
               ia = ib
               ib = l
            endif
            leftovr = idint(10000.*(atom1(j)-iatom)+0.1)
            if (ia .lt. 10) then
               read (names(ia),1006) name
               write (molname,1007) name,names(ib),leftovr
            else
               write (molname,1008) names(ia),names(ib),leftovr
            endif
            if (iunits .eq. 1) then
               write (nf1out,1009) j, 1.d-4*wave1(j), molname, 
     .               atom1(j), e(j,1), loggf, damptype(j), 
     .               logstrength, 1000.*width(j)
            else
               write (nf1out,1010) j, wave1(j), molname, 
     .               atom1(j), e(j,1), loggf, damptype(j), 
     .               logstrength, 1000.*width(j)
            endif
            if (linprintopt .ge. 2) 
     .         write (nf1out,1005) 
     .               d0(j), (chi(j,k),k=1,2), charge(j), amass(j), 
     .               rdmass(j)
         endif
      enddo    
      if (start.ne.0.0 .or. sstop.ne.0.0) then
         if (iunits .eq. 1) then
            write (nf1out,1011) oldstart,oldstop,oldstep,olddelta
         else 
            write (nf1out,1012) start,sstop,step,delta  
         endif
      if (rwlow .ne. 0.) write (nf1out,1013) rwlow, rwhigh, rwstep
      endif  
      if (linprintopt .ge. 3) then
         write (nf1out,1014)
         do j=1,95
            if (elem(j) .ne. 0.) then
               iatom = int(elem(j))
               write (nf1out,1015) iatom, names(iatom), xam(j),
     .                            xchi1(j), xchi2(j), xchi3(j)
               do k=1,4
                  write (nf1out,1016) k-1,(u(j,k,i),i=1,ntau)   
               enddo
            endif
         enddo
      endif

      if (linprintopt .ge. 4) then
         write (nf1out,1017)
         do j=1,nlines
            write (nf1out,1018) j, wave1(j)
            write (nf1out,1019) (kapnu0(j,i),i=1,ntau)
         enddo
      endif
      return



c*****here the STRONG line data are output; MOOG assumes that no
c     molecular line can possibly be in this category
2     write (nf1out,2001) nstrong
      do j=nlines+1,nlines+nstrong
         ich = idint(charge(j) + 0.1)
         iatom = idint(atom1(j))
         loggf = dlog10(gf(j))
         logstrength = dlog10(strength(j))
         if (iatom .lt. 100) then
            if (iunits .eq. 1) then
               write (nf1out,1003) j-nlines,1.d-4*wave1(j),names(iatom),
     .                             ion(ich), atom1(j), e(j,1), loggf,
     .                             damptype(j), logstrength
            else
               write (nf1out,1004) j-nlines, wave1(j),names(iatom),
     .                             ion(ich), atom1(j), e(j,1), loggf,
     .                             damptype(j), logstrength
            endif
         else
            write (*,2004) iatom
            stop
         endif
      enddo
      printstrong = 1
      return


c*****results of force-fitting EW to yield abundances are output here
c     look here also for the calls to the trend line calculations
3     if (ifresh .eq.0) then
         write (nf2out,3001) linitle,moditle
         ifresh = 1
      endif
      if (cogatom .eq. 0.) then
         iatom = iabatom
      else
         iatom = idint(cogatom)
      endif
      xab = dlog10(xabund(iatom)) + 12.
      ich = idint(charge(lim1obs) + 0.1)
      if (atom1(lim1obs) .lt. 100.) then
         write (array,3002) names(iatom), ion(ich) ,xab
         line = 1
         call prinfo (line)
         write (nf2out,*)
         write (nf2out,3002) names(iatom), ion(ich), xab
         write (array,3003)
         line = 2
         call prinfo (line)
         write (nf2out,3003)
      else
         call sunder (atom1(lim1obs),ia,ib)
         if (ia .eq. 1) then
            l = ia
            ia = ib
            ib = l
         endif
         leftovr = idint(10000.*(atom1(lim1obs)-iatom)+0.1)
         if (ia .lt. 10) then
            read (names(ia),1006) name
            write (molname,1007) name,names(ib)
         else
            write (molname,1008) names(ia),names(ib)
         endif
         write (array,3004) molname,xab
         line = 1
         call prinfo (line)
         write (nf2out,*)
         write (nf2out,3004) molname,xab
         write (array,3005) names(iabatom)
         line = 2
         call prinfo (line)
         write (nf2out,3005) names(iabatom)
         write (array,3006)
         line = 3
         call prinfo (line)
         write (nf2out,3006)
      endif
      do l=lim1obs,lim2obs
         if (abundout(l) .ne. 999.99) then
            diff = abundout(l) - average
         else
            diff = 999.99
         endif
         ew = 1000.*width(l)
         rw = dlog10(width(l)/wave1(l))
         loggf = dlog10(gf(l))
         write (array,3007) wave1(l), atom1(l), e(l,1), loggf,
     .         ew, rw, abundout(l), diff
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (nf2out,3007) wave1(l), atom1(l), e(l,1), loggf,
     .         ew, rw, abundout(l), diff
      enddo
      write (array,3008) average, deviate, kount
      line = line + 1
      if (errmess(1:9) .ne. 'stopinfo!') call prinfo (line)
      write (nf2out,3008) average, deviate, kount
      if (kount .gt. 2 .and. deltaep .gt. 1.5) then
         write (array,3009) xxm1, xxb1, xxr1 
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (nf2out,3009) xxm1, xxb1, xxr1
      else
         write (array,*) 'No statistics done for E.P. trends' 
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (nf2out,*) 'No statistics done for E.P. trends' 
      endif
      if (kount .gt. 2 .and. deltarw .gt. 0.5) then
         write (array,3010) xxm2, xxb2, xxr2   
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (nf2out,3010) xxm2, xxb2, xxr2   
      else
         write (array,*) 'No statistics done for R.W. trends' 
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (nf2out,*) 'No statistics done for R.W. trends' 
      endif
      if (kount .gt. 2 .and. deltawv .gt. 500.) then
         write (array,3011) xxm3, xxb3, xxr3
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (nf2out,3011) xxm3, xxb3, xxr3
      else
         write (array,*) 'No statistics done for wavelength trends'
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (nf2out,*) 'No statistics done for wavelength trends'
      endif
      return


c*****format statements
1001  format (/'INPUT LINES DATA FOR ' ,i5, ' LINES'/ 
     .        '   #', 5x, 'wave1', 3x, 'spec', 9x, 'spec#', 
     .        3x, 'E.P.', 3x, 'loggf', 5x, 'damp', 4x, 'logSTR', 
     .        5x, 'E.W.')
1002  format (20x, 6x, 'chi1', 4x, 'chi2', 6x, 'chi3', 4x, 'charge',
     .        6x, 'mass', 4x, 'rdmass')
1003  format (i4, f10.6, 2x, a2, a4, f13.5, f7.3, f8.3, 2x, a7,
     .        f9.1, f9.2)
1004  format (i4, f10.3, 2x, a2, a4, f13.5, f7.3, f8.3, 2x, a7,
     .        f10.2, f8.2)
1005  format (20x, f10.3, f8.3, f10.3, f10.1, f10.2, f10.4)
1006  format (a1)
1007  format (1x,a1,a2,i4)
1008  format (2a2,i4)
1009  format (i4, f10.6, 3x, a4, 1x, f13.5, f7.3, f8.3, 2x, a7,
     .        f10.2, f8.2)
1010  format (i4, f10.3, 3x, a4, 1x, f13.5, f7.3, f8.3, 2x, a7,
     .        f10.2, f8.2)
1011  format (/'SYNTHETIC SPECTRUM PARAMETERS (units=1/cm)'/
     .        10x,'start =',f11.3,' ',5x,'stop =',f11.3,' '/  
     .        'step size in the spectrum =',f11.4,' '/
     .        'at each point, opacity will include lines' ,
     .        ' within',f11.4,' of the point')          
1012  format (/'SYNTHETIC SPECTRUM PARAMETERS (units=A)'/
     .        10x,'start =',f11.3,' ',5x,'stop =',f11.3,' '/  
     .        'step size in the spectrum =',f11.3,' '/
     .        'at each point, opacity will include lines' ,
     .        ' within',f11.3,' of the point')          
1013  format (/'CURVE-OF-GROWTH PARAMETERS'/
     .        10x,'log(R.W) lower bound =',f7.3, 
     .        10x,'upper bound =',f7.3/
     .        10x,'step size in the curve =',f7.3)
1014  format (/'PARTITION FUNCTIONS')
1015  format (/'Z =',i2,' (',a2,'),  mass=',f8.3,'  I.P.s=', 3f7.3)
1016  format ('    ionization state = ',i1/(10f8.3))
1017  format (/'LINE OPACITIES')
1018  format (/'LINE', i4, ' AT WAVELENGTH ',f8.2)
1019  format (10E15.7)  
2001  format (/'INPUT LINES DATA FOR',i4,' STRONG LINES'/
     .        '   #', 5x, 'wave1', 3x, 'spec', 9x, 'spec#',
     .        3x, 'E.P.', 3x, 'loggf', 5x, 'damp', 4x, 'logSTR')
2004  format ('SPECIES = ', i5, ' IS A MOLECULE, NOT ALLOWED AS A ',
     .        'STRONG LINE; I QUIT!')
3001  format (a80)
3002  format ('Abundance Results for Species ',a2,a4,
     .        '       (input abundance = ',f7.3,')')
3003  format ('wavelength', 9x, 'ID', 6x, 'EP', 3x, 'logGF', 5x, 'EWin',
     .        3x, 'logRWin', 5x, 'abund', 3x, 'delavg')
3004  format ('Abundance Results for Species ',a8,
     .        '       (input abundance = ',f6.2,')')
3005  format ('From these data, the abundance of ',a2, 
     .        ' will be altered')
3006  format ('wavelength', 9x, 'ID', 6x, 'EP', 3x, 'logGF', 5x, 'EWin',
     .        3x, 'logRWin', 5x, 'abund', 3x, 'delavg')
3007  format (f10.3, f11.5, f8.3, f8.3, f9.2, f10.3, f10.3, f9.3)
3008  format ('average abundance = ',f6.3,'     std. ',
     .        'deviation = ',f6.3,'     #lines = ',i3)
3009  format ('E.P. correlation:  slope = ',f7.3,'  intercept = ',
     .        f7.3,'  corr. coeff. = ',f7.3)
3010  format ('R.W. correlation:  slope = ',f7.3,'  intercept = ',
     .        f7.3,'  corr. coeff. = ',f7.3)
3011  format ('wav. correl.:  slope = ',1pd11.3,'  intercept = ',
     .        0pf7.3,'  corr. coeff. = ',f7.3)



      return
      end

      subroutine cogsyn
c******************************************************************************
c     This program produces a curve-of-growth of a blended feature,
c     altering only a specified species' abundance.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Pstuff.com'


c*****examine the parameter file
      call params


c*****open the files for standard output and summary curves-of-growth
      nf1out = 20
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21
      lscreen = lscreen + 2
      array = 'SUMMARY C-O-G OUTPUT'
      nchars = 20
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)


c*****open and read the model atmosphere
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****open and read the line list file; get ready for the line calculations
      nflines = 31
      lscreen = lscreen + 2
      array = 'THE LINE LIST'
      nchars = 13
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .              flines,lscreen)
      call inlines (1)
      call eqlib
      call nearly (1)


c*****do the syntheses
      isynth = 1
      isorun = 1
      ncurve = 0
      iatom =nint(cogatom)
      pec(iatom) = 1
      numpecatom = 1
      pecabund(iatom,1) = 0.
      mode = 3
10    ncurve = ncurve + 1
      nlines = 0
      call synspec
      call total
      if (ncurve .eq. 1) then
         wstart = 10.**(rwlow)*wave1(lim1)
         wstop = 10.**(rwhigh)*wave1(lim1)
      endif
      molopt = 1
      linprintopt = 0
      if (w(ncurve) .gt. wstart) then
         pecabund(iatom,1) = pecabund(iatom,1) - rwstep
         go to 10
      endif
      pecabund(iatom,1) = rwstep
20    ncurve = ncurve + 1
      nlines = 0
      call synspec
      call total
      molopt = 1
      linprintopt = 0
      if (w(ncurve) .lt. wstop) then
         pecabund(iatom,1) = pecabund(iatom,1) + rwstep
         go to 20
      endif
      call pltcog

         
c*****finish
      call finish (0)
      end

      subroutine params 
c****************************************************************************** 
c     This subroutine reads in the commands from the parameter file 
c****************************************************************************** 

      implicit real*8 (a-h,o-z) 
      include 'Atmos.com' 
      include 'Linex.com' 
      include 'Factor.com' 
      include 'Pstuff.com' 
      include 'Obspars.com'
      include 'Mol.com'
      include 'Multistar.com'
      real*8 deltalogab(5)
      character keyword*20
      character arrayz*80
      integer kk
      data newcount, linecount /0, 0/


      if (linecount .eq. 0) oldcount = 0


c  IF DOING MULTIPLE RUNS: if this is not the first reading of the
c  parameter file, then read down to correct place in parameter file, 
c  using "linecount", and then skip the re-initialization of the 
c  various variables
      rewind nfparam
      read (nfparam,1001,end=100) arrayz
      if (linecount .ne. 0) then
         do i=1,linecount
            read (nfparam,1001,end=100) arrayz
         enddo
         go to 4
      endif


c  INITIALIZE SOME VARIABLES: output file names and output file numbers
c  f1out, nf1out:    verbose standard output
c  f2out, nf2out:    raw synthetic spectra, or summary abundances, or
c                    summary curves-of-growth
c  f3out, nf3out:    smoothed synthetic spectra
c  f4out, nf4out:    IRAF-text-style synthetic spectra output
c  f5out, nf5out:    postscript plot output
c  f6out, nf6out:    synthetic/observed comparison text output (gridsyn)
c  f7out, nf7out:    raw synthetic spectrum of primary of a binary, 
c                    output summary run table, or
c                    to be used for some other purpose as needed; at
c                    present not given keyword input
c  f8out, nf8out:    raw synthetic spectrum of secondary of a binary,
c                    or the kept lines in a line weedout, or for
c                    some other purpose as needed
c  f9out, nf9out:    combined smoothed synthetic spectrum of a binary star,
c                    or the discarded lines in a line weedout, or the
c                    mean raw synthesis for a population of stars, or
c                    some other purpose as needed
c                    to be used for some other purpose as needed`
c  f10out, nf10out:  combined smoothed synthetic spectrum of a binary star,
c                    to be used for some other purpose as needed`
      f1out =   'no_filename_given'
      f2out =   'no_filename_given'
      f3out =   'no_filename_given'
      f4out =   'no_filename_given'
      f5out =   'optional_output_file'
      f6out =   'optional_output_file'
      f7out =   'no_filename_given'
      f8out =   'no_filename_given'
      f9out =   'no_filename_given'
      f10out =  'no_filename_given'
      nf1out =   0
      nf2out =   0
      nf3out =   0
      nf4out =   0
      nf5out =   0
      nf6out =   0
      nf7out =   0
      nf8out =   0
      nf9out =   0
      nf10out =  0
      modelnum = 0


c  INITIALIZE SOME VARIABLES: input file names and input file numbers
      fmodel =  'no_filename_given'
      flines =  'no_filename_given'
      fslines = 'no_filename_given'
      fobs =    'no_filename_given'
      ftable =  'no_filename_given' 
      nfmodel =  0 
      nflines =  0
      nfslines = 0
      nfobs =    0
      nftable =  0


c  INITIALIZE SOME VARIABLES: terminal type;
c  set smterm = ' ' for the plotting package 'sm'
      smterm = 'x11'
      

c  INITIALIZE SOME VARIABLES: 
c  atmosphere data printing:              modprintopt  [old ipr(1)]
c  molecular equilibrium:                 molopt       [old ipr(2)]
c  line data:                             linprintopt  [old ipr(3)] 
c  flux/intensity                         fluxintopt   [old ipr(4)]
c  synthesis/single line computations:    [deleted]    [old ipr(5)] 
c  line formation level                   [deleted]    [old ipr(6)]
c  plotting:                              plotopt      [old ipr(7)] 
c  damping                                dampingopt   [old ipr(8)]
c  observed spectrum file type            specfileopt  [old ipr(9)]
c  format of linelist (formatted/not)     linfileopt
c  source function with scat+abs          scatopt
      modprintopt  = 1
      molopt       = 1
      linprintopt  = 1
      fluxintopt   = 0
      plotopt      = 0
      dampingopt   = 0
      specfileopt  = 0
      linfileopt   = 0
      iunits       = 0
      itru         = 0
      iscale       = 0
      nlines       = 0
      iraf         = 0
      histoyes     = 0
      byteswap     = 0
      deviations   = 0
      scatopt      = 0
      gfstyle      = 0
      maxshift     = 0
      dostrong     = 0
      molset       = 0
 

c  INITIALIZE SOME VARIABLES:
c   if fudge is less than or equal to 0 then it does not scale it...make it
c   -1.0 just to be sure we dont have floating point problems with 0.0
      fudge = -1.0


c  INITIALIZE SOME VARIABLES: spectrum run parameters
      oldstart = 0.
      start = 0.
      sstop = 0.
      step = 0.
      delta = 0.
      cogatom = 0.
      contnorm = 1.0


c  INITIALIZE SOME VARIABLES: line limit parameters
      ncurve = 0
      lim1line = 0
      lim2line = 0
      lim1obs = 0
      lim2obs = 0
      lim1 = 0
      lim2 = 0


c  INITIALIZE SOME VARIABLES: spectroscopic binary parameters
      deltaradvel = 0.
      lumratio = 1.


c  INITIALIZE SOME VARIABLES: elements with special abundance data; for
c  practical reasons, keyword "abundances" and "isotopes" must be specified
c  in each RUN; they must be reset each time.
4     neq = 0
      numpecatom = 0
      numatomsyn = 0
      newnumpecatom = 0
      newnumatomsyn = 0
      ninetynineflag = 0
      do i=1,95
         pec(i) = 0
         newpec(i) = 0
         do j=1,5
            abfactor(j) = 0.
            pecabund(i,j) = 0.
            newpecabund(i,j) = 0.
         enddo
      enddo
      numiso = 0
      numisosyn = 0
      newnumiso = 0
      newnumisosyn = 0
      do i=1,20
         isotope(i) = 0.
         newisotope(i) = 0.
         do j=1,5
            isoabund(i,j) = 0.
            newisoabund(i,j) = 0.
         enddo
      enddo


c  read a line of the parameter file into "arrayz"; decode it to get the 
c  key word, which is always within the first 20 characters;  dump the 
c  rest of arrayz into "array"
5     write (array,1007)
      read (nfparam,1001,end=98) arrayz
      linecount = linecount + 1
      i=index(arrayz,' ')
      keyword = arrayz(1:i-1)
      array = arrayz(i:)


c  keyword 'RUN' signals that there are either multiple syntheses being
c  done or multiple comparisons with observed spectra
      if (keyword .eq. 'RUN') then
         read (array,*) newcount
         if (newcount .gt. oldcount+1) then
            linecount = linecount - 1
            oldcount = syncount
            go to 100
         else
            syncount = newcount
            go to 5
         endif
      endif


c  keyword 'freeform' indicates whether or not the linelist will be read
c  in under format control (7e10.3) or will be free-form.  If freeform = 0,
c  the default value, then the old-style formatted input will be used;
c  If freeform = 1, unformatted read will be used, BUT the user must then
c  give values for all quantities (that is, explicit zeros will need to
c  be put instead of blank spaces.
      if     (keyword .eq. 'freeform') then
         read (array,*) linfileopt
 
 
c  keyword 'standard_out' controls the name of the verbose standard output
      elseif (keyword .eq. 'standard_out') then
         read (array,*) f1out


c  keyword 'summary_out' controls the name of either the EW summary or
c  the raw synthesis output
      elseif (keyword .eq. 'summary_out') then
         read (array,*) f2out


c  keyword 'hardpost_out' controls the name of a postscript plot output
      elseif (keyword .eq. 'hardpost_out') then
         read (array,*) f5out


c  keyword 'speccomp_out' controls the name of a text file containing the
c  comparisons (wavelength shifts, sigmas, etc.) between observed and
c  synthetic spectra
      elseif (keyword .eq. 'speccomp_out') then
         read (array,*) f6out


c  keyword 'bin_raw_out' controls the name of a file containing the
c  raw synthesis of a spectroscopic binary, with an appropriate velocity 
c  difference and luminosity ratio dialed in
      elseif (keyword .eq. 'bin_raw_out') then
         read (array,*) f9out


c  keyword 'bin_smo_out' controls the name of a file containing the
c  smoothed synthesis of a spectroscopic binary
      elseif (keyword .eq. 'bin_smo_out') then
         read (array,*) f10out

 
c  keyword 'summary_in' controls the name of the raw synthesis file,
c  created previously, that will be read in for plotting purposes
      elseif (keyword .eq. 'summary_in') then
         read (array,*) f2out


c  keyword 'smoothed_out' controls the name of the smoothed synthesis output
      elseif (keyword .eq. 'smoothed_out') then
         read (array,*) f3out


c  keyword 'keeplines_out' controls the name of the list of kept lines
c  for future synthetic spectrum runs
      elseif (keyword .eq. 'keeplines_out') then
         read (array,*) f8out


c  keyword 'tosslines_out' controls the name of the list of discarded lines
c  that are too weak to keep in future synthetic spectrum runs
      elseif (keyword .eq. 'tosslines_out') then
         read (array,*) f9out


c  keyword 'iraf_out' controls the name of the optional IRAF output
      elseif (keyword .eq. 'iraf_out') then
         read (array,*) f4out


c  keyword 'model_in' controls the name of input model atmosphere file
      elseif (keyword .eq. 'model_in') then
         read (array,*) fmodel


c  keyword 'lines_in' controls the name of the input line list
      elseif (keyword .eq. 'lines_in') then
         read (array,*) flines


c  keyword 'stronglines_in' controls the name of the input strong line list
      elseif (keyword .eq. 'stronglines_in') then
         read (array,*) fslines


c  keyword 'observed_in' controls the name of the input observed spectrum
      elseif (keyword .eq. 'observed_in') then
         read (array,*) fobs


c  keyword 'table_in' controls the name of the extra input instruction file
      elseif (keyword .eq. 'table_in   ') then
         read (array,*) ftable


c  keyword 'table_out' controls the name of the extra input instruction file
      elseif (keyword .eq. 'table_out  ') then
         read (array,*) f7out


c  keyword 'popsyn_out' controls the name of the extra input instruction file
      elseif (keyword .eq. 'popsyn_out ') then
         read (array,*) f9out


c  keyword 'rawbin_out ' controls the name of the input observed spectrum
      elseif (keyword .eq. 'rawbin_out ') then
         read (array,*) f9out


c  keyword 'smoobin_out' controls the name of the input observed spectrum
      elseif (keyword .eq. 'smoobin_out') then
         read (array,*) f10out


c  keyword 'atmosphere' controls the output of atmosphere quantities
c           0 = do not print out the atmosphere
c           1 = print out the standard things about an atmsophere
c           2 = print standard things and additional stuff like continuous
c                    opacities, etc.
      elseif (keyword .eq. 'atmosphere') then
         read (array,*) modprintopt


c  keyword 'molecules ' controls the molecular equilibrium calculations
c           0 = do not do molecular equilibrium
c           1 = do molecular equilibrium but do not print results
c           2 = do molecular equilibrium and print results
      elseif (keyword .eq. 'molecules') then
         read (array,*) molopt
         if     (molopt .eq. 0) then
            nchars = 64
            write (array,1009) 
            call getasci (nchars,l0)
            if (chinfo(1:1) .eq. 'n') then
               stop
            else
               molopt = 1
            endif
         endif


c  keyword 'molset' controls the choice of which set of molecules will be
c  used in molecular equilibrium calculations.
c          1 = the small set involving H, C, N, O, Mg, Ti (DEFAULT)
c          2 = the large set more useful for very cool stars
      elseif (keyword .eq. 'molset') then
         read (array,*) molset


c  keyword 'deviations' controls whether, for synthetic spectrum computations,
c  an 'obs-comp' plot will be made in addition to the normal spectrum plot
c           0 = do not plot the obs-comp plot
c           1 = plot the obs-comp plot
      elseif (keyword .eq. 'deviations') then
         read (array,*) deviations


c  keyword 'lines     ' controls the output of line data
c           0 = print out nothing about the input lines
c           1 = print out standard information about the input line list
c           2 = gory line data print (usually for diagnostic purposes)
      elseif (keyword .eq. 'lines') then
         read (array,*) linprintopt
         linprintalt = linprintopt


c  keyword 'gfstyle   ' controls the output of line data
c           0 = base-10 logarithms of the gf values (DEFAULT)
c           1 = straight gf values
      elseif (keyword .eq. 'gfstyle') then
         read (array,*) gfstyle


c  keyword 'contnorm  ' allows multiplicative adjustment of the
c           continuum; useful probably only for batch syntheses
c           the numbers employed should be around 1.0;
c           default is 1.000000
      elseif (keyword .eq. 'contnorm') then
         read (array,*) contnorm


c  keyword 'plotpars  ' allows you to set all of the plotting 
c     parameters if you know them in advance
c     0 = none set (default); user can change in plotting routine
c     1 = given in following lines as follows 
c xlow         xhi         ylo       yhi
c vshift       lamshift    obsadd    obsmult
c smooth-type  FWHM-Gauss  vsini     L.D.C.    FWHM-Macro     FWHM-Loren
      elseif (keyword .eq. 'plotpars') then
         read (array,*) iscale
         if (iscale .ne. 0) then
            read (nfparam,*) xlo, xhi, ylo, yhi
            linecount = linecount + 1
            read (nfparam,*) veladd, xadd, yadd, ymult
            if (xadd .ne. 0.) then
               veladd = 3.0d5*xadd/((xlo+xhi)/2.)
               xadd = 0.
            endif
            linecount = linecount + 1
            read (nfparam,*) smtype, fwhmgauss, vsini, limbdark, vmac,
     .                      fwhmloren
            linecount = linecount + 1
         endif


c keyword 'trudamp     '  should moog use the detailed line damping for
c                         those transitions that have information stored in
c                         subroutine trudamp? (Default is *no*)
      elseif (keyword .eq. 'trudamp') then
         read (array,*) itru


c keyword 'veladjust   '  shoud moog try to do a cross-correlation between
c                         observed and synthetic spectra and use that to
c                         align the spectra better in wavelength
c                         (Default is *no*)
      elseif (keyword .eq. 'veladjust') then
         read (array,*) maxshift


c keyword 'units      ' controls the units in which moog 
c          outputs the final spectrum
c            0 = angs
c            1 = microns
c            2 = 1/cm
      elseif (keyword .eq. 'units') then
         read (array,*) iunits
         if (iunits .ne. 0) then
            write (*,1010)
            stop
         endif


c keyword 'iraf       ' allows the user to output a raw spectrum in 
c          a form suitable for IRAF's rtext input command
c            0 = don't do this, make output the normal way.
c            1 = make an IRAF-compatible output
      elseif (keyword .eq. 'iraf') then
         read (array,*) iraf


c  keyword 'scat       'allows the user to employ a source function
c          which has both scattering and absorption components     
c          0 = NO scattering
c          1 = scattering
      elseif (keyword .eq. 'scat') then
         read (array,*) scatopt


c  keyword 'flux/int  ' choses integrated flux or central intensity
c           0 = integrated flux calculations
c           1 = central intensity calculations
      elseif (keyword .eq. 'flux/int') then
         read (array,*) fluxintopt


c*****here are the calculations to set up the damping; for atomic lines
c     there are several options:
c        dampingopt = 0 and dampnum < 0 --->
c                             gammav = 10^{dampnum(i)}*(T/10000K)^0.3*n_HI
c        dampingopt = 0 and dampnum = 0 --->
c                             c6 = Unsold formula
c        dampingopt = 0 and dampnum > 10^(-10) --->
c                             c6 =  (Unsold formula)*dampnum(i)
c        dampingopt = 0 and dampnum(i) < 10^(-10) --->
c                             c6 = dampnum(i)
c        dampingopt = 1 --->
c                             gammav = gamma_Barklem if possible,
c                                        otherwise use dampingopt=0 options
c        dampingopt = 2 --->
c                             c6 = c6_Blackwell-group
c        dampingopt = 3 and dampnum <= 10^(-10) --->
c                             c6 = c6_NEXTGEN for H I, He I, H2
c        dampingopt = 3 and dampnum > 10^(-10) --->
c                             c6 = (c6_NEXTGEN for H I, He I, H2)*dampnum
c     for molecular lines (lacking a better idea) --->
c                                        c6 done as in dampingopt = 0
      elseif (keyword .eq. 'damping') then
         read (array,*) dampingopt


c  keyword 'obspectrum' controls the file type of the observed spectrum
c           0 = no observed spectrum is to be input
c           1 = read a true FITS file with internal read statements
c          -1 = as if obspectrum = 1, but on a byte-swapping machine
c           2 = (not implemented yet)
c           3 = read a true Fits file with the FITSIO package
c           4 = (not implemented yet)
c           5 = read a special MONGO style (wavelength, flux pair) file
      elseif (keyword .eq. 'obspectrum') then
         read (array,*) specfileopt
         if (specfileopt .lt. 0) then
            byteswap = 1
            specfileopt = iabs(specfileopt)
         endif


c   keyword 'histogram' makes histogram plots of observed spectra if
c   histoyes = 1
      elseif (keyword .eq. 'histogram') then
         read (array,*) histoyes


c  keyword 'terminal  ' gives the sm plotting window type
c           smterm = a character string of the sm window type (see the 
c           appropriate sm manual for a list)
      elseif (keyword .eq. 'terminal') then
         read (array,*) smterm


c  keyword 'plot      ' decides whether or not to make a plot of results
c           0 = do not make a plot
c           For syntheses: 1 = plot only synthetic spectra
c                          2 = plot synthetic and observed spectra
c                          3 = smooth the syntheses but don't plot
c           For line analyses: # = the minimum number of lines of a 
c                                  species necessary to trigger a plot
c           For curves-of-growth: 1 = make plots
c           For flux curves: 1 = make plots
      elseif (keyword .eq. 'plot') then
         read (array,*) plotopt


c  keyword 'abundances' gives the changes to be applied to the abundances
c           # = the number of different syntheses to run
c               (the next line gives the different abundance factors
c               to use)
c  minimum error check:  numatomsyn must equal numisosyn or code will stop
      elseif (keyword .eq. 'abundances') then
         neq = 0
         numpecatom = 0
         numatomsyn = 0
         newnumpecatom = 0
         newnumatomsyn = 0
         ninetynineflag = 0
         do i=1,95
            pec(i) = 0
            newpec(i) = 0
            do j=1,5
               abfactor(j) = 0.
               pecabund(i,j) = 0.
               newpecabund(i,j) = 0.
            enddo
         enddo
         read (array,*) numpecatom,numatomsyn
         if (numisosyn .ne. 0) then
            if (numatomsyn .ne. numisosyn) then
               write (array,1002) numatomsyn, numisosyn
               call putasci (77,6)
               stop
            endif
         endif
         do l=1,numpecatom
            read (nfparam,*) jatom,(deltalogab(kk),kk=1,numatomsyn)
            linecount = linecount + 1
            if (jatom .eq. 99) then
               do kk=1,numatomsyn
                  abfactor (kk) = deltalogab(kk)
               enddo
            else
               do kk=1,numatomsyn
                  pecabund(jatom,kk) = deltalogab(kk)
               enddo
               pec(jatom) = 1
            endif
         enddo
         if (numpecatom.eq.1 .and. jatom.eq.99) ninetynineflag = 1


c keyword 'isotopes   ' gives the isotopes used in the line list and their
c                       abundance relative to the parent spiecies
c  minimum error check:  numatomsyn must equal numisosyn or code will stop
      elseif (keyword .eq. 'isotopes') then
         numiso = 0
         numisosyn = 0
         newnumiso = 0
         newnumisosyn = 0
         do i=1,20
            isotope(i) = 0.
            newisotope(i) = 0.
            do j=1,5
               isoabund(i,j) = 0.
               newisoabund(i,j) = 0.
            enddo
         enddo
         read (array,*) numiso,numisosyn
         if (numatomsyn .ne. 0) then
            if (numatomsyn .ne. numisosyn) then
               write (array,1002) numatomsyn, numisosyn
               call putasci (77,6)
               stop
            endif
         endif
         do  j=1,numiso
            read (nfparam,*) isotope(j),(isoabund(j,kk),kk=1,numisosyn)
            linecount = linecount + 1
         enddo


c  keyword 'lumratio' gives the ratio of the luminosity of two stars at a
c                     specific wavelength in a binary star system (used 
c                     only with driver "binary")
      elseif (keyword .eq. 'lumratio') then
         read (array,*) lumratio


c  keyword 'deltaradvel' gives the velocity difference between the stars
c                        binary star system (used only with driver "binary")
      elseif (keyword .eq. 'deltaradvel') then
         read (array,*) deltaradvel


c  keyword 'synlimits ' gives the wavelength parameters for syntheses;
c                       start and sstop are beginning and ending
c                       wavelengths, step is the step size in the
c                       syntheses, and delta is the wavelength range
c                       to either side of a synthesis point to consider
c                       for line opacity calculations
      elseif (keyword .eq. 'synlimits') then
         read (nfparam,*) start, sstop, step, delta
         oldstart = start
         oldstop  = sstop
         oldstep  = step
         olddelta = delta
         step1000 = 1000.*step
         if (dble(idnint(step1000))-step1000 .ne. 0.) then
            write (*,1008) step
            stop
         endif
         linecount = linecount + 1


c  keyword 'fluxlimits' gives the wavelength parameters for flux curves;
c                       start and sstop are beginning and ending
c                       wavelengths, and step is the step size in the
c                        flux curve
      elseif (keyword .eq. 'fluxlimits') then
         read (nfparam,*) start, sstop, step
         linecount = linecount + 1


c  keyword 'blenlimits' gives the parameters for blended line abundance
c                       matches.  delwave is the wavelength offset 
c                       to the blue of first and to the red of the 
c                       last line in the blend to extend the syntheses; 
c                       step is the wavelength step size in the 
c                       computations; cogatom is the name of the
c                       element whose abundance should be varied
c                       to achieve an EW match with observations.
      elseif (keyword .eq. 'blenlimits') then
         read (nfparam,*) delwave, step, cogatom
         linecount = linecount + 1


c  keyword 'coglimits ' gives the log(W/lambda) limits for curves-of-growth
c                       rwlow and rwhigh are the beginning
c                       and ending points of the log(red.width) values,
c                       rwstep is the step in log(red.width),
c                       cogatom is the declaration of which element
c                       will have its abundance varied (necessary only
c                       for spectrum synthesis curves-of-growth,
c                       and wavestep is a forced (if desired) step size
c                       in wavelength along the line (this applies to
c                       single line computations only
      elseif (keyword .eq. 'coglimits') then
         read (nfparam,*) rwlow, rwhigh, rwstep, wavestep, cogatom
         linecount = linecount + 1


c  keyword 'limits    ' old limits format...tell the user to change the
c                       keyword and quit.

      elseif (keyword .eq. 'limits') then
      write(*,*) 'Warning: keyword changed to *synlimits*, *coglimits*'
      write(*,*) 'for Syntesis and COG calculations.'
      write(*,*) 'Here are the proper formats:'
      write(*,*) 
      write(*,*) 'synlimits <start> <stop> <step> <delta>'
      write(*,*) 'coglimits <rwlow> <rwhigh> <rwstep> <wavestep> ',
     .           '<cogatom>'
         stop


c   keyword of strong for lines which are to be considered for all of the 
c   synthesis
      elseif (keyword .eq. 'strong') then
         read (array,*) dostrong
     

c  keyword word of opacit which takes the continuus opacity and scales it
c  with the form of kaplam(i)= kaplam(i)*((factor*10000)/t(i))
c  in Opacit.f after it calulates the normal kaplam
c  if value is <= 0 then it does not do it
      elseif (keyword .eq. 'opacit') then
         read (array,*) fudge
     
      
c  any other keyword causes great grudge
      else
         write (array,1006) keyword
         call prinfo (5)
         stop

      endif
 

c  loop back to get another parameter
      go to 5
 

c  wrap things up with a few assignments
98    if (control.eq.'gridsyn' .or. control.eq.'gridplo' .or.
     .    control.eq.'binary ' .or. control.eq.'abandy ') then
         control = 'gridend'
      endif


c  assign plotting window type; if no type has been given in the
c  parameter file, then ask for it
100   if (smterm .eq. ' ') then
         array = 'GIVE THE SM TERMINAL NAME : '
         nchar = 28
         call getasci (nchar,12)
         smterm = chinfo(1:nchar)
         ivstat = ivcleof(12,1)
      endif
      if (smterm.eq.'x11' .or. smterm.eq.'X11') then
         if    (control .eq. 'synth  ' .or.
     .          control .eq. 'synpop ' .or.
     .          control .eq. 'synplot' .or.
     .          control .eq. 'isoplot' .or.
     .          control .eq. 'gridsyn' .or.
     .          control .eq. 'gridplo' .or.
     .          control .eq. 'doflux ' .or.
     .          control .eq. 'cogsyn ' .or.
     .          control .eq. 'cog    ' .or.
     .          control .eq. 'isotop ' .or.
     .          control .eq. 'binary ') then
             smterm = smt1
         else
             smterm = smt2
         endif
      endif


c  for syntheses, store the plotting parameters
      if (control.eq.'synth  ' .or. control.eq.'synplot' .or.
     .    control.eq.'gridsyn' .or. control.eq.'gridplo' .or.
     .    control.eq.'binary ' .or. control.eq.'synpop ') then
         if (oldstart .eq. 0) then
            write (*,1011) 
            stop
         endif
         if (iscale .eq. 0) call plotremember (0)
         call plotremember (1)
      endif


c*****exit normally
      return


c*****format statements
1001  format (a80)
1002  format ('# OF ABUNDANCE (',i1,') AND ISOTOPIC (',i1,')',
     .        ' SYNTHESES DO NOT AGREE!   I QUIT!       ')
1006  format ('THIS OPTION IS UNKNOWN TO MOOG: ', a10, ' I QUIT!')
1007  format (79(' '))
1008  format ('step =', f10.5, 'A but it cannot be more precise than ',
     .        'the nearest 0.001A; I QUIT!')
1009  format ('WARNING: molecular eq. always done if ',
     .        'Teff < 8000K;  OK (y/n)???')
1010  format ('the units=1 option is fragile; rerun with only ',
     .       'Angstroms and units=0')
1011  format ('SYNTHESIS START NOT SET; I QUIT!')

      end

      subroutine chabund
c*****************************************************************************
c  this routine changes the input abundances according to the users request
c  and the re-runs the synthesis with the new abundances OVERWRITING the 
c  original output files, but using the same model, linelist, etc
c*****************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Pstuff.com'
      include 'Multistar.com'
      real*8 xnum
      real*4 shortnum
      character choice2


c*****set the local temporary parameters to what they were for the last synth
      newnumiso = numiso
      newnumisosyn = numisosyn
      newnumpecatom = numpecatom
      newnumatomsyn = numatomsyn
      if (newnumatomsyn .eq. 0) newnumatomsyn = 1
      do i=3,95
         newpec(i) = pec(i)
         do j=1,newnumatomsyn
            newpecabund(i,j) = pecabund(i,j)
         enddo
      enddo
      do i=1,newnumiso
         if(newnumiso .ge. 1) then
            newisotope(i)=isotope(i)
            do j=1,newnumisosyn
               newisoabund(i,j)=isoabund(i,j)
            enddo
         endif
      enddo
      if (newnumatomsyn .le. 0) newnumatomsyn = 1


c*****SPECIAL CASE
c     for the "binary" driver, present a limited set of options; only
c     the abundances of the elements already chosen for variation in
c     the parameter file can be altered
11    if (control .eq. 'binary ') then
         istat = ivcleof(4,1)
         if (syncount .eq. 1) then
            array = 'Abundance Alterations for the PRIMARY STAR:   '
         else
            array = 'Abundance Alterations for the SECONDARY STAR: '
         endif
         istat = ivwrite(5,5,array,46)
         array = 'Atom   Abundance (relative to initial model)'
         istat = ivwrite(6,1,array,49)
         line = 6
         do i=3,95
            if(newpec(i) .eq. 1) then
               line = line + 1
               write (array,1001) i,(newpecabund(i,j),j=1,newnumatomsyn)
               istat = ivwrite(line,1,array,57)
            endif
         enddo
         array = 'Options: c = change abundances '
         istat = ivwrite(line+1,1,array,41)
         array = '         x = exit no changes    q = rerun synth'
         istat = ivwrite(line+2,1,array,47)
         array = 'What is your choice? '
         nchars = 21
         call getasci (nchars,line+4)
         choice = chinfo(1:1)
         if (choice.ne.'c' .and. choice.ne.'x' .and.
     .       choice.ne.'q') go to 11
      endif
         
        
c*****for the "synth" driver, present the user with the current abundance 
c     alterations, and the options; find out what is desired
1     if (control .eq. 'synth'  .or. 
     .    control .eq. 'isotop' .or.
     .    control .eq. 'synpop') then
         line = 4
         istat = ivcleof(line,1)
         write (array,1006)
         line = line + 1
         istat = ivwrite(6,1,array,72)
         line = line + 1
         do i=3,95
            if(newpec(i) .eq. 1) then
               line = line + 1
               write (array,1001) i,(newpecabund(i,j),j=1,newnumatomsyn)
               istat = ivwrite(line,1,array,57)
            endif
         enddo
         if (newnumiso .gt. 0) then
            do i=1,newnumiso
               line = line + 1
               write (array,1002) i, newisotope(i), 
     .                            (newisoabund(i,j),j=1,newnumisosyn)
               istat = ivwrite(line,1,array,68)
            enddo
         endif
         write (array,1007)
         istat = ivwrite(line+1,1,array,61)
         write (array,1008)
         istat = ivwrite(line+2,1,array,72)
         array = 'What is your choice? '
         nchars = 21
         call getasci (nchars,line+3)
         choice = chinfo(1:1)
         if (choice.ne.'c' .and. choice.ne.'i' .and.
     .       choice.ne.'n' .and. choice.ne.'x' .and.
     .       choice.ne.'q') go to 1
      endif

         
c*****for "synth", change elemental abundances
      if     (choice .eq. 'c') then
20       istat = ivcleof(line+1,1)
         array = 'Which element to change? '
         nchars = 25
         call getnum (nchars,line+1,xnum,shortnum)
         if (xnum.lt.2.0 .or. xnum.gt.95.) go to 20
         j = nint(xnum)
         if (newpec(j) .eq. 1) then
25          array = 'n = new abundances, or z = zero offsets? '
            nchars = 41
            call getasci (nchars,line+2)
            choice2 = chinfo(1:1)
            if     (choice2 .eq. 'z') then 
               newpec(j) = 0
               do i=1,5
                  newpecabund(j,i) = 0.0
               enddo
               newnumpecatom = newnumpecatom - 1
            elseif (choice2 .eq. 'n') then
               write (array,1004)
               istat = ivwrite(line+3,1,array,40)
               read (*,*) (newpecabund(j,i),i=1,newnumatomsyn)
            else
               go to 25
            endif
         else
            newpec(j) = 1
            write (array,1004)
            istat = ivwrite(line+2,1,array,40)
            read (*,*) (newpecabund(j,i),i=1,newnumatomsyn) 
            newnumpecatom = newnumpecatom + 1
         endif


c*****for "synth", change isotopic factors
      elseif (choice .eq. 'i') then
         istat = ivcleof(line+1,1)
         array = 'Options: c = change an isotopic factor'
         istat = ivwrite(line+1,1,array,49)
         array = '         n = enter a new isotope'
         istat = ivwrite(line+2,1,array,48)
30       array = 'What is your choice? '
         nchars = 22
         call getasci (nchars,line+3)
         choice2 = chinfo(1:1)
         if (choice2 .eq. 'c') then
35          istat = ivcleof(line+1,1)
            array =  'Which isotope number from the list? '
            nchars = 36
            call getnum (nchars,line+1,xnum,shortnum)
            j = nint(xnum)
            if (j.lt.1 .or. j.gt.newnumiso) go to 35
            istat = ivcleof(line+2,1)
            array = 'What are the new division factors? '
            istat = ivwrite(line+2,1,array,35)
            read (*,*) (newisoabund(j,i),i=1,newnumisosyn)
         elseif (choice2 .eq. 'n') then
            newnumiso = newnumiso + 1
            istat = ivcleof(line+1,1)
            array = 'What is the new isotope designation? '
            nchars = 37
            call getnum (nchars,line+4,xnum,shortnum)
            newisotope(newnumiso) = xnum
            array = 'What are its division factors? '
            istat = ivwrite(line+2,1,array,31)
            read (*,*) (newisoabund(newnumiso,i),i=1,newnumisosyn)
         else
            go to 30
         endif
            

c*****for "synth", change the number of syntheses
      elseif (choice .eq. 'n') then
55       array = 'How many synths? '
         nchars = 17
         call getnum (nchars,line+5,xnum,shortnum)
         if (xnum .gt. 5.) go to 55
         newnumatomsyn = nint(xnum)
         go to 1


c*****for "synth", exit the routine without changing anything
      elseif (choice .eq. 'x') then
         return


c*****for "synth", make the proposed alterations permanent; then
c     return to the calling routine, which allegedly will
c     redo the syntheses.
      elseif (choice .eq. 'q') then
         numiso = newnumiso
         numisosyn = newnumisosyn
         numpecatom = newnumpecatom
         numatomsyn = newnumatomsyn
         do i=3,95
            pec(i) = newpec(i)
            do j=1,numatomsyn
               pecabund(i,j) = newpecabund(i,j)
            enddo
         enddo
         do i=1,numiso
            if(numiso .ge. 1) then
               isotope(i) = newisotope(i)
               do j=1,numisosyn
                  isoabund(i,j)=newisoabund(i,j)
               enddo
            endif
         enddo
         return
      endif


c*****loop back and print out the main menu again
      if (control .eq. 'synth  ') then
         go to 1
      else
         go to 11
      endif


c*****format statements
1001  format (i3, 4x, 5(f8.3, 2x))
1002  format (i2, 2x, f10.5, 5(3x, f8.3))
1004  format ('Enter the new offsets on the line below:')
1006     format ('element, abundance offsets   OR   ',
     .            'isotope number, isotope name, factors')
1007     format ('Options: c = change abundance       ',
     .           'i = change isotopic ratio')
1008     format('         n = change # syntheses     q = rerun ',
     .          'syntheses        x = exit')

      end

      subroutine writenumber (xnum)
c******************************************************************************
c     This subroutine decides on the order-of-magnitude of a number and
c     writes it to a character string in a reasonable format
c******************************************************************************

      include 'Pstuff.com'
      real*4 xnum, lognum
      integer numdec


      lognum = alog10(abs(xnum))
      if     (lognum .ge. 6.) then
         write (errmess,1002) 
      elseif (lognum .ge. 0.) then 
         numdec = 5 - nint(lognum)
         write (errmess,1001) numdec
      else   
         write (errmess,1003)
      endif
      write (array,errmess) xnum
      return


c*****format statements
1001  format ('(f8.',i1,'$)')
1002  format ('(1pe8.1$)')
1003  format ('(f8.5$)')


      end

      subroutine crosscorr (ishift,rxy,xcross,ycross,npx)
c******************************************************************************
c     This routine determines the correlation of array 'x' and array 'y',
c     comparing array elements 'i' in 'x' with elements 'i+ishift';
c     the number of points in each array is assumed to be equal.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      real*4 xcross(100000),ycross(100000)
      real*8 xsum,ysum,xysum,x2sum,y2sum,covar,varx,vary
      real*8 xx,yy


      xsum = 0.
      ysum = 0.
      xysum = 0.
      x2sum = 0.
      y2sum = 0.
      if (ishift .ge. 0) then
         minpt = 1
         maxpt = npx - ishift
      else
         minpt = iabs(ishift) + 1
         maxpt = npx
      endif


      do 10 i=minpt,maxpt
         xx = xcross(i)
         yy = ycross(i+ishift)
         xsum = xsum + xx
         ysum = ysum + yy
         xysum = xysum + xx*yy
         x2sum = x2sum + xx*xx
10       y2sum = y2sum + yy*yy


      xn = real(maxpt - minpt + 1)
      covar = xn*xysum - xsum*ysum
      varx = dsqrt(xn*x2sum - xsum*xsum)
      vary = dsqrt(xn*y2sum - ysum*ysum)
      rxy = sngl(covar/(varx*vary))


      return
      end

      subroutine cog
c******************************************************************************
c     This routine produces sets of curves-of-growth                    
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'


c*****examine the parameter file
      call params


c*****open the files for standard output and summary curves-of-growth
      nf1out = 20
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21
      lscreen = lscreen + 2
      array = 'SUMMARY C-O-G OUTPUT'
      nchars = 20
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)
      nf5out = 26
      lscreen = lscreen + 2
      array = 'POSTSCRIPT PLOT OUTPUT'
      nchars = 22
      call infile ('output ',nf5out,'formatted  ',0,nchars,
     .             f5out,lscreen)


c*****open and read the model atmosphere
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
102   nfmodel = 30
      lscreen = lscreen + 2
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****open and read the line list file; get ready for the line calculations
      nflines = 31
      lscreen = lscreen + 2
      array = 'THE LINE LIST'
      nchars = 13
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .             flines,lscreen)
      isynth = 1
101   call inlines (1)
      call eqlib
      call nearly (1)


c*****define the range of lines (the whole list, in this case)
      mode = 1
      call linlimit
      if (lim1line .lt. 0) then
         call finish (0)
         return
      endif

 
c*****do the curves of growth, making plots if desired
      do lim1=lim1line,lim2line
         lim2 = lim1
         call curve
         call pltcog
         if (choice .eq. 'm') then
            close (unit=nfmodel)
            close (unit=nflines)
            rewind nf1out
            rewind nf2out
            rewind nf5out
            array = 'THE NEW MODEL ATMOSPHERE'
            nchars = 24
            fmodel =  'no_filename_given'
            go to 102
         endif
         if (choice .eq. 'v') go to 101
         array = 'DO ANOTHER CURVE-OF-GROWTH ([y]/n)? '
         nchars = 36
         lscreen = 16
         call getasci (nchars,lscreen)
         choice = chinfo(1:1)
         if (choice .eq. 'n') then
            call finish (0)
            return
         endif
      enddo


c****end the computations
      call finish (0)
      return


      end                                                               

      subroutine pltspec (line,ncall)
c******************************************************************************
c     This subroutine controls the plotting of the synthesized and 
c     observed data
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      real*8 xnum
      real*4 yyadd, xxadd, vveladd, yymult
      integer ncall


c*****initialize some variables, or re-set them to old values
3     if (ncall .eq. 1) then
         if (iscale .eq. 0) then
            choice = 's'
         else
            choice = '1'
         endif
      else
         call plotremember (4)
      endif


c*****make a special "choice" for grid syntheses, which go directly to
c*****postscript files if desired
      if (control.eq.'gridsyn' .or. control.eq.'gridend' .or.
     .    control.eq.'gridplo') then
         choice = 'g'
      endif


c*****begin by reading in an observed spectrum
      if (specfileopt.ge.1 .and. plotopt.eq.2 .and. ncall.eq.1) then
         call readobs (line)
         if (lount .eq. -1) then
            array = 'OBSERVED SPECTRUM FILE PROBLEM!  I QUIT.'
            istat = ivwrite (line+4,3,array,40)
            stop
         endif
      endif
      

c*****go through the option list; the routine may be exited at this point
      istat = ivcleof(4,1)
1     if (choice .eq. 'q') return


c*****or a default plot may be made upon entering the routine
      if (choice.eq.'1' .or. choice.eq.'g') then
c*****make a cross correlation to line up synthetic and observed spectra 
c*****in velocity (wavelength) space; the user can turn this off/on
c*****not working for you
         call smooth (-1,ncall)
c----------------------------------------------------------------------------
         if (plotopt.eq.2 .and. ncall.eq.1) then
            vfactor = 1.0 + veladd/2.99795e+5
            do i=1,lount
               xobs(i) = vfactor*xobs(i)
            enddo
            if (maxshift .gt. 0) then
               call correl (maxshift)
               vfactor = 1.0 + deltavel/2.99795e+5
               do i=1,lount
                  xobs(i) = vfactor*xobs(i)
               enddo
            endif
         endif
c----------------------------------------------------------------------------
         if (ncall .eq. 1) then
            wmiddle = (start + sstop)/2.
            if (iunits .eq. 1) wmiddle = 1.d-4*wmiddle
            if (ymult .eq. 0.0) ymult = 1.0
            do i=1,lount
               yobs(i) = ymult*yobs(i)
               yobs(i) = yadd+yobs(i)
            enddo
            if (xlo .eq. xhi) then
               xlo = start
               xhi = sstop
               if (iunits .eq. 1) then
                  xlo = 1.d-4*xlo
                  xhi = 1.d-4*xhi
               endif
            endif
            if (ylo .eq. yhi) then
               ylo = 0.
               yhi = 1.1
            endif
         endif
         call boxit
      endif
            
         
c*****or the synthetic spectra may be resmoothed; if a problem develops in
c     a user-specified parameter (like a Gaussian FWHM that is too large),
c     then output a warning and let user decide what to do next
      if (choice .eq. 's') then
         call smooth (line+2,1)
2        if (smtype .eq. 'e') then
            array = 'REDO THE SMOOTHING (y/n)? '
            nchars = 26
            call getasci (nchars,line+9)
            smtype = chinfo(1:1)
            if (smtype .eq. 'n') then
               go to 100
            else
               istat = ivcleof (10,1)
               go to 2
            endif
         endif
         if (xlo .eq. 0.0 .and. xhi .eq. 0.0) then
            xlo = start
            xhi = sstop
            if (iunits .eq. 1) then
               xlo = 1.d-4*xlo
               xhi = 1.d-4*xhi
            endif
         endif
      endif


c*****or the observations may be rescaled
      if (choice .eq. 'r') then
         array = 'MULTIPLY THE OBSERVED POINTS BY WHAT FACTOR? '
         nchars = 45
         call getnum (nchars,13,xnum,yymult)
         ymult = ymult*yymult
         do i=1,lount
            yobs(i) = yymult*yobs(i)
         enddo
      endif


c*****or the observations may be shifted by an additive constant
      if (choice .eq. 'a') then
         array = 'ADD WHAT NUMBER TO THE OBSERVED POINTS? '
         nchars = 40
         call getnum (nchars,13,xnum,yyadd)
         yadd = yadd + yyadd
         do i=1,lount
            yobs(i) = yyadd + yobs(i)
         enddo
      endif


c*****or the observations may be shifted by a constant wavelength
      if (choice .eq. 'w') then
         array = 'SHIFT THE OBSERVED POINTS BY WHAT WAVELENGTH? '
         nchars = 46
         call getnum (nchars,13,xnum,xxadd)
         wfactor = xxadd/((start+sstop)/2.)
         veladd = veladd + wfactor*2.99795d+5
         vfactor = 1.0 + wfactor
         do i=1,lount
            xobs(i) = vfactor*xobs(i)
         enddo
      endif


c*****or the observations may be shifted by a constant velocity
      if (choice .eq. 'v') then
         array = 'SHIFT THE OBSERVED POINTS BY WHAT VELOCITY (KM/S)? '
         nchars = 51
         call getnum (nchars,13,xnum,vveladd)
         veladd = veladd + vveladd
         vfactor = 1.0 + vveladd/2.99795d+5
         do i=1,lount
            xobs(i) = vfactor*xobs(i)
         enddo
      endif


c*****or the plot boundaries may be changed
      if (choice .eq. 'c') then
         write (array,1001) xlo
         nchars = 29
         call getnum (nchars,15,xnum,xlo)
         write (array,1002) xhi
         nchars = 30
         call getnum (nchars,15,xnum,xhi)
         write (array,1003) ylo
         nchars = 34
         call getnum (nchars,15,xnum,ylo)
         write (array,1004) yhi
         nchars = 31
         call getnum (nchars,15,xnum,yhi)
         call boxit
      endif


c*****or the cross hairs can be used to zoom in on a part of the plot
      if (choice .eq. 'z') then
         array = 'MARK THE LOWER LEFT HAND CORNER WITH THE CURSOR'
         istat = ivcleof(13,1)
         istat = ivwrite(13,3,array,47)
c         call pointcurs
         xlo = xplotpos
         ylo = yplotpos
         array = 'MARK THE UPPER RIGHT HAND CORNER WITH THE CURSOR'
         istat = ivcleof(14,1)
         istat = ivwrite (14,1,array,48)
c         call pointcurs
         xhi = xplotpos
         yhi = yplotpos
         call boxit
         if (iunits .eq. 1) then
            xlo = 1.d-4*xlo
            xhi = 1.d-4*xhi
         endif
         whichwin = '1of1'
      endif



c*****or cursor position can be returned
      if (choice .eq. 'p') then
         array = 'MARK THE POSITION WITH THE CURSOR'
         istat=ivcleof(21,1)
         istat=ivwrite(13,3,array,34)
c         call drawcurs
         go to 100
      endif


c*****or the title of the model can be changed
      if (choice .eq. 't') then
         array = 'ENTER THE NEW TITLE'
         istat = ivcleof(21,1)
         istat = ivwrite (13,3,array,19)
         read (*,1005) moditle
      endif
   

c*****or the spectra can be replotted, with a separate plot showing the 
c     observed/synthtic spectrum differences
      if (choice .eq. 'd') then
         deviations = 1
         whichwin = '2of2'
      endif


c*****or the plot boundaries may be reset to the original values;
c     this is a basic starting over plot
      if (choice .eq. 'o') then
         xlo = start
         xhi = sstop
         if (iunits .eq. 1) then
            xlo = 1.d-4*xlo
            xhi = 1.d-4*xhi
         endif
         xlo = origxlo
         xhi = origxhi
         ylo = origylo
         yhi = origyhi
         lim1obs = 1
         lim2obs = lount
         deviations = 0
         call boxit
      endif


c*****or the plot can simply be redone
      if (choice .eq. 'm') then
         go to 90
      endif


c*****now either here make a hardcopy plot
      if (choice .eq. 'h') then
         if (control .eq. 'binary ') then
            plotroutine = 'hard_land_bin '
         else
            plotroutine = 'hard_land_spec'
         endif
         if (deviations .eq. 0) then
            whichwin = '1of1'
         else
            whichwin = '2of2'
         endif
         lscreen = 12
c         call makeplot (lscreen)
         go to 100
      endif


c*****or write the plot to a postscript file
      if (choice.eq.'f' .or. choice.eq.'g') then
         if (control .eq. 'binary ') then
            plotroutine = 'file_land_bin '
         else
            plotroutine = 'file_land_spec'
         endif
         if (deviations .eq. 0) then
            whichwin = '1of1'
         else
            whichwin = '2of2'
         endif
         lscreen = 12
c         call makeplot (lscreen)
         if (choice .eq. 'g') then
            return
         else
            go to 90
         endif
      endif

      
c*****or return to the calling routine in order to change abundances
      if (choice .eq. 'n') then
         call plotremember (3)
         return
      endif


c*****or add an additional uniform amount of flux, expressed in terms of
c     the current continuum flux; this only is approximately physically
c     correct if spectrograph smoothing is negligible compared to other
c     smoothing
      if (choice .eq. 'l') then
         write (array,*)
     .      'WHAT IS THE ADDITIONAL FLUX IN TERMS OF CONTINUUM [0.0]? '
         nchars = 57
         call getnum (nchars,15,xnum,addflux)
         call smooth (-1,ncall)
      endif
 
 
c*****or if total confusion has happened in the plotting, reset all parameters
c     to their original values, and replot
      if (choice .eq. 'u') then
         call plotremember (2)
         ncall = 1
         go to 3
      endif
 
 
c*****or plot on the terminal
90    if (control.eq.'gridsyn' .or. control.eq.'gridend' .or.
     .    control .eq. 'gridplo') return
      if (control .eq. 'binary ') then
         plotroutine = 'term_land_bin '
      else
         plotroutine = 'term_land_spec'
      endif
      lscreen = 12
      if (choice.eq.'f' .or. choice.eq.'h') choice = 'm'
      if (deviations .eq. 0) then
         whichwin = '1of1'
      else
         whichwin = '2of2'
      endif
c      call makeplot (lscreen)


c*****finally, print the option table
100   istat = ivcleof (5,1)
      array = 'OPTIONS?    s=new smoothing     r=rescale obs.     '
      istat = ivwrite (5,3,array,48)
      array = '            a=add # to obs.     h=hardcopy         '
      istat = ivwrite (6,3,array,48)
      array = '            c=change bounds     q=quit             '
      istat = ivwrite (7,3,array,48)
      array = '            m=redo same plot    o=orig. plot bounds'
      istat = ivwrite (8,3,array,51)
      array = '            v=velocity shift    w=wavelength shift '
      istat = ivwrite (9,3,array,51)
      array = '            z=zoom in on plot   p=cursor position  '
      istat = ivwrite (10,3,array,51)
      array = '            t=change title      f=postscript file  '
      istat = ivwrite (11,3,array,51)
      array = '            n=new abundances    d=obs/syn deviation'
      istat = ivwrite (12,3,array,51)
      array = '            l=add veiling       u=undo all; replot '
      istat = ivwrite (13,3,array,51)
      array = 'What is your choice? '
      nchars = 21
      call getasci (nchars,15)
      choice = chinfo(1:1)


c*****reprint the option table if the choice is not understood
c     or take action on the choice
      if (choice.eq.'s' .or. choice.eq.'r' .or.
     .    choice.eq.'a' .or. choice.eq.'h' .or.
     .    choice.eq.'c' .or. choice.eq.'q' .or.
     .    choice.eq.'m' .or. choice.eq.'o' .or.
     .    choice.eq.'v' .or. choice.eq.'w' .or.
     .    choice.eq.'z' .or. choice.eq.'p' .or.
     .    choice.eq.'t' .or. choice.eq.'f' .or.
     .    choice.eq.'n' .or. choice.eq.'d' .or.
     .    choice.eq.'l' .or. choice.eq.'u') then
         go to 1
      else 
         go to 100
      endif


c*****format statements
1001     format ('LEFT WAVELENGTH (',f9.2,'): ')
1002     format ('RIGHT WAVELENGTH (',f9.2,'): ')
1003     format ('BOTTOM RELATIVE FLUX (',f9.2,'): ')
1004     format ('TOP RELATIVE FLUX (',f9.2,'): ')
1005     format(a80)


      end
      

      subroutine synth                   
c******************************************************************************
c     This program synthesizes a section of spectrum and compares it
c     to an observation file.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Dummy.com'


c*****examine the parameter file
      call params


c*****open the files for: standard output, raw spectrum depths, smoothed 
c     spectra, and (if desired) IRAF-style smoothed spectra
      nf1out = 20     
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21               
      lscreen = lscreen + 2
      array = 'RAW SYNTHESIS OUTPUT'
      nchars = 20
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)
      if (plotopt .ne. 0) then
         nf3out = 22               
         lscreen = lscreen + 2
         array = 'SMOOTHED SYNTHESES OUTPUT'
         nchars = 25
         call infile ('output ',nf3out,'formatted  ',0,nchars,
     .                f3out,lscreen)
         if (f5out .ne. 'optional_output_file') then
            nf5out = 26
            lscreen = lscreen + 2
            array = 'POSTSCRIPT PLOT OUTPUT'
            nchars = 22
            call infile ('output ',nf5out,'formatted  ',0,nchars,
     .                   f5out,lscreen)
         endif
      endif
      if (iraf .ne. 0) then
         nf4out = 23               
         lscreen = lscreen + 2
         array = 'IRAF ("rtext") OUTPUT'
         nchars = 24
         call infile ('output ',nf4out,'formatted  ',0,nchars,
     .                f4out,lscreen)
      endif


c*****open and read the model atmosphere file
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****open the line list file and the strong line list file
      nflines = 31
      lscreen = lscreen + 2
      array = 'THE LINE LIST'
      nchars = 13
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .              flines,lscreen)
      if (dostrong .gt. 0) then
         nfslines = 32
         lscreen = lscreen + 2
         array = 'THE STRONG LINE LIST'
         nchars = 20
         call infile ('input  ',nfslines,'formatted  ',0,nchars,
     .                 fslines,lscreen)
      endif
      

c*****do the syntheses
      choice = '1'
      do i=1,100
         if (i .eq. 100) then
            write (*,1002) 
            stop
         endif
         ncall = 1
         call getsyns (lscreen,ncall)
         

c*****now either don't make a plot (plotopt = 0) 
c                plot the synthetic spectrum, (plotopt = 1)
c                plot syntheses and observation (plotopt = 2) 
c                or just smooth the syntheses (plotopt = 3)
         if (choice .eq. 'n') then
            ncall = 2
         else
            ncall = 1
         endif
         if     (plotopt .eq. 0) then
            choice = 'q'
         elseif (plotopt .eq. 1) then
            call pltspec (lscreen,ncall)
         elseif (plotopt .eq. 2) then
            nfobs = 33               
            lscreen = lscreen + 2
            array = 'THE OBSERVED SPECTRUM'
            nchars = 21
            if (specfileopt .eq. 1) then
               call infile ('input  ',nfobs,'unformatted',2880,nchars,
     .                      fobs,lscreen)
            else
               call infile ('input  ',nfobs,'formatted  ',0,nchars,
     .                      fobs,lscreen)
            endif
            call pltspec (lscreen,ncall)
         elseif (plotopt .eq. 3) then
            call smooth (-1,ncall)
            choice = 'q'
         else
            write (*,1001)
            stop
         endif
         if (choice .eq. 'q') then
            call finish (0)
            exit
         endif
      enddo



c*****format statements
1001  format ('for syntheses, parameter "plot" must be 0, 1, 2, or 3;',
     .        ' I QUIT!')
1002  format ('something wrong:  max number (99) of synthesis ',
     .        'cycles exceeded; I QUIT!')



      end 

      subroutine total
c******************************************************************************
c     This routine integrates to get an equivalent width.                   
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Dummy.com'
      real*8 waveint(5000), depthint(5000)
      equivalence (waveint,dummy3), (depthint,dummy4)


c*****compute the wavelength array 
      ntotal = (sstop - start)/step + 1.3
      if (ntotal .gt. 5000) then
         write (nf1out,1002) ntotal
         write (nf2out,1002) ntotal
         return
      endif
      do i=1,ntotal                                                    
         waveint(i) = start + step*(i-1)    
      enddo


c*****use the RINTEG routine to do an integration
      answer = 1000.*rinteg(waveint,d,depthint,ntotal,0.)         
      write (nf1out,1001) answer, ntotal                               
      write (nf2out,1001) answer, ntotal                               
      w(ncurve) = answer/1000.


c*****Then recheck using Simpson's rule
      ntot = ntotal
      if(ntotal/2*2 - ntotal .eq. 0) ntot = ntotal - 1
      answer = d(1) + 4.*d(2) + d(ntot)
      ntot = ntot - 2
      do i=3,ntot,2                                                   
         answer = answer + 2.*d(i) + 4.*d(i+1)
      enddo
      answer = 1000.*step/3.*answer
      write (nf1out,1006) answer
      write (nf2out,1006) answer
      return


c*****format statements
1001  format (' equivalent width: ',f8.2,' mA.',5x,
     .        5x,'number of points: ',i5)
1002  format (i7,' POINTS ARE TOO MANY FOR THE INTEGRATION')
1006  format(' Simpson rule check on equivalent width =',f8.2)          


      end

      subroutine gammabark
c******************************************************************************
c     This subroutine pulls in damping factors from Barklem data
c     So far, these data have been compiled from:
c                  1. Barklem, P. S., Piskunov, N., & O'Mara, B. J. 2000, 
c                     A&ApS, 142, 467 for (mostly) neutral species
c                  2. Barklem, P. S., & Aspelund-Johansson, J. 2005, A&Ap, 
c                     435, 373 for Fe II lines with E_lower < 70000 cm-1
c  Added column to Barklem.dat for radiative damping, Gamma_rad.  -AMcW 12/2013
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Pstuff.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dampdat.com'
      data firstread/0/
      character*80 line


c*****on first entry to this routine, read damping data from either 
c    'Barklem.dat' or 'BarklemUV.dat', depending on the wavelength region 
c    of the linelist; read Van der Waals params, if radiative damping 
c    data are present
      if (firstread .eq. 0) then
         if (wave1(nlines) .gt. 3000.) then
            nwant = 35
         else
            nwant = 36
         endif
         do k=1,30000
            call blankstring (line)
            read (nwant,1001,end=10) line 
            read (line,*) wavebk(k), idbk(k), gammabk(k), alphabk(k)
            if (line(34:) .ne. '    ') then
               read(line(34:),*) gammarad(k)
            else
               gammarad(k) = 0.0
            endif
         enddo
10       numbark = k -1
         firstread = 1
      endif
     

c*****identify the Barklem list positions of the wavelength limits of
c     the input line list
      wavemin = 10000000.
      do j=1,nlines+nstrong
         if (wave1(j) .lt. wavemin) wavemin = wave1(j)
      enddo
      wavemax = 0.
      do j=1,nlines+nstrong
         if (wave1(j) .gt. wavemax) wavemax = wave1(j)
      enddo
      do k=1,numbark
         if (wavemin-wavebk(k) .lt. 1.0) then
            nummin = k
            exit
         endif
      enddo
      do k=nummin,numbark
         if (wavebk(k)-wavemax .gt. 1.0) then
            nummax = k
            exit
         endif
      enddo


c*****search for Barklem data
       do j=1,nlines+nstrong
         gambark(j) = -1.
         alpbark(j) = -1.
         gamrad(j)  = -1.
         if (atom1(j) .gt. 100.) cycle
         iatom10 = nint(10.*atom1(j))
         do k=nummin,nummax
            waveerror = -(wave1(j) - wavebk(k))/wavebk(k)
            iii = nint(10.*idbk(k))
            if (dabs(waveerror).lt.5.0d-06 .and.
     .          iii .eq. iatom10) then
               gamrad(j)  = gammarad(k)
               gambark(j) = 10.**gammabk(k)
               alpbark(j) = (1.-alphabk(k))/2.
               exit
            endif
            if (waveerror .gt. 5.0d-06) exit
         enddo
      enddo


c*****exit normally
      return


c*****format statements
1001  format (a80)
      end

       integer function ivcleof(y,x)
c******************************************************************************
c    This routine clears to the end of the screen, beginning with the
c    position row=y, column=x. The cursor is then placed at (y,x)
c******************************************************************************

       include 'Pstuff.com'
       character blank*79
       integer y,x,ypos,xpos
 
       write(blank,1001)
1001   format(79(' '))
       istat = ivwrite(y,x,blank,79)
       xpos = 1
       ypos = y


       do 11 ipos=ypos,maxline
          istat = ivmove(ipos,xpos)
11        istat = ivcleol()
       istat = ivmove(y,x)
c
       ivcleof = 0
       return
       end





       integer function ivwrite(y,x,arr,ccount)
c
c    This routine writes out a string of characters from 'arr',
c    with the first character beginning at row=y, column=x. The length
c    of the string may be at most 79 characters, and this routine
c    will not write on the 80th column or the 25th row of the screen.
c
       include 'Pstuff.com'
       integer y,x,count,ccount
       character arr*(*),dummy*80,string(80)*1,esc*1
       equivalence (dummy,string(1))
c
       count = ccount
       if (y .gt. maxline .or. x .gt. 79) then
          ivwrite = -1
          return
       endif
c
       esc = char(27)
       dummy = arr
       count = min0(80-x,count)
c       
       if (x .lt. 10) then
          if (y .lt. 10) then
             write (*,1007) esc,y,x,(string(i),i=1,count)
1007         format(1x,a1,'[',i1,';',i1,'H',80a1)
          else
             write (*,1006) esc,y,x,(string(i),i=1,count)
1006         format(1x,a1,'[',i2,';',i1,'H',80a1)
          endif
       else 
          if (y .lt. 10) then
             write (*,1005) esc,y,x,(string(i),i=1,count)
1005         format(1x,a1,'[',i1,';',i2,'H',80a1)
          else
             write (*,1004) esc,y,x,(string(i),i=1,count)
1004         format(1x,a1,'[',i2,';',i2,'H',80a1)
          endif
       endif
c
       ivwrite = 0
       return
       end






       integer function ivmove(y,x)
c
c    This routine moves the cursor to position row=y, column=x.
c    It checks to be sure that y does not exceed 'maxline', and x does not
c    exceed 79 (the screen limits).
c
       include 'Pstuff.com'
       integer y,x
       character esc*1
c
       if (y .gt. maxline .or. x .gt. 79) then
          ivmove = -1
          return
       endif
c
       esc = char(27)
c       
       if (x .lt. 10) then
          if (y .lt. 10) then
             write (*,1007) esc,y,x
1007         format(1x,a1,'[',i1,';',i1,'H')
          else
             write (*,1006) esc,y,x
1006         format(1x,a1,'[',i2,';',i1,'H')
          endif
       else 
          if (y .lt. 10) then
             write (*,1005) esc,y,x
1005         format(1x,a1,'[',i1,';',i2,'H')
          else
             write (*,1004) esc,y,x
1004         format(1x,a1,'[',i2,';',i2,'H')
          endif
       endif
c
       ivmove = 0
       return
       end



    


       integer function ivcleol()
c    This routine clears to the end of a line, beginning with the current
c    cursor position.
c
       character*1 esc
c
       esc = char(27)
       write(*,1001) esc
1001   format(1x,a1,'[K')
c
       ivcleol = 0
       return
       end




       integer function ivbold(on)
c    
c    This routine either turns on the bold-face lettering, if on=1,
c    or turns it off, if on=0
c
       integer on
       character*1 esc
c
       esc = char(27)
       if(on.eq.1) then
             write(*,'(1x,a1,a)') esc,'[1m'
       else
             write(*,'(1x,a1,a)') esc,'[0m'
       endif 
c
       ivbold = 0
       return
       end





       integer function ivundl(on)
c
c    This routine either turns on the underlining of text, if on=1,
c    or turns it off.
c
       integer on
       character*1 esc
c
       esc = char(27)
       if(on.eq.1) then
             write(*,'(1x,a1,a)') esc,'[4m'
       else
             write(*,'(1x,a1,a)') esc,'[0m'
       endif 
c
       ivundl = 0
       return
       end

 

      subroutine infile (type,iunit,mode,irec,charcount,fname,line)
c******************************************************************************
c     this routine serves to open files for reading, and does minimal
c     error checking.
c******************************************************************************

      include 'Atmos.com'
      include 'Pstuff.com'
      integer charcount
      character type*7,kstat*7,yesno*1,mode*11
      character fname*80

c  decide on the file status desired
      jstat = 0
      if     (type .eq. 'input  ') then
         kstat = 'old    '
      elseif (type .eq. 'output ') then
         kstat = 'new    '
      elseif (type .eq. 'overout') then
         kstat = 'unknown'
      endif

c  write out the appropriate message about this file
5     nchars = charcount
      if (fname .eq. 'optional_output_file') then
         return
      elseif (fname .eq. 'no_filename_given') then
         array(charcount+1:charcount+24) ='; what is the filename? '
         charcount = charcount + 24
         call getasci (charcount,line)
         fname = chinfo
      else
         array(charcount+1:charcount+24) ='; here is the filename: '
         array(charcount+25:79) = fname
         charcount = 79
         call putasci (charcount,line)
         if (type .ne. 'input  ') kstat = 'unknown'
      endif
     
c  open the file specified by the user, earlier or now
6     if (mode .eq. 'formatted  ') then
         open (unit=iunit,file=fname,access='sequential',
     .         form=mode,blank='null',status=kstat,
     .         iostat=jstat,err=10)
      else
         open (unit=iunit,file=fname,access='direct',
     .         form=mode,status=kstat,recl=irec,
     .         iostat=jstat,err=10)
      endif
      istat = ivmove (line+1,1)
      istat = ivcleol ()
      return

c  here are the file reading error messages;
c  if an expected file is not found, 118 is the error code for SunOS, 1018
c  is for Solaris, and 2 is for Redhat Linux operating systems.
10    if (jstat .eq. 118 .or. jstat .eq. 1018 .or.
     .    jstat .eq. 2) then
         write (errmess,1001) jstat
         istat = ivwrite (line+2,3,errmess,44)
         fname = 'no_filename_given'
         charcount = nchars
         go to 5
c  if a file is in danger of being over-written, 117 is the error code for 
c  SunOS, 1017 is for Solaris, and 128 is for Redhat Linux operating systems.
      elseif (jstat .eq. 117 .or. jstat .eq. 1017 .or.
     .        jstat .eq. 128) then
         write (errmess,1002) jstat
         istat = ivwrite (line+2,3,errmess,41)
         read (*,*) yesno
         if (yesno .eq. 'y') then
            kstat = 'unknown'
            go to 6
         else
            write (errmess,1003) 
            istat = ivwrite (line+2,3,errmess,32)
            fname = 'no_filename_given'
            charcount = nchars
            go to 5
         endif
      else
         write (errmess,1004) jstat
         istat = ivwrite (line+2,3,errmess,46)
      endif


c*****format statements
1001  format ('ERROR ',i4,': FILE DOES NOT EXIST! TRY AGAIN.') 
1002  format ('ERROR ',i4,': FILE EXISTS! OVERWRITE (y/n)?')
1003  format ('PLEASE GIVE A DIFFERENT FILENAME')
1004  format ('ERROR ',i4,': UNKNOWN FILE READING ERROR; ABORT!')


      end

      subroutine prinfo (line)
c******************************************************************************
c     this routine prints out information on the text terminal
c******************************************************************************
 
      include 'Pstuff.com'
      include 'Atmos.com'
      character errm1*80,array1*80


c*****do not print out information in real time if the code is in 
c     batch mode
      if (silent .eq. 'y') return

       
      if (line .eq. 1) then
         istat = ivcleof(4,1)
      endif

      if (line .eq. maxline-5) then
         errm1 = errmess
         array1 = array
10       array = 'WANT TO SEE MORE ([y]/n)? '
         nchars = 26
         call getasci (nchars,4+line)
         if (chinfo(1:1).eq.'y' .or. nchars.le.0) then
            istat = ivcleof(4,1)
            line = 1
            array = array1
            errmess = errm1
         elseif (chinfo(1:1) .eq. 'n') then
            errmess = 'stopinfo!'
            return
         else
            go to 10
         endif
      endif


      istat = ivwrite(4+line,1,array,79)
      errmess = 'everything OK'
      return


      end

      subroutine getnum (nchars,line,xnum,xnumsngl)
c******************************************************************************
c     this routine gets a double precision number 'xnum' and its
c     equivalent single precision number 'xnumsngl' from screen input;
c     if a non-number is typed in, the user will be queried again
c******************************************************************************

      implicit real*8 (a-h,o-z)
      real*8 xnum
      real*4 xnumsngl
      integer line


      xnum = -9999.
1     call getasci (nchars,line)
      if (nchars .lt. 0) return
      call number (nchars,line,xnum)
         if (xnum .eq. -9999.) go to 1
      xnumsngl = sngl(xnum)
      return

      end

      subroutine synspec
c******************************************************************************
c     This routine does synthetic spectra                                
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Pstuff.com'
      include 'Dummy.com'
      real*8 dd(5000)

c*****initialize the synthesis
      write (nf1out,1101)
      write (nf2out,1002) moditle(1:73)
      if (iunits .eq. 1) then
         write (nf2out,1103) start/1.d4, sstop/1.d4,
     .                       step/1.d4, delta/1.d4
      else
         write (nf2out,1102) start,sstop,step,delta
      endif
      if (iraf .eq. 1) then
         npoint = (sstop-start)/step
         write (nf4out,1104) npoint,wave,wave,step,step
         write (nf4out,1105)
         write (nf4out,1106) moditle
         do j=1,93
            if (pec(j) .gt. 0 ) then
               dummy1(j) = dlog10(xabund(j)) + 12.0
               write (nf4out,1107) names(j),dummy1(j)
            endif
         enddo
         write (nf4out,1108) vturb(1)
         write (nf4out,1109)
      endif
      if (mode .ne. 4) then 
         lim1line = 0
         lim2line = 0
         lim1obs = 0
         lim2obs = 0
         lim1 = 0
         lim2 = 0
      endif


c*****now step in wavelength as the spectrum is computed
      kount = nint((sstop - start + (step/4.0) )/step) + 1
      num = 0
      wavl = 0.


c*****first calculate or recalculated continuum quantities at the 
c     spectrum wavelength, if needed
      do n=1,kount
         num = num + 1
         wave = oldstart + (n-1)*step
         if (dabs(wave-wavl)/wave .ge. 0.001) then
            wavl = wave   
            call opacit (2,wave)    
            if (modprintopt .ge. 2) 
     .          write (nf1out,1001) wave,(kaplam(i),i=1,ntau)
            call cdcalc (1)  
            first = 0.4343*cd(1)
            flux = rinteg(xref,cd,dummy1,ntau,first)
            if (iunits .eq. 1) then
               write (nf1out,1003) 1.d-4*wave,flux
            else
               write (nf1out,1004) wave,flux
            endif
         endif


c*****find the appropriate set of lines for this wavelength, reading 
c     in a new set if this is the initial depth calculation or if
c     needed because the line list end has been reached
         if (mode .eq. 3) then
20          call linlimit
            if (lim2line .lt. 0) then
               call inlines (2)
               call nearly (1)
               go to 20
            endif
            lim1 = lim1line
            lim2 = lim2line
         endif


c*****compute a spectrum depth at this point; if there are no absorption
c     lines in the interval then just set the depth to zero without
c     extensive line calculations
         if (lineflag .lt. 0) then
            d(num) = 0.
         else
            call taukap   
            call cdcalc (2)
            first = 0.4343*cd(1)
            d(num) = rinteg(xref,cd,dummy1,ntau,first)
         endif
         if (mod(n,10) .eq. 0) then
            if (iraf .eq. 1) then
               do j = 1,10
                  dd(num-10+j) = 1. - d(num-10+j)
               enddo
               write (nf4out,1110) (dd(num-10+j),j=1,10)
            endif
            if (iunits .eq. 1) then
               wave3 = 1.d-4*(wave - 9.0*step)
               write (nf1out,1112) wave3,(d(num-10+j),j=1,10)
            else
               wave3 = wave - 9.0*step
            write (nf1out,1111) wave3,(d(num-10+j),j=1,10)
            endif
            if (nf2out .gt. 0) write (nf2out,1110) (d(num-10+j),j=1,10)
         endif
         if (num .ge. 5000) num = 0
      enddo


c*****finish the synthesis
      nn = mod(num,10)
      if (nn .ne. 0) then
         if (iraf .eq. 1) then
            do j=1,nn
               dd(num-nn+j) = 1. - d(num-nn+j)
            enddo
            write (nf4out,1110) (dd(num-nn+j),j=1,nn)
         endif
         if (iunits .eq. 1) then
            wave3 = 1.d-4*(wave - 9.0*step)
            write (nf1out,1112) wave3,(d(num-nn+j),j=1,nn)
         else
            wave3 = wave - 9.0*step
            write (nf1out,1111) wave3,(d(num-nn+j),j=1,nn)
         endif
         if (nf2out .gt. 0) write (nf2out,1110) (d(num-nn+j),j=1,nn)
      endif
      if (iunits .eq. 1) then
         write (nf1out,1113) 1.d-4*wave
      else
         write (nf1out,1114) wave
      endif


c*****exit normally
       return 


c*****format statements
1001  format ('  kaplam from 1 to ntau at wavelength',f10.2/
     .        (6(1pd12.4)))
1002  format ('MODEL: ',a73)
1003  format ('AT WAVELENGTH/FREQUENCY =',f11.7,
     .        '  CONTINUUM FLUX/INTENSITY =',1p,d12.5)
1004  format ('AT WAVELENGTH/FREQUENCY =',f11.3,
     .        '  CONTINUUM FLUX/INTENSITY =',1p,d12.5)
1101  format (/'SPECTRUM DEPTHS')
1102  format (4f11.3)
1103  format (4f10.7)
1104  format ('SIMPLE  =                    T / Fits standard'/
     .        'NAXIS   =     1'/'NAXIS1  = ',i10,/
     .        'W0      =',f10.4/'CRVAL1  =',f10.4/'WPC     =',f10.4/
     .        'CDELT1  =',f10.4)
1105  format (16HORIGIN  = 'moog'/21HDATA-TYP= 'synthetic'/
     .        18HCTYPE1  = 'lambda'/21HCUNIT1  = 'angstroms')
1106  format (11HTITLE   = ',A65,1H')
1107  format ('ATOM    = ',1H',7x,a2,1H',/,'ABUND   = ',f10.2)
1108  format ('VTURB   = ',d10.4,'     /  cm/sec  ')
1109  format ('END')
1110  format (10f8.4)
1111  format (f10.3,': depths=',10f6.3)
1112  format (f10.7,': depths=',10f6.3)
1113  format ('FINAL WAVELENGTH/FREQUENCY =',f10.7/)
1114  format ('FINAL WAVELENGTH/FREQUENCY =',f10.3/)


      end                                

      subroutine ewweighted
c******************************************************************************
c     This routine computes a weighted mean EW for one line from a set 
c     of models
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Multimod.com'


c*****start the computations for a line
      if (dabs(rwlgerror) .lt. 0.01) write (nf7out,1001)
      ewweighttot = 0.
      weighttot = 0
      modcount = 0
      iatom = int(atom1(lim1)+0.0001)
      xngf = dlog10(xabund(iatom)*gf(lim1)) + deltangf


c*****for each model, interpolate in the curve-of-growth to get an EW_calc
c     for the assumed abundance
      do mmod=1,modtot
         ncurvetot = nmodcurve(mmod,lim1)
         do icurve=3,ncurvetot-2
            if (gfmodtab(mmod,lim1,icurve) .gt. xngf) then
               ic = icurve - 1
               pp = (xngf-gfmodtab(mmod,lim1,ic))/0.15
               rw = rwmodtab(mmod,lim1,ic-1)*(-pp)*(pp-1.)*(pp-2.)/6. +
     .              rwmodtab(mmod,lim1,ic)*(pp*pp-1.)*(pp-2.)/2. +
     .              rwmodtab(mmod,lim1,ic+1)*(-pp)*(pp+1.)*(pp-2.)/2. +
     .              rwmodtab(mmod,lim1,ic+2)*pp*(pp*pp-1.)/6.
               ew = 10**rw*wave1(lim1)
               go to 10
            endif
         enddo

c*****add this EW to the total, weighting it by flux*radius^2*relcount
10       ewweight = ew*weightmod(mmod,lim1)
         weighttot = weighttot + weightmod(mmod,lim1)
         ewweighttot = ewweighttot + ewweight
         if (dabs(rwlgerror) .lt. 0.01) 
     .       write (nf7out,1005) fmodinput(mmod), 
     .       fmodoutput(mmod), radius(mmod), relcount(mmod), 
     .       fluxmod(mmod,lim1), weightmod(mmod,lim1), 
     .       1000.*ew, 1000.*ewweight
      enddo


c*****write out the mean EW
      ewmod(lim1) = ewweighttot/weighttot
      abundout(lim1) =dlog10(xabund(iatom))+deltangf+12.
      if (dabs(rwlgerror) .lt. 0.01) then
         write(nf7out,1006) atom1(lim1), wave1(lim1), e(lim1,1),
     .                       dlog10(gf(lim1)), 1000.*ewmod(lim1), 
     .                       abundout(lim1)
      endif
c      write (nf7out,1006) 1000.*ewmod(lim1), abundout(lim1)
      return


c*****format statements
1001  format ('MODFILE', 5x, 'COGOUT', 9x, 'RADIUS', 3x, '*COUNT',
     .        5x, 'FLUX', 3x, 'WEIGHT', 5x, 'EW', ' EWWEIGHT')
1005  format (2a12, 1pe9.2, e9.2, e9.2, e9.2, 0pf7.1, 1pe9.2)
c1006  format ('EWmean, Abundance =', f8.1, f8.2)
1006  format ('Final: ', f5.1, 3x, f8.3, 3x, f6.3, 3x,f7.3,1x,f8.1,
     .        1x,f8.2)


      end

      subroutine defcolor (icolor)
c******************************************************************************
c     This routine decides on whether to call for a black & white hardcopy
c     plot or a colorful screen plot
c******************************************************************************

      include 'Pstuff.com'
      character*7 colors(8)


c*****assign colors to character arrays
      colors(1) = 'white  '
      colors(2) = 'red    '
      colors(3) = 'cyan   '
      colors(4) = 'yellow '
      colors(5) = 'green  '
      colors(6) = 'magenta'
      colors(7) = 'blue   '
      colors(8) = 'black  '


c      if (choice.eq.'h' .or. choice.eq.'f' .or.
c     .    choice.eq.'g') then
c         call sm_ctype (colors(8))
c      else
c         call sm_ctype (colors(icolor))
c      endif

      
      return
      end

      subroutine blends
c******************************************************************************
c     This program does abundance derivations from blended spectral features;
c     only one element will have its abundance derived per run.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Pstuff.com'
      include 'Dummy.com'
 

c*****examine the parameter file
      call params


c*****open the files for standard output and summary abundances
      nf1out = 20
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf2out = 21
      lscreen = lscreen + 2
      array = 'SUMMARY ABUNDANCE OUTPUT'
      nchars = 24
      call infile ('output ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)


c*****open and read the model atmosphere
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel


c*****initialize some variables
      isynth = 1
      isorun = 1
      iatom = nint(cogatom)
      pec(iatom) = 1
      numpecatom = 1
      pecabund(iatom,1) = 0.


c*****open and read the line list file; get ready for the line calculations
      nflines = 31
      lscreen = lscreen + 2
      array = 'THE LINE LIST'
      nchars = 13
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .              flines,lscreen)
100   call inlines (1)
      call eqlib
      call nearly (1)


c*****start the large loop that will go through each blended feature
      ewsynthopt = -1
      mode = 4
30    do lll=1,1000
         if (lim2line .eq. nlines) exit


c*****define the set of lines responsible for a blended feature
         call linlimit
         lim1 = lim1line
         lim2 = lim2line
         write (99,1007) iatom, wave1(lim1), wave1(lim2)


c*****make sure that the element whose abundance is to be fit has
c     a representative line of the blend
         ifind = 0
         do j=lim1,lim2
            if (atom1(j) .lt. 100.) then
               if (iatom .eq. int(atom1(j))) then
                  ifind = 1
                  exit
               endif
            else
               call sunder (atom1(j),ia,ib)
               if (iatom.eq.ia .or. iatom.eq.ib) then
                  ifind = 1
                  exit
               endif
            endif
         enddo
         if (ifind .eq. 0) then
            do j=lim1,lim2
               abundout(j) = 999.99
            enddo
            write (nf1out,1002)
            lim1line = lim2line + 1
            if (lim1line .le. nlines+nstrong) cycle
         endif
 

c*****do the syntheses, forcing each abundance to predict the
c     feature equivalent width; a limit of 30 iterations is imposed
c     arbitrarily
         ncurve = 1
         start = wave1(lim1) - delwave
         sstop = wave1(lim2) + delwave
         delta = wave1(lim2) - wave1(lim1) + delwave
         oldstart = start
         oldstop = sstop
         oldstep = step
         olddelta = delta
         rwlgobs = dlog10(width(lim1)/wave1(lim1))
         gf1(ncurve) = 1.
         do k=1,30
            call synspec
            call total
            error = (w(ncurve)-width(lim1))/width(lim1)
            ratio = width(lim1)/w(ncurve)
            ncurve = ncurve + 1


c*****here we go for another iteration
            if (dabs(error) .ge. 0.0075) then
               rwlcomp = dlog10(w(ncurve-1)/wave1(lim1))
               if     (rwlcomp.lt.-5.2 .and. rwlgobs.lt.-5.2) then 
                  ratio = ratio
               elseif (rwlcomp.ge.-5.2 .and. rwlgobs.ge.-5.2) then 
                  ratio = ratio**2.0
               else   
                  ratio = ratio**1.5
               endif
               gf1(ncurve) = gf1(ncurve-1)*ratio
               do j=lim1,lim2
                  if (atom1(j) .gt. 100.) then
                     call sunder (atom1(j),ia,ib)
                     if (ia.eq.iatom .or. ib.eq.iatom) then
                        do i=1,ntau                                
                           kapnu0(j,i) = kapnu0(j,i)*ratio            
                        enddo
                     endif
                  elseif (int(atom1(j)) .eq. iatom) then
                     do i=1,ntau                                
                        kapnu0(j,i) = kapnu0(j,i)*ratio            
                     enddo
                  endif
               enddo
               if (k .eq. 20) then
                  write (*,1008)
                  stop
               endif
            else
               exit
            endif
         enddo


c*****here we do the final calculation when the predicted and observed are close
         gf1(ncurve) = gf1(ncurve-1)*ratio
         do j=lim1,lim2
            if (atom1(j) .gt. 100.) then
               call sunder (atom1(j),ia,ib)
               if (ia.eq.iatom .or. ib.eq.iatom) then
                  do i=1,ntau                                
                     kapnu0(j,i) = kapnu0(j,i)*ratio            
                  enddo
               endif
            elseif (int(atom1(j)) .eq. iatom) then
               do i=1,ntau                                
                  kapnu0(j,i) = kapnu0(j,i)*ratio            
               enddo
            endif
         enddo
         call synspec
         call total
         widout(lim1) = w(ncurve)
         diff = dlog10(gf1(ncurve))
         abundout(lim1) = dlog10(xabund(iatom)) + 12.0 + diff
         if (ncurve .ne. 1) then
            write (nf1out,1001) ncurve
         endif


c*****here is where some auxiliary things like mean depth are computed
         if (lim1.eq.lim2 .and. linprintopt.ge.3) then
            wave = wave1(lim1)
            call taukap
            call cdcalc(2)
            first = 0.4343*cd(1)
            d(1) = rinteg(xref,cd,dummy1,ntau,first)
            do i=1,ntau
               dummy1(i) = xref(i)*cd(i)
            enddo
            first = 0.
            cdmean = rinteg(xref,dummy1,dummy2,ntau,first)/
     .      rinteg(xref,cd,dummy2,ntau,first)
            do i=1,ntau
               if (cdmean .lt. cd(i)) exit
            enddo
            write (nf1out,1005) lim1, cdmean, i, xref(i)
            do i=1,ntau
               if (taunu(i)+taulam(i) .ge. 1.) exit
            enddo
            write (nf1out,1006) lim1, i, dlog10(tauref(i)),
     .                          dlog10(taulam(i)), dlog10(taunu(i))
         endif


c*****assign the abundance to the strongest line of the blend that
c     contains cogatom; put 999.99's as the abundances of all but 
c     this line; go back for another blended feature
         if (lim2 .gt. lim1) then
            abunblend = abundout(lim1)
            widblend = widout(lim1)
            strongest = 0.
            linstrongest = 0
            do j=lim1,lim2
               abundout(j) = 999.99
            enddo
            do j=lim1,lim2
               if (atom1(j) .lt. 100.) then
                  if (dint(atom1(j)) .eq. cogatom) then
                     if (kapnu0(j,jtau5) .gt. strongest) then
                        strongest = kapnu0(j,jtau5)
                        linstrongest = j
                     endif
                  endif
               else
                  call sunder (atom1(j),ia,ib)
                  if (dble(ia).eq.cogatom .or. dble(ib).eq.cogatom) then
                     if (kapnu0(j,jtau5) .gt. strongest) then
                        strongest = kapnu0(j,jtau5)
                        linstrongest = j
                     endif
                  endif
               endif
            enddo
            abundout(linstrongest) = abunblend
            widout(linstrongest) = widblend
         endif
         lim1line = lim2line + 1
         if (lim1line .le. nlines+nstrong) cycle
      enddo


c*****do abundance statistics; print out a summary of the abundances 
      lim1obs = 1
      lim2obs = nlines+nstrong
      call stats
      rewind nf2out
      call lineinfo (3)


c*****here a plot may be made on the terminal (and paper) if there
c     are enough lines; then the user will be prompted on some
c     options concerning what is seen on the plot
      if (plotopt .ne. 0) then
         call pltabun
         if (choice.eq.'v' .or. choice.eq.'m') go to 100
      endif


c*****now the option will be to redo the molecular equilibrium and redo
c     the last species, at the user's option.
      if (neq .ne. 0) then
         do n=1,neq
            if (iatom .eq. iorder(n)) then
               write (array,1004)
               ikount = min0(nlines+11,maxline)
               nchars = 70
35             call getasci (nchars,ikount)
               choice = chinfo(1:1)
               if (choice.eq.'y' .or. nchars.le.0) then
                  xabund(iatom) = 10.**(average-12.)
                  call eqlib
                  call nearly (1)
                  lim1line = 0
                  lim2line = 0
                  rewind nf2out
                  go to 30
               elseif (choice .eq. 'n') then
                  call finish (0)
               else
                  go to 35
                endif
            endif
         enddo
      endif
 

c*****exit the program
      call finish (0)


c*****format statements
1001  format (' This fit required ',i2,' iterations'/)
1002  format ('WARNING: NO ELEMENT LINE TO VARY IN BLEND')
1004  format ('SPECIES USES MOLECULAR EQUILIBRIUM!',
     .        '  REDO WITH NEW ABUNDANCE ([y]/n)? ')
1005  format (/'LINE ', i5, ':',
     .        ' weighted mean line contribution function C_d =',
     .        f6.2/ '  which occurs near level ', i3,
     .        ' with log tauref = ', f6.2)
1006  format (/'LINE ', i5, ':',
     .        '  tau(total) is greater than 1 at level',i3/
     .        '  logs of tauref, taulam, taunu =', 3f6.2)
1007  format (/'VARYING THIS ELEMENT: ', i8/
     .        'USING THE LINE GROUP IN THE RANGE: ', 2f10.3)
1008  format (' MAX OF 30 ITERATIONS REACHED; I QUIT!')


      end

      subroutine weedout                   
c******************************************************************************
c     This routine goes through an initial line list and culls from it
c     absorption lines that are not substantial contributors.  This is
c     done in a simple fashion by eliminating lines weaker than X, where
c     X = kapnu/kaplam at the approximate line wavelength, calculated
c     at a continuue optical depth of 0.5.  The user will be prompted for
c     the desired value of X.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      real*8 xratio
      real*4 shortnum


c*****examine the parameter file
      call params


c*****open the files for: standard output, lines to be kept, and lines
c     to be heaved out
      nf1out = 20     
      lscreen = 4
      array = 'STANDARD OUTPUT'
      nchars = 15
      call infile ('output ',nf1out,'formatted  ',0,nchars,
     .             f1out,lscreen)
      nf8out = 21               
      lscreen = lscreen + 2
      array = 'KEPT LINES'
      nchars = 10
      call infile ('output ',nf8out,'formatted  ',0,nchars,
     .             f8out,lscreen)
      nf9out = 22               
      lscreen = lscreen + 2
      array = 'DISCARDED LINES'
      nchars = 15
      call infile ('output ',nf9out,'formatted  ',0,nchars,
     .             f9out,lscreen)


c*****open and read the model atmosphere file
      nfmodel = 30
      lscreen = lscreen + 2
      array = 'THE MODEL ATMOSPHERE'
      nchars = 20
      call infile ('input  ',nfmodel,'formatted  ',0,nchars,
     .             fmodel,lscreen)
      call inmodel
      call eqlib


c*****open the initial line list file
      nflines = 31
      lscreen = lscreen + 2
      array = 'THE INITIAL LINE LIST'
      nchars = 21
      call infile ('input  ',nflines,'formatted  ',0,nchars,
     .              flines,lscreen)

c*****ask the user about the value of X
      lscreen = lscreen + 2
      array = 'GIVE THE MINIMUM LINE/CONTINUUM OPACITY RATIO TO KEEP: '
      nchars = 55
      call getnum (nchars,lscreen,xratio,shortnum)
      write (nf1out,1001) xratio
      write (nf8out,1002)
      write (nf9out,1003)
      

c*****compute the line opacities
      call inlines (3)
1     call nearly (1)


c*****calculate continuum quantities at the line list wavelength middle
      wave = (wave1(1)+wave1(nlines))/2.
      call opacit (2,wave)
      if (modprintopt .ge. 2) 
     .   write(nf1out,1006) wave,(kaplam(i),i=1,ntau)


c*****divide the lines into keepers and discards
      do j=1,nlines
         residual = 10.*atom1(j) - dble(nint(10.*(atom1(j))))
         if (strength(j)/kaplam(jtau5) .ge. xratio) then
            if (atom1(j) .lt. 100.) then
               if (residual .gt. 0. .and. dampnum(j) .gt. 0.) then
                  write (nf8out,1007) wave1(j), atom1(j), e(j,1), 
     .            dlog10(gf(j)), dlog10(dampnum(j)), dlog10(strength(j))
               else if (residual .gt. 0. .and. dampnum(j) .le. 0.) then
                  write (nf8out,1007) wave1(j), atom1(j), e(j,1), 
     .            dlog10(gf(j)), 0.0, dlog10(strength(j))
               else if (residual .le. 0. .and. dampnum(j) .gt. 0.) then
                  write (nf8out,1004) wave1(j), atom1(j), e(j,1),
     .            dlog10(gf(j)), dlog10(dampnum(j)), dlog10(strength(j))
               else 
                  write (nf8out,1004) wave1(j), atom1(j), e(j,1),
     .            dlog10(gf(j)), 0.0, dlog10(strength(j))
               endif
            else 
               if (residual .gt. 0.) then
                  write (nf8out, 1008) wave1(j), atom1(j), e(j,1),
     .            dlog10(gf(j)), d0(j), dlog10(strength(j))
               else
                  write (nf8out, 1005) wave1(j), atom1(j), e(j,1),
     .            dlog10(gf(j)), d0(j), dlog10(strength(j))
               endif
            endif
         else
            if (atom1(j) .lt. 100.) then
               if (residual .gt. 0. .and. dampnum(j) .gt. 0.) then
                  write (nf9out,1007) wave1(j), atom1(j), e(j,1),
     .            dlog10(gf(j)), dlog10(dampnum(j)), dlog10(strength(j))
               else if (residual .gt. 0. .and. dampnum(j) .le. 0.) then
                  write (nf9out,1007) wave1(j), atom1(j), e(j,1),
     .            dlog10(gf(j)), 0.0, dlog10(strength(j))
               else if (residual .le. 0. .and. dampnum(j) .gt. 0.) then
                  write (nf9out,1004) wave1(j), atom1(j), e(j,1),
     .            dlog10(gf(j)), dlog10(dampnum(j)), dlog10(strength(j))
               else
                  write (nf9out,1004) wave1(j), atom1(j), e(j,1),
     .            dlog10(gf(j)), 0.0, dlog10(strength(j))
               endif
            else
               if (residual .gt. 0.) then
                  write (nf9out, 1008) wave1(j), atom1(j), e(j,1),
     .                     dlog10(gf(j)), d0(j), dlog10(strength(j))
               else
                  write (nf9out, 1005) wave1(j), atom1(j), e(j,1),
     .                     dlog10(gf(j)), d0(j), dlog10(strength(j))
               endif
            endif
         endif
      enddo
      if (nlines +nstrong .eq. 2500) then
         call inlines (6)
         go to 1
      endif
         

c*****finish
      call finish (0)


c*****format statements
1001  format (/'DESIRED LINE-TO-CONTINUUM MINIMUM OPACITY RATIO: ', 
     .        1pe10.2)
1002  format ('THIS IS THE KEEPER LINE LIST')
1003  format ('THIS IS THE DISCARDED LINE LIST')
1004  format (f10.4, f10.1, f10.3, f10.3, f10.3, 20x, f9.1)
1005  format (f10.4, f10.1, f10.3, f10.3, 10x, f10.3, 10x, f9.1)
1006  format ('  kaplam from 1 to ntau at wavelength',f10.2/
     .        (6(1pd12.4)))
1007  format (f10.4, f10.4, f10.3, f10.3, f10.3, 20x, f9.1)
1008  format (f10.4, f10.5, f10.3, f10.3, 10x, f10.3, 10x, f9.1)


      end

      subroutine inmodel 
c******************************************************************************
c     This subroutine reads in the model 
c****************************************************************************** 

      implicit real*8 (a-h,o-z) 
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Quants.com'
      include 'Factor.com'
      include 'Dummy.com'
      include 'Pstuff.com'
      real*8 element(95), logepsilon(95)
      real*8 kaprefmass(100)
      real*8 bmol(110)
      integer nel(7)
      character list*80, list2*70
      integer append
      data (nel(i),i=1,7)/  1,  2,  6, 12, 13, 14, 26/


c*****Read in the key word to define the model type
      modelnum = modelnum + 1
      rewind nfmodel
      read (nfmodel,2001) modtype
      write (nf1out,1010) modtype
      if (modtype .eq. 'begn      ' .or.  modtype .eq. 'BEGN      ') 
     .   write (nf1out,1011)


c*****Read a comment line (usually describing the model)
      read (nfmodel,2002) moditle


c*****Read the number of depth points
      read (nfmodel,2002) list
      list2 = list(11:)
      read (list2,*) ntau
      if (ntau .gt. 100) then
         write (array,1012)
         call prinfo (10)
         stop
      endif


c*****EITHER: Read in a model from the output of the experimental new
c     MARCS code.  This modtype is called "NEWMARCS".  On each line 
c     the numbers are:
c     tau(5000), t, pe, pgas, rho,  model microtrubulent velocity,
c     and mean opacity (cm^2/gm) at the reference wavelength (5000A).
      if (modtype .eq. 'NEWMARCS  ') then
         read (nfmodel,*) wavref    
         do i=1,ntau
            read (nfmodel,*) tauref(i),t(i),ne(i),pgas(i),rho(i),
     .                         vturb(1),kaprefmass(i)
         enddo
c*****OR: Read in a model from the output of the on-line new
c     MARCS code.  This modtype is called "WEBMARCS".  On each line
c     the numbers are:
c     layer number (not needed), log{tau(Rosseland)} (not needed),
c     log{tau(5000)}, depth, t, pe, pgas, prad (not read in) and
c     pturb (not read in)
      elseif (modtype .eq. 'WEBMARCS') then
         read (nfmodel,*) wavref
         do i=1,ntau
            read (nfmodel,*) k, dummy1(k), tauref(i), dummy2(k), t(i),
     .                       ne(i), pgas(i)
         enddo
c*****OR: Read in a model from an alternative form of on-line new
c     MARCS code.  This modtype is called "WEB2MARC".  On each line
c     the numbers are:
c     atmospheric layer number (not needed), log{tau(5000)}, t, 
c     log(Pe), log(Pgas), rhox
      elseif (modtype .eq. 'WEB2MARC') then
         read (nfmodel,*) wavref
         do i=1,ntau
            read (nfmodel,*) k,tauref(i),t(i),ne(i),pgas(i),rhox(i)
         enddo
c     OR: Read in a model from the output of the ATLAS code.  This
c     modtype is called "KURUCZ".  On each line the numbers are:
c     rhox, t, pgas, ne, and Rosseland mean opacity (cm^2/gm), and
c     two numbers not used by MOOG.  
      elseif (modtype .eq. 'KURUCZ    ') then
         do i=1,ntau
            read (nfmodel,*) rhox(i),t(i),pgas(i),ne(i),kaprefmass(i)
         enddo
c     OR: Read in a model from the output of the NEXTGEN code.  This
c     modtype is called "NEXTGEN".  These models have tau scaled at a 
c     specific wavelength that is read in before the model. MOOG will 
c     need to generate the opacities internally.On each line the numbers 
c     are: tau, t, pgas, pe, density, mean molecular weight, two numbers
c     not used by MOOG, and Rosseland mean opacity (cm^2/gm).
      elseif (modtype .eq. 'NEXTGEN   ') then
         read (nfmodel,*) wavref
         do i=1,ntau
            read (nfmodel,*) tauref(i),t(i),pgas(i),ne(i), rho(i),  
     .                       molweight(i), x2, x3, kaprefmass(i)
         enddo
c     OR: Read in a model from the output of the MARCS code.  This modtype
c     type is called "BEGN".  On each line the numbers are:
c     tauross, t, log(pg), log(pe), mol weight, and kappaross.
      elseif (modtype .eq. 'BEGN      ') then
         do i=1,ntau
            read (nfmodel,*) tauref(i),t(i),pgas(i),ne(i),
     .                          molweight(i),  kaprefmass(i)
         enddo
c     OR: Read in a model generated from ATLAS, but without accompanying
c     opacities.  MOOG will need to generate the opacities internally,
c     using a reference wavelength that it reads in before the model.
      elseif (modtype .eq. 'KURTYPE') then
         read (nfmodel,*) wavref    
         do i=1,ntau
            read (nfmodel,*) rhox(i),t(i),pgas(i),ne(i)
         enddo
c     OR: Read in a model generated from ATLAS, with output generated
c     in Padova.  The columns are in somewhat different order than normal
      elseif (modtype .eq. 'KUR-PADOVA') then
         read (nfmodel,*) wavref
         do i=1,ntau
            read (nfmodel,*) tauref(i),t(i),kaprefmass(i),
     .                         ne(i),pgas(i),rho(i)
         enddo
c     OR: Read in a generic model that has a tau scale at a specific 
c     wavelength that is read in before the model.  
c     MOOG will need to generate the opacities internally.
      elseif (modtype .eq. 'GENERIC   ') then
         read (nfmodel,*) wavref    
         do i=1,ntau
            read (nfmodel,*) tauref(i),t(i),pgas(i),ne(i)
         enddo
c     OR: quit in utter confusion if those model types are not specified
      else
         write (*,1001)
         stop
      endif


c*****Compute other convenient forms of the temperatures
      do i=1,ntau
          theta(i) = 5040./t(i)
          tkev(i) = 8.6171d-5*t(i)
          tlog(i) = dlog(t(i))
      enddo


c*****Convert from logarithmic Pgas scales, if needed
      if (pgas(ntau)/pgas(1) .lt. 10.) then
         do i=1,ntau                                                    
            pgas(i) = 10.0**pgas(i)
         enddo
      endif


c*****Convert from logarithmic Ne scales, if needed
      if(ne(ntau)/ne(1) .lt. 20.) then
         do i=1,ntau                                                    
            ne(i) = 10.0**ne(i)
         enddo
      endif


c*****Convert from Pe to Ne, if needed
      if(ne(ntau) .lt. 1.0e7) then
         do i=1,ntau                                                    
            ne(i) = ne(i)/1.38054d-16/t(i)
         enddo
      endif


c*****compute the atomic partition functions
      do j=1,95
         elem(j) = dble(j)
         call partfn (elem(j),j)
      enddo


c*****Read the microturbulence (either a single value to apply to 
c     all layers, or a value for each of the ntau layers). 
c     Conversion to cm/sec from km/sec is done if needed
      read (nfmodel,2003) (vturb(i),i=1,6)
      if (vturb(2) .ne. 0.) then
         read (nfmodel,2003) (vturb(i),i=7,ntau) 
      else
         do i=2,ntau                                                    
            vturb(i) = vturb(1)
         enddo
      endif
      if (vturb(1) .lt. 100.) then
         write (moditle(55:62),1008) vturb(1)
         do i=1,ntau
            vturb(i) = 1.0e5*vturb(i)
         enddo
      else
         write (moditle(55:62),1008) vturb(1)/1.0e5
      endif


c*****Read in the abundance data, storing the original abundances in xabu
c*****The abundances not read in explicity are taken from the default
c*****solar ones contained in array xsolar.
      read (nfmodel,2002) list
      list2 = list(11:)
      read (list2,*) natoms,abscale
      write (moditle(63:73),1009) abscale
      if(natoms .ne. 0) 
     .         read (nfmodel,*) (element(i),logepsilon(i),i=1,natoms) 
      xhyd = 10.0**xsolar(1)
      xabund(1) = 1.0
      xabund(2) = 10.0**xsolar(2)/xhyd
      do i=3,95                                                      
         xabund(i) = 10.0**(xsolar(i)+abscale)/xhyd
         xabu(i) = xabund(i)
      enddo
      if (natoms .ne. 0) then
         do i=1,natoms                                                  
            xabund(idint(element(i))) = 10.0**logepsilon(i)/xhyd
            xabu(idint(element(i))) = 10.0**logepsilon(i)/xhyd
         enddo
      endif

c*****Compute the mean molecular weight, ignoring molecule formation
c     in this approximation (maybe make more general some day?)
      wtnum = 0.
      wtden = 0.
      do i=1,95
         wtnum = wtnum + xabund(i)*xam(i)
         wtden = wtden + xabund(i)
      enddo
      wtmol = wtnum/(xam(1)*wtden)
      nomolweight = 0
      if (modtype .eq. 'BEGN      ' .or. modtype .eq. 'NEXTGEN   ') then
         nomolweight = 1
      endif
      if (nomolweight .ne. 1) then
         do i=1,ntau
             molweight(i) = wtmol
         enddo
      endif

c*****Compute the density 
      if (modtype .ne. 'NEXTGEN   ') then
         do i=1,ntau                                                    
            rho(i) = pgas(i)*molweight(i)*1.6606d-24/(1.38054d-16*t(i))
         enddo
      endif


c*****Calculate the fictitious number density of hydrogen
c     Note:  ph = (-b1 + dsqrt(b1*b1 - 4.0*a1*c1))/(2.0*a1)
      iatom = 1
      call partfn (dble(iatom),iatom)
      do i=1,ntau    
         th = 5040.0/t(i)         
         ah2 = 10.0**(-(12.7422+(-5.1137+(0.1145-0.0091*th)*th)*th))
         a1 = (1.0+2.0*xabund(2))*ah2
         b1 = 1.0 + xabund(2)
         c1 = -pgas(i)         
         ph = (-b1/2.0/a1)+dsqrt((b1**2/(4.0*a1*a1))-(c1/a1))
         nhtot(i) = (ph+2.0*ph*ph*ah2)/(1.38054d-16*t(i))
      enddo


c*****Molecular equilibrium called here.
c     First, a default list of ions and molecules is considered. Then the 
c     user's list is read in. A check is performed to see if any of these 
c     species need to be added. If so, then they are appended to the 
c     default list. The molecular equilibrium routine is then called.
c     Certain species are important for continuous opacities and damping
c     calculations - these are read from the equilibrium solution and 
c     saved.


c*****Set up the default molecule list
      if (molset .eq. 0) then
         nmol = 30
      else
         nmol = 59
      endif
      if     (molset .eq. 0) then
         do i=1,110
            amol(i) = smallmollist(i)
         enddo
      elseif (molset .eq. 1) then
         do i=1,110
            amol(i) = largemollist(i)
         enddo
      else
         array = 'molset = 0 or 1 only; I quit!'
         call putasci (29,6)
         stop
      endif


c*****Read in the names of additional molecules to be used in 
c     molecular equilibrium if needed.
      read (nfmodel,2002,end=101) list
      list2 = list(11:)
      read (list2,*) moremol
      if (moremol .ne. 0) then
         read (nfmodel,*) (bmol(i),i=1,moremol)
         append = 1
         do k=1,moremol
            do l=1,nmol
               if (nint(bmol(k)) .eq. nint(amol(l))) 
     .         append = 0  
            enddo
            if (append .eq. 1) then 
               nmol = nmol + 1
               amol(nmol) = bmol(k)
            endif
            append = 1
         enddo  
      endif


c*****do the general molecular equilibrium
101   call eqlib


c*****SPECIAL NEEDS: for NEWMARCS models, to convert kaprefs to our units
      if (modtype .eq. 'NEWMARCS  ') then
         do i=1,ntau
            kapref(i) = kaprefmass(i)*rho(i)
         enddo
c     SPECIAL NEEDS: for KURUCZ models, to create the optical depth array,
c     and to convert kaprefs to our units
      elseif (modtype .eq. 'KURUCZ    ') then
         first = rhox(1)*kaprefmass(1)
         tottau = rinteg(rhox,kaprefmass,tauref,ntau,first) 
         tauref(1) = first
         do i=2,ntau
            tauref(i) = tauref(i-1) + tauref(i)
         enddo
         do i=1,ntau
            kapref(i) = kaprefmass(i)*rho(i)
         enddo
c     SPECIAL NEEDS: for NEXTGEN models, to convert kaprefs to our units
      elseif (modtype .eq. 'NEXTGEN   ') then
         do i=1,ntau                                                    
            kapref(i) = kaprefmass(i)*rho(i)
         enddo
c     SPECIAL NEEDS: for BEGN models, to convert kaprefs to our units
      elseif (modtype .eq. 'BEGN      ') then
         do i=1,ntau                                                    
            kapref(i) = kaprefmass(i)*rho(i)
         enddo
c     SPECIAL NEEDS: for KURTYPE models, to create internal kaprefs,
c     and to compute taurefs from the kaprefs converted to mass units
      elseif (modtype .eq. 'KURTYPE   ') then
         call opacit (1,wavref)
         do i=1,ntau                                                    
            kaprefmass(i) = kapref(i)/rho(i)
         enddo
         first = rhox(1)*kaprefmass(1)
         tottau = rinteg(rhox,kaprefmass,tauref,ntau,first) 
         tauref(1) = first
         do i=2,ntau
            tauref(i) = tauref(i-1) + tauref(i)
         enddo
c     SPECIAL NEEDS: for NEWMARCS models, to convert kaprefs to our units
      elseif (modtype .eq. 'KUR-PADOVA') then
         do i=1,ntau
            kapref(i) = kaprefmass(i)*rho(i)
         enddo
c     SPECIAL NEEDS: for generic models, to create internal kaprefs,
      elseif (modtype .eq. 'GENERIC   ' .or.
     .        modtype .eq. 'WEBMARCS  ' .or.
     .        modtype .eq. 'WEB2MARC  ') then
         call opacit (1,wavref)
      endif


c*****Convert from logarithmic optical depth scales, or vice versa.
c     xref will contain the log of the tauref
      if(tauref(1) .lt. 0.) then
         do i=1,ntau                                                    
            xref(i) = tauref(i)
            tauref(i) = 10.0**xref(i)
         enddo
      else
         do i=1,ntau                                                    
            xref(i) = dlog10(tauref(i))
         enddo
      endif


c*****Write information to output files
      if (modprintopt .lt. 1) return
      write (nf1out,1002) moditle
      do i=1,ntau
         dummy1(i) = dlog10(pgas(i))
         dummy2(i) = dlog10(ne(i)*1.38054d-16*t(i))
      enddo
      write (nf1out,1003) wavref,(i,xref(i),tauref(i),t(i),dummy1(i),
     .                    pgas(i),dummy2(i),ne(i),vturb(i),i=1,ntau)
      write (nf1out,1004)
      do i=1,95
         dummy1(i) = dlog10(xabund(i)) + 12.0
      enddo
      write (nf1out,1005) (names(i),i,dummy1(i),i=1,95)
      write (nf1out,1006) modprintopt, molopt, linprintopt, fluxintopt
      write (nf1out,1007) (kapref(i),i=1,ntau)
      return


c*****format statements
2001  format (a10)
2002  format (a80)
2003  format (6d13.0)
1001  format('permitted model types are:'/'KURUCZ, BEGN, ',
     .       'KURTYPE, KUR-PADOVA, NEWMARCS, WEBMARCS, NEXTGEN, ',
     .       'WEB2MARC, or GENERIC'/ 'MOOG quits!')
1002  format (/'MODEL ATMOSPHERE HEADER:'/a80/)
1003  format ('INPUT ATMOSPHERE QUANTITIES', 10x,
     .        '(reference wavelength =',f10.2,')'/3x, 'i', 2x, 'xref',
     .        3x, 'tauref', 7x, 'T', 6x, 'logPg', 4x, 'Pgas',
     .        6x, 'logPe', 5x, 'Ne', 9x, 'Vturb'/
     .        (i4, 0pf6.2, 1pd11.4, 0pf9.1, f8.3, 1pd11.4, 0pf8.3,
     .        1pd11.4, d11.2))
1004  format (/'INPUT ABUNDANCES: (log10 number densities, log H=12)'/
     .       '      Default solar abundances: Asplund et al. 2009')
1005  format (5(3x,a2, '(',i2,')=', f5.2))
1006  format (/'OPTIONS: atmosphere = ', i1, 5x, 'molecules  = ', i1/
     .        '         lines      = ', i1, 5x, 'flux/int   = ', i1)
1007  format (/'KAPREF ARRAY:'/(6(1pd12.4)))
1008  format ('vt=', f5.2)
1009  format (' M/H=', f5.2)
1010  format (13('-'),'MOOG OUTPUT FILE', 10('-'),
     .        '(MOOG version from 01/28/09)', 13('-')//
     .        'THE MODEL TYPE: ', a10)
1011  format ('   The Rosseland opacities and optical depths have ',
     .        'been read in')
1012  format ('HOUSTON, WE HAVE MORE THAN 100 DEPTH POINTS! I QUIT!')


      end

      subroutine getcount (num,linechars)
c***************************************************************************
c     this routine simply counts the number of characters in the
c     ascii array 'linechars' until the first blank is seen;
c     it is most useful for discovering the length of a file name.
c***************************************************************************

      character*80 linechars
      integer num


      do i=num,1,-1
         if (linechars(i:i) .ne. ' ') go to 11
      enddo
      num = -1
      return
11    num = i


      return
      end

      subroutine obshead (head,iend,line)
c******************************************************************************
c     this routine decodes the header records of the observed FITS
c     spectrum file
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Pstuff.com'
      include 'Obspars.com'
      include 'Atmos.com'
      character head*2880

      do j=1,36
         k = 80*(j-1)
         if     (head(k+1:k+8) .eq. 'SIMPLE  ') then
            if (head(k+30:k+30) .ne. 'T') then
               write(array,1029) head(k+1:k+58)
               istat = ivwrite (line+2,3,array,79)
               go to 1007
            endif
         elseif (head(k+1:k+8) .eq. 'BITPIX  ') then
               read (head(k+1:k+80),1025) ibits
               if (ibits .eq. 16) then
                  nblock = 1440
               elseif (ibits .eq. 32) then
                  nblock = 720
               elseif (ibits .eq. -32) then
                  nblock = 720
               else
                  write(array,1026) ibits
                  istat = ivwrite (line+2,3,array,32)
                  go to 1007
               endif
         elseif (head(k+1:k+8) .eq. 'NAXIS   ') then
               read (head(k+1:k+80),1025) naxis
               if (naxis .ne. 1) then
                  write(array,1028) head(k+1:k+58) 
                  go to 1007
               endif
         elseif (head(k+1:k+8) .eq. 'NAXIS1  ') then
               read (head(k+1:k+80),1025) lount
         elseif (head(k+1:k+8) .eq. 'OBJECT  ') then
               write (obsitle,1027) head(k+12:k+80)
         elseif (head(k+1:k+8) .eq. 'BZERO   ') then
               read (head(k+1:k+80),1024) bzero
         elseif (head(k+1:k+8) .eq. 'BSCALE  ') then
               read (head(k+1:k+80),1024) bscale
         elseif ((head(k+1:k+8) .eq. 'W0      ') .or. 
     .      (head(k+1:k+8) .eq. 'CRVAL1  ')) then
               read (head(k+1:k+80),1024) disp(1)
         elseif ((head(k+1:k+8) .eq. 'WPC     ') .or. 
     .      (head(k+1:k+8) .eq. 'CDELT1  ')) then
               read (head(k+1:k+80),1024) dval
               if (dval .ne. 1.) disp(2) = dval
         elseif (head(k+1:k+8) .eq. 'CD1_1    ') then
               read (head(k+1:k+80),1024) disp(2)
         elseif (head(k+1:k+8) .eq. 'FILENAME') then
               write (obsitle(39:80),1023) head(k+12:k+53)
         elseif (head(k+1:k+8) .eq. 'HISTORY ') then
               if (head(k+24:k+28) .eq. 'DISP=') then
                  read (head(k+1:k+80),1022) (disp(i),i=1,4)
               elseif (head(k+20:k+26) .eq. 'D1,2,3:') then
                  read (head(k+1:k+80),1042) (disp(i),i=1,3)
               elseif (head(k+20:k+26) .eq. 'D4,5,6:') then
                  read (head(k+1:k+80),1042) (disp(i),i=4,6)
               elseif (head(k+20:k+26) .eq. 'D7,8,9:') then
                  read (head(k+1:k+80),1042) (disp(i),i=7,9)
                  if (disp(7).ne.0.0 .and. disp(8).eq.0.0 .and.
     .                disp(9).eq.0.0) then
                     disp(8) = 1.0
                     disp(9) = lount
                  endif
               endif
            elseif (head(k+1:k+8) .eq. 'END     ') then
               iend = 1
               return
         endif
      enddo
      return
         

1007  lount = -1
      return


c*****format statements
1022  format(28x,1p4d13.5)
1023  format (a41)
1024  format (10x,d20.10)
1025  format (10x,i20)
1026  format('SORRY: I CANT HANDLE BITPIX=',i4)
1027  format (a68)
1028  format('ILLEGAL NAXIS ENTRY: ',a58)
1029  format('ILLEGAL FILE FORMAT: ',a58)
1042  format(26x,1p3d18.11)


      end

      subroutine number (nchar,line,xnum)
c******************************************************************************
c     this routine decodes a character string into a double precision
c     floating point number
c******************************************************************************
 
      include 'Pstuff.com'
      real*8 xnum
      character form*10

 
c*****if a carriage return has been hit, return with -9999.
      if (nchar .le. 0) then
         xnum = -9999.
         return
      endif


c*****set the conversion format
      if (nchar .lt. 10) then
         write(form,1001) nchar
      else
         write(form,1002) nchar
      endif

 
c*****now do the conversiton to a number
      read (unit=chinfo,fmt=form,iostat=ierr,err=100) xnum
      return

 
c*****here an error has been detected
100   write (errmess,1004) ierr,chinfo(1:nchar)
      nchars = 65
      istat = ivwrite (line,3,errmess,nchars)
      xnum = -9999.
      return      


c*****format statements
1001  format('(f',i1,'.0)    ')
1002  format('(f',i2,'.0)   ')
1004  format ('ERROR IN NUMBER INPUT: ERROR=',i4,5x,'NUMBER=',a20) 


      end

 
      subroutine pltflux
c******************************************************************************
c     This subroutine controls the decisions that are made around the
c     plots of flux curves
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'


c  call up the flux plot
      if (plotopt .eq. 0) return
10    choice = 'y'
      plotroutine = 'term_land_flux'
      lscreen = 12
c      call makeplot (lscreen)


c  make a hardcopy, write to a postscript file, or replot?
      array = 'WHAT TO DO NEXT ([n]/h/f/r)? '
      lscreen = 12
      nchars = 33
      call getasci (nchars,lscreen)
      choice = chinfo(1:1)
      if (choice.eq.'n' .or. nchars.le.0) then
         return
      elseif (choice .eq. 'h') then
         plotroutine = 'hard_land_flux'
c         call makeplot (lscreen)
      elseif (choice .eq. 'r') then
         go to 10
      elseif (choice .eq. 'f') then
         plotroutine = 'file_land_flux'
c         call makeplot (lscreen)
      endif

      return
      end

      subroutine gridplo
c******************************************************************************
c     This routine plots a spectrum that already has been synthesized
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Pstuff.com'


c*****examine the parameter file
1      call params


c*****open the files for: raw spectrum depths (as input), smoothed
c     spectra (output), and (if desired) IRAF-style smoothed spectra (output)
      nf2out = 21
      lscreen = 4
      array = 'RAW SYNTHESES INPUT'
      nchars = 19
      call infile ('input  ',nf2out,'formatted  ',0,nchars,
     .             f2out,lscreen)
      if (plotopt .ne. 0) then
         nf3out = 22
         lscreen = lscreen + 2
         array = 'SMOOTHED SYNTHESES OUTPUT'
         nchars = 25
         call infile ('output ',nf3out,'formatted  ',0,nchars,
     .                f3out,lscreen)
         nf5out = 26
         lscreen = lscreen + 2
         array = 'POSTSCRIPT PLOT OUTPUT'
         nchars = 22
         call infile ('output ',nf5out,'formatted  ',0,nchars,
     .                f5out,lscreen)
      endif
      if (plotopt .gt. 1) then
         nf6out = 27
         lscreen = lscreen + 2
         array = 'SPECTRUM COMPARISON OUTPUT'
         nchars = 27
         call infile ('output ',nf6out,'formatted  ',0,nchars,
     .                f6out,lscreen)
      endif
      if (iraf .ne. 0) then
         nf4out = 23
         lscreen = lscreen + 2
         array = 'IRAF ("rtext") OUTPUT'
         nchars = 24
         call infile ('output ',nf4out,'formatted  ',0,nchars,
     .                f4out,lscreen)
      endif


c*****now plot the spectrum
      if (plotopt.eq.2 .and. specfileopt.gt.0) then
         nfobs = 33               
         lscreen = lscreen + 2
         array = 'THE OBSERVED SPECTRUM'
         nchars = 21
         if     (specfileopt.eq.1 .or. specfileopt.eq.3) then
            call infile ('input  ',nfobs,'unformatted',2880,nchars,
     .                   fobs,lscreen)
         else
            call infile ('input  ',nfobs,'formatted  ',0,nchars,
     .                   fobs,lscreen)
         endif
      endif
      if (plotopt .ne. 0) then
         line = 10
         ncall = 1
         call pltspec (line,ncall)
      endif


c*****finish
      if (control .ne. 'gridend') then
         call finish (1)
         go to 1
      else
         call finish (0)
      endif
      return


      end   

      subroutine invert(order,a,i,nsiz)                                 
c******************************************************************************
c     This routine inverts an *order,order* matrix *a*. answer is *i*       
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      integer order, orde
      real*8 a(nsiz,nsiz), i(nsiz,nsiz)


      do n=1,order                                                   
         do m=1,order                                                   
            i(m,n) = 0.0
         enddo
      enddo
      do j=1,order                                                   
         i(j,j) = 1.0
      enddo
      orde=order-1                                                      
      do k=1,orde
         kk = k+1
         do j=kk,order
            i(j,k) = 0.0
            i(k,j) = 0.0
         enddo
      enddo

c  here begins the inversion                                             
      do n=1,order                                                   
         if (n .eq. order) go to 244
         g = a(n,n)
         n1 = n+1
         ng = n
         do m=n1,order                                                  
            f = a(m,n)
            if (f .gt. g) then
               g = f
               ng = m
            endif
         enddo
         if (ng .eq. n) go to 244
         do k=1,order
            d = i(n,k)
            e = i(ng,k)
            f = a(n,k)
            g = a(ng,k)
            i(ng,k) = d
            i(n,k) = e 
            a(ng,k) = f
            a(n,k) = g
         enddo
244      g = a(n,n)
         if (g .eq. 0.0) then
            write (nf1out,1001)     
            return
         endif
         do k=1,order
            a(n,k) = a(n,k)/g
            i(n,k) = i(n,k)/g
         enddo
         if (n .eq. order) go to 27
         do k=n1,order
            f = -a(k,n)
            do j=1,order
               a(k,j) = a(k,j) + f*a(n,j)
               i(k,j) = i(k,j)+f*i(n,j)
            enddo
         enddo
      enddo

27    do jk=1,orde                                                   
         n = order - jk + 1
         do j=jk,orde
            m = order - j
            f = -a(m,n)
            do k=1,order
            a(m,k) = a(m,k) + f*a(n,k)
            i(m,k) = i(m,k) + f*i(n,k)
            enddo
         enddo
      enddo
      return


c*****format statements
1001  format('WARNING: AN UN-INVERTABLE ARRAY HAS BEEN ENCOUNTERED!')

      end                                                               

#!/bin/bash

# Bash program to modify the USER SETUP AREA of Moog.f and Moogsilent.f.

#!/bin/bash

# Bash program to modify the USER SETUP AREA of Moog.f and Moogsilent.f.

# Change the moogpath from '/Users/chris/CODES/moogfeb2017/' to `pwd` or user specified path 
# Note that the code will break the path to multiple lines if it is longer than 60.

path=`pwd`'/'
replacement_string="     .  '${path}'"

sed -i "22s#.*#$replacement_string#" Moog.f
sed -i "22s#.*#$replacement_string#" Moogsilent.f

# Change the machine to user specified type.
machine='None'
while [ $machine == 'None' ]
do
	machine=`uname`
	if [[ -z "$machine" ]] || [ $machine == 'Linux' ] 
	then
		machine='pcl'
		break
	elif [ $machine == 'Darwin' ]
	then
		machine='mac'
		break
	else 
		machine='pcl'
	fi
done

sed -i "29s/'.*'/'$machine'/" Moog.f
sed -i "29s/'.*'/'$machine'/" Moogsilent.f

# Install MOOG and MOOGSILENT

if [ $machine == 'pcl' ]
then
	make -f Makefile.rh64 
	make -f Makefile.rh64silent 
elif [ $machine == 'mac' ]
then
	make -f Makefile.maclap 
	make -f Makefile.maclapsilent 
fi

#!/bin/bash

# Bash program to modify the USER SETUP AREA of Moog.f and Moogsilent.f.

# Change the moogpath from '/Users/chris/CODES/moogfeb2017/' to `pwd` or user specified path 

path=`pwd`'/'
sed "22s?'.*'?'$path'?" Moog_bak.f > Moog.f
sed "22s?'.*'?'$path'?" Moogsilent_bak.f > Moogsilent.f

sed -i "_old" "29s/'.*'/'$machine'/" Moog.f
sed -i "_old" "29s/'.*'/'$machine'/" Moogsilent.f

# Install MOOG and MOOGSILENT
make -f Makefile.rh64 
make -f Makefile.rh64silent
